SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;


DROP TABLE IF EXISTS `DBPREFIXlanguages`;
CREATE TABLE `DBPREFIXlanguages` (
  `langid` int(11) NOT NULL,
  `englishname` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `nativename` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `langcode` varchar(10) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'In this format: https://bit.ly/3mSII8u',
  `isdefault` tinyint(1) NOT NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `DBPREFIXlanguages` (`langid`, `englishname`, `nativename`, `langcode`, `isdefault`) VALUES
(1, 'English', 'English', 'en', 1),
(2, 'English (US)', 'English (US)', 'en-us', 0),
(3, 'Polish', 'Polski', 'pl', 0),
(4, 'German', 'Deutsch', 'de', 0),
(5, 'Bulgarian', 'български', 'bg', 0),
(6, 'Spanish', 'Español', 'es', 0),
(7, 'Russian', 'Русский', 'ru', 0),
(8, 'Dutch', 'Nederlands', 'nl', 0),
(9, 'Czech', 'Čeština', 'cs', 0),
(10, 'Hungarian', 'Magyar', 'hu', 0),
(11, 'Belarusian', 'Беларуская', 'be', 0),
(12, 'Bosnian', 'Босански', 'bs', 0),
(13, 'Portuguese', 'Português', 'pt', 0),
(14, 'Greek', 'Ελληνικά', 'el', 0),
(15, 'Danish', 'Dansk', 'da', 0),
(16, 'French', 'Français', 'fr', 0),
(17, 'Turkish', 'Türkçe', 'tr', 0),
(18, 'Italian', 'Italiano', 'it', 0),
(19, 'Ukrainian', 'Українська', 'uk', 0),
(20, 'Chinese', '简体中文', 'zh-cn', 0);

DROP TABLE IF EXISTS `DBPREFIXtranslations`;
CREATE TABLE `DBPREFIXtranslations` (
  `id` int(10) NOT NULL,
  `langid` int(10) NOT NULL,
  `identifier` varchar(128) COLLATE utf8mb4_unicode_ci NOT NULL,
  `value` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `comment` text COLLATE utf8mb4_unicode_ci DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `DBPREFIXtranslations` (`id`, `langid`, `identifier`, `value`, `comment`) VALUES
(1, 1, 'AUTHORS', 'Wruczek <wruczekk@gmail.com>', 'Language authors'),
(3, 1, 'COOKIEALERT_MESSAGE', '<b>Do you like cookies?</b> &#x1F36A; We use cookies to ensure you get the best experience on our website. <a href=\"http://cookiesandyou.com/\" target=\"_blank\">Learn more</a>', 'Remember to change link to a website in your language'),
(5, 1, 'COOKIEALERT_AGREE', 'I agree', NULL),
(7, 1, 'OUTDATED_DATA', '<b>Warning!</b> Some information cannot be obtained now. Showing outdated data from {0}.', '{0} will be replaced with fuzzy date (for example \"8 hours ago\"). Please try to match the your message grammatically'),
(9, 1, 'SHOW_PROBLEMS', 'Show problems', NULL),
(11, 1, 'PROBLEMS_DESCRIPTION', 'Problems encountered while connecting to the TeamSpeak server', NULL),
(13, 1, 'NO_JAVASCRIPT_ENABLED', 'This website will not work without <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript enabled</a>.', 'Remember to change the website address to include instructions in your language'),
(15, 1, 'CANNOT_GET_DATA', 'Cannot get data for \"{0}\"! Please contact website owner.', '{0} will be replaced with component name that cannot be refreshed (for example banlist or viewer)'),
(17, 1, 'NO_REASON_SET', '<b>(no reason set)</b>', 'Please keep the \"<b>\" tags in place, as they help to distinguish a placeholder form a real message'),
(19, 1, 'BANS_HEADER_TARGET', 'Ban', NULL),
(21, 1, 'BANS_HEADER_REASON', 'Reason', NULL),
(23, 1, 'BANS_HEADER_INVOKER', 'Banned by', NULL),
(25, 1, 'BANS_HEADER_BANDATE', 'Ban date', NULL),
(27, 1, 'BANS_HEADER_EXPIRES', 'Expires', NULL),
(29, 1, 'DATATABLES_LANGUAGE_NAME', 'English', 'This language will be used to load language file for DataTables. Please choose a language from this list: https://datatables.net/plug-ins/i18n/#Translations.\r\n\r\nIf chosen correctly, this url: \"//cdn.datatables.net/plug-ins/1.10.12/i18n/{NAME}.json\" should return a valid JSON object with translations. For example: \"//cdn.datatables.net/plug-ins/1.10.12/i18n/English.json\"'),
(31, 1, 'BANS_NEVEREXPIRES', 'Never', NULL),
(33, 1, 'STATUS_ADDRESS', 'Address:', ''),
(35, 1, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(37, 1, 'STATUS_RESERVED_SLOTS', '{0} reserved slots', NULL),
(39, 1, 'STATUS_TOP_ONLINE', 'Most online:', NULL),
(41, 1, 'STATUS_TOP_ONLINE_DESC', 'Achieved on {0}', NULL),
(43, 1, 'STATUS_UPTIME', 'Uptime:', NULL),
(45, 1, 'STATUS_VERSION', 'Version:', NULL),
(47, 1, 'STATUS_VERSION_DESC', '{0} on {1}', NULL),
(49, 1, 'STATUS_PING', 'Avg. ping:', NULL),
(51, 1, 'STATUS_PACKETLOSS', 'Avg. packet loss:', NULL),
(53, 1, 'STATUS_ERROR', 'Cannot retrieve server status', NULL),
(55, 1, 'STATUS_PANEL_TITLE', 'Server status', NULL),
(57, 1, 'DAYJS_LANG', 'en-gb', 'Language for day.js, full list: https://github.com/iamkun/dayjs/tree/dev/src/locale'),
(58, 2, 'DAYJS_LANG', 'en', NULL),
(60, 1, 'LOGIN_CONFIRMATION_CODE', 'Hi, here\'s your confirmation code to login: [b]{0}[/b]', 'You can use BBCode. Use {0} for the confirmation code.'),
(62, 1, 'UNSUPPORTED_BROWSER', 'Your browser is not supported. Please switch to the latest version of Chrome, Firefox, Safari or Edge to use this website.', ''),
(64, 1, 'DATATABLES_PLACEHOLDER_SEARCH', 'Search...', NULL),
(66, 1, 'WEBSITE_TITLE', ' | TS-website English Language', NULL),
(68, 1, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(70, 1, 'ADMIN_STATUS_AWAY', 'Away', NULL),
(72, 1, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(76, 1, 'ADMIN_STATUS_EMPTY_GROUP', 'Nothing to show', NULL),
(78, 1, 'ADMIN_STATUS_EMPTY_STATUS', 'Admin status is empty', NULL),
(80, 1, 'ASSIGNER_PANEL_TITLE', 'Group assigner', NULL),
(82, 1, 'ASSIGNER_TITLE', 'Group assigner', NULL),
(84, 1, 'BANS_EMPTY', 'Banlist is empty', NULL),
(86, 1, 'BANS_TITLE', 'Banlist', NULL),
(88, 1, 'BANS_PANEL_TITLE', 'Banlist', NULL),
(90, 1, 'BANS_BANNED_ALERT_TITLE', 'Your IP has been banned by {0}', NULL),
(92, 1, 'BANS_BANNED_ALERT_REASON', 'Reason: {0}', NULL),
(94, 1, 'BANS_VIEW_MORE_TIP', 'Click on a row to view more details about a ban', NULL),
(96, 1, 'RULES_TITLE', 'Rules', NULL),
(98, 1, 'RULES_PANEL_TITLE', 'Rules', NULL),
(100, 1, 'FAQ_COPY_LINK', 'Copy link to that answer', NULL),
(102, 1, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(104, 1, 'FAQ_TITLE', 'FAQ', NULL),
(106, 1, 'FAQ_COPY_LINK_SUCCESS', 'Copied!', NULL),
(108, 1, 'FAQ_COPY_LINK_ERROR', 'Error!', NULL),
(110, 1, 'HOME_TITLE', 'News', NULL),
(112, 1, 'HOME_PANEL_TITLE', 'News', NULL),
(114, 1, 'HOME_EMPTY', 'No news available at this moment', NULL),
(116, 1, 'HOME_INVALID_PAGE', 'Invalid page number', NULL),
(118, 1, 'HOME_PREVIOUS_NEWS', 'Previous', 'This value is only used by assistive technologies (screen readers ect.)'),
(120, 1, 'HOME_NEXT_NEWS', 'Next', 'This value is only used by assistive technologies (screen readers ect.)'),
(122, 1, 'ADMIN_STATUS_PANEL_TITLE', 'Admin status', NULL),
(124, 1, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Hide offline admins', NULL),
(126, 1, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Show offline admins', NULL),
(128, 1, 'ADMIN_STATUS_ERROR', 'Admin status error', NULL),
(130, 1, 'NAV_TOGGLE', 'Toggle navigation', 'This value is only used by assistive technologies (screen readers ect.)'),
(132, 1, 'NAV_VIEWER', 'Viewer', NULL),
(134, 1, 'NAV_ASSIGNER', 'Assigner', NULL),
(136, 1, 'NAV_BANS', 'Bans', NULL),
(138, 1, 'NAV_RULES', 'Rules', NULL),
(140, 1, 'NAV_FAQ', 'FAQ', NULL),
(142, 1, 'NAV_ACCOUNT_LOGIN', 'Login', NULL),
(144, 1, 'NAV_ACCOUNT_LOGOUT', 'Logout', NULL),
(146, 1, 'VIEWER_TITLE', 'Server viewer', NULL),
(148, 1, 'VIEWER_PANEL_TITLE', 'Server viewer', NULL),
(150, 1, 'VIEWER_SHOW_EMPTY', 'Show empty channels', NULL),
(152, 1, 'VIEWER_HIDE_EMPTY', 'Hide empty channels', NULL),
(154, 1, 'VIEWER_TIP_ALERT', 'Click on a channel to join it. Hover over a user to check their info', NULL),
(158, 1, 'ARIA_CLOSE', 'Close', 'This value is only used by assistive technologies (screen readers ect.)'),
(160, 1, 'VIEWER_ERROR', 'Viewer error', NULL),
(162, 1, 'VIEWER_CONNECTION_CONFIRMATION', 'Do you want to connect to this channel?', NULL),
(164, 1, 'VIEWER_CLIENT_LASTACTIVE', 'Last active:', NULL),
(166, 1, 'VIEWER_CLIENT_ONLINE', 'Online time:', NULL),
(168, 1, 'VIEWER_CLIENT_JOINED', 'First joined:', NULL),
(170, 1, 'VIEWER_CLIENT_TITLE', 'Client info', NULL),
(172, 1, 'VIEWER_SERVER_ICON', 'Server icon', NULL),
(174, 1, 'VIEWER_DEFAULT_CHANNEL', 'Default channel', NULL),
(176, 1, 'VIEWER_CHANNEL_UNSUB1', ', unsubscribed', 'Please note that this string starts with \", \"'),
(178, 1, 'VIEWER_CHANNEL_OCCUPIED', 'Fully occupied', NULL),
(180, 1, 'VIEWER_CHANNEL_PASSWORD', 'Password-protected', NULL),
(182, 1, 'VIEWER_CHANNEL_UNSUB2', 'Unsubscribed', NULL),
(184, 1, 'VIEWER_CHANNEL_ICON', 'Channel icon', NULL),
(186, 1, 'VIEWER_CHANNEL_MODERATED', 'Moderated', NULL),
(188, 1, 'VIEWER_CHANNEL_MUSIC_CODED', 'Music codec', NULL),
(190, 1, 'VIEWER_CLIENT_AWAY', 'Away', NULL),
(194, 1, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Sound disabled', NULL),
(196, 1, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Deafened', NULL),
(198, 1, 'VIEWER_CLIENT_MIC_DISABLED', 'Microphone disabled', NULL),
(200, 1, 'VIEWER_CLIENT_MIC_MUTED', 'Muted', NULL),
(202, 1, 'VIEWER_CLIENT_COMMANDER', 'Channel commander', NULL),
(204, 1, 'VIEWER_CLIENT_ICON', 'Client icon', NULL),
(206, 1, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Priority speaker', NULL),
(208, 1, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Talk power granted', NULL),
(210, 1, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Insufficient talk power', NULL),
(212, 1, 'ASSIGNER_NOT_LOGGED_IN', 'Log in before using group assigner', NULL),
(214, 1, 'ASSIGNER_LOGIN_BUTTON', 'Login', NULL),
(216, 1, 'ASSIGNER_SAVE_BUTTON', 'Save', NULL),
(218, 1, 'ASSIGNER_INVALID_GROUPS', 'Invalid group settings', NULL),
(220, 1, 'ASSIGNER_NOT_CONFIGURED', 'Group assigner is not configured by the website administrator', NULL),
(222, 1, 'ASSIGNER_SAVE_SUCCESS', 'Your groups have been updated', NULL),
(224, 1, 'ASSIGNER_SAVE_ERROR', 'Group change error', NULL),
(226, 1, 'ASSIGNER_SAVE_NO_CHANGE', 'No changes has been made', NULL),
(227, 1, 'ASSIGNER_NO_REQUIRED_GROUPS', 'You don\'t have any of the required groups. You cannot use the group assigner.', NULL),
(3311, 1, 'DATE_FORMAT', 'd.m.Y', 'Format: https://secure.php.net/manual/en/function.date.php#refsect1-function.date-parameters'),
(3312, 1, 'TIME_FORMAT', 'H:i', 'Format: https://secure.php.net/manual/en/function.date.php#refsect1-function.date-parameters'),
(3313, 2, 'DATE_FORMAT', 'm.d.Y', NULL),
(3314, 2, 'TIME_FORMAT', 'g:i A', NULL),
(16042, 3, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Nie masz żadnej z wymaganych grup. Nie możesz użyć przydzielania grup.', NULL),
(16043, 3, 'DATE_FORMAT', 'd.m.Y', NULL),
(16044, 3, 'TIME_FORMAT', 'H:i', NULL),
(16045, 3, 'BANS_HEADER_TARGET', 'Ban', NULL),
(16046, 3, 'AUTHORS', 'Wruczek <wruczekk@gmail.com>', NULL),
(16047, 3, 'COOKIEALERT_MESSAGE', '<b>Lubisz ciasteczka?</b> &#x1F36A; Używamy ciasteczek, aby zapewnić najwyższą jakość usług. <a href=\"https://support.mozilla.org/pl/kb/ciasteczka\" target=\"_blank\">Dowiedz się więcej</a>', NULL),
(16048, 3, 'COOKIEALERT_AGREE', 'Zgadzam się', NULL),
(16049, 3, 'OUTDATED_DATA', '<b>Uwaga!</b> Niektóre dane nie mogą być teraz uzyskane. Pokazuje nieaktualne dane z {0}.', NULL),
(16050, 3, 'SHOW_PROBLEMS', 'Pokaż problemy', NULL),
(16051, 3, 'PROBLEMS_DESCRIPTION', 'Problemy napotkane podczas próby połączenia się z serwerem TeamSpeak', NULL),
(16052, 3, 'NO_JAVASCRIPT_ENABLED', 'Ta strona nie będzie działać bez <a href=\"https://www.enable-javascript.com/pl/\" target=\"_blank\">włączonej obsługi JavaScript</a>.', NULL),
(16053, 3, 'CANNOT_GET_DATA', 'Nie mogę pobrać informacji o \"{0}\"! Skontaktuj się z właścicielem strony.', NULL),
(16054, 3, 'NO_REASON_SET', '<b>(brak powodu)</b>', NULL),
(16055, 3, 'BANS_HEADER_REASON', 'Powód', NULL),
(16056, 3, 'BANS_HEADER_INVOKER', 'Zbanowany przez', NULL),
(16057, 3, 'BANS_HEADER_BANDATE', 'Data zbanowania', NULL),
(16058, 3, 'BANS_HEADER_EXPIRES', 'Wygasa', NULL),
(16059, 3, 'DATATABLES_LANGUAGE_NAME', 'Polish', NULL),
(16060, 3, 'BANS_NEVEREXPIRES', 'Nigdy', NULL),
(16061, 3, 'STATUS_ADDRESS', 'Adres:', NULL),
(16062, 3, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(16063, 3, 'STATUS_RESERVED_SLOTS', '{0} zarezerwowanych slotów', NULL),
(16064, 3, 'STATUS_TOP_ONLINE', 'Rekord online:', NULL),
(16065, 3, 'STATUS_TOP_ONLINE_DESC', 'Ustanowiono {0}', NULL),
(16066, 3, 'STATUS_UPTIME', 'Uptime:', NULL),
(16067, 3, 'STATUS_VERSION', 'Wersja:', NULL),
(16068, 3, 'STATUS_VERSION_DESC', '{0} na {1}', NULL),
(16069, 3, 'STATUS_PING', 'Śr. ping:', NULL),
(16070, 3, 'STATUS_PACKETLOSS', 'Śr. utrata pakietów:', NULL),
(16071, 3, 'STATUS_ERROR', 'Błąd podczas wczytywania statusu serwera', NULL),
(16072, 3, 'STATUS_PANEL_TITLE', 'Status serwera', NULL),
(16073, 3, 'DAYJS_LANG', 'pl', NULL),
(16074, 3, 'LOGIN_CONFIRMATION_CODE', 'Cześć, oto twój kod potwierdzający logowanie: [b]{0}[/b]', NULL),
(16075, 3, 'UNSUPPORTED_BROWSER', 'Twoja przeglądarka nie jest wspierana. Zainstaluj najnowszą wersję Chrome, Firefox, Safari lub Edge by korzystać z tej strony.', NULL),
(16076, 3, 'DATATABLES_PLACEHOLDER_SEARCH', 'Szukaj...', NULL),
(16077, 3, 'WEBSITE_TITLE', ' | TS-website Język Polski', NULL),
(16078, 3, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(16079, 3, 'ADMIN_STATUS_AWAY', 'Zaraz wracam', NULL),
(16080, 3, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(16081, 3, 'ADMIN_STATUS_EMPTY_GROUP', 'Nic do pokazania', NULL),
(16082, 3, 'ADMIN_STATUS_EMPTY_STATUS', 'Status administracji jest pusty', NULL),
(16083, 3, 'ASSIGNER_PANEL_TITLE', 'Przydzielanie grup', NULL),
(16084, 3, 'ASSIGNER_TITLE', 'Przydzielanie grup', NULL),
(16085, 3, 'BANS_EMPTY', 'Lista banów jest pusta', NULL),
(16086, 3, 'BANS_TITLE', 'Lista banów', NULL),
(16087, 3, 'BANS_PANEL_TITLE', 'Lista banów', NULL),
(16088, 3, 'BANS_BANNED_ALERT_TITLE', 'Twoje IP zostało zbanowane przez {0}', NULL),
(16089, 3, 'BANS_BANNED_ALERT_REASON', 'Powód: {0}', NULL),
(16090, 3, 'BANS_VIEW_MORE_TIP', 'Kliknij na wiersz by pokazać więcej informacji o banie', NULL),
(16091, 3, 'RULES_TITLE', 'Regulamin', NULL),
(16092, 3, 'RULES_PANEL_TITLE', 'Regulamin', NULL),
(16093, 3, 'FAQ_COPY_LINK', 'Kopiuj link do tej odpowiedzi', NULL),
(16094, 3, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16095, 3, 'FAQ_TITLE', 'FAQ', NULL),
(16096, 3, 'FAQ_COPY_LINK_SUCCESS', 'Skopiowano!', NULL),
(16097, 3, 'FAQ_COPY_LINK_ERROR', 'Błąd!', NULL),
(16098, 3, 'HOME_TITLE', 'Aktualności', NULL),
(16099, 3, 'HOME_PANEL_TITLE', 'Aktualności', NULL),
(16100, 3, 'HOME_EMPTY', 'Brak aktualności', NULL),
(16101, 3, 'HOME_INVALID_PAGE', 'Zły numer strony', NULL),
(16102, 3, 'HOME_PREVIOUS_NEWS', 'Poprzednia', NULL),
(16103, 3, 'HOME_NEXT_NEWS', 'Następna', NULL),
(16104, 3, 'ADMIN_STATUS_PANEL_TITLE', 'Status administracji', NULL),
(16105, 3, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Ukryj administratorów offline', NULL),
(16106, 3, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Pokaż administratorów offline', NULL),
(16107, 3, 'ADMIN_STATUS_ERROR', 'Błąd statusu administracji', NULL),
(16108, 3, 'NAV_TOGGLE', 'Przełącz nawigację', NULL),
(16109, 3, 'NAV_VIEWER', 'Podgląd', NULL),
(16110, 3, 'NAV_ASSIGNER', 'Grupy', NULL),
(16111, 3, 'NAV_BANS', 'Bany', NULL),
(16112, 3, 'NAV_RULES', 'Regulamin', NULL),
(16113, 3, 'NAV_FAQ', 'FAQ', NULL),
(16114, 3, 'NAV_ACCOUNT_LOGIN', 'Zaloguj się', NULL),
(16115, 3, 'NAV_ACCOUNT_LOGOUT', 'Wyloguj się', NULL),
(16116, 3, 'VIEWER_TITLE', 'Podgląd serwera', NULL),
(16117, 3, 'VIEWER_PANEL_TITLE', 'Podgląd serwera', NULL),
(16118, 3, 'VIEWER_SHOW_EMPTY', 'Pokaż puste kanały', NULL),
(16119, 3, 'VIEWER_HIDE_EMPTY', 'Ukryj puste kanały', NULL),
(16120, 3, 'VIEWER_TIP_ALERT', 'Kliknij na kanał, by na niego dołączyć. Nakieruj na użytkownika, by sprawdzić informacje o nim', NULL),
(16121, 3, 'ARIA_CLOSE', 'Zamknij', NULL),
(16122, 3, 'VIEWER_ERROR', 'Błąd podglądu', NULL),
(16123, 3, 'VIEWER_CONNECTION_CONFIRMATION', 'Czy chcesz dołączyć na ten kanał?', NULL),
(16124, 3, 'VIEWER_CLIENT_LASTACTIVE', 'Aktywny:', NULL),
(16125, 3, 'VIEWER_CLIENT_ONLINE', 'Online przez:', NULL),
(16126, 3, 'VIEWER_CLIENT_JOINED', 'Dołączył:', NULL),
(16127, 3, 'VIEWER_CLIENT_TITLE', 'Informacje o kliencie', NULL),
(16128, 3, 'VIEWER_SERVER_ICON', 'Ikona serwera', NULL),
(16129, 3, 'VIEWER_DEFAULT_CHANNEL', 'Kanał domyślny', NULL),
(16130, 3, 'VIEWER_CHANNEL_UNSUB1', ', odsubskrybowany', NULL),
(16131, 3, 'VIEWER_CHANNEL_OCCUPIED', 'Zajęty', NULL),
(16132, 3, 'VIEWER_CHANNEL_PASSWORD', 'Zabezpieczony hasłem', NULL),
(16133, 3, 'VIEWER_CHANNEL_UNSUB2', 'Odsubskrybowany', NULL),
(16134, 3, 'VIEWER_CHANNEL_ICON', 'Ikona kanału', NULL),
(16135, 3, 'VIEWER_CHANNEL_MODERATED', 'Moderowany', NULL),
(16136, 3, 'VIEWER_CHANNEL_MUSIC_CODED', 'Kodek muzyczny', NULL),
(16137, 3, 'VIEWER_CLIENT_AWAY', 'Zaraz wracam', NULL),
(16138, 3, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Głos wyłączony', NULL),
(16139, 3, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Głos wyciszony', NULL),
(16140, 3, 'VIEWER_CLIENT_MIC_DISABLED', 'Mikrofon wyłączony', NULL),
(16141, 3, 'VIEWER_CLIENT_MIC_MUTED', 'Mikrofon wyciszony', NULL),
(16142, 3, 'VIEWER_CLIENT_COMMANDER', 'Dowódca kanału', NULL),
(16143, 3, 'VIEWER_CLIENT_ICON', 'Ikona klienta', NULL),
(16144, 3, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Mówca priorytetowy', NULL),
(16145, 3, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Moc konwersacji przyznana', NULL),
(16146, 3, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Niewystarczająca moc konwersacji', NULL),
(16147, 3, 'ASSIGNER_NOT_LOGGED_IN', 'Zaloguj się przed przydzielaniem grup', NULL),
(16148, 3, 'ASSIGNER_LOGIN_BUTTON', 'Zaloguj się', NULL),
(16149, 3, 'ASSIGNER_SAVE_BUTTON', 'Zapisz', NULL),
(16150, 3, 'ASSIGNER_INVALID_GROUPS', 'Nieprawidłowe ustawienia grup', NULL),
(16151, 3, 'ASSIGNER_NOT_CONFIGURED', 'Przydzielanie grup nie jest skonfigurowane przez administratora strony', NULL),
(16152, 3, 'ASSIGNER_SAVE_SUCCESS', 'Twoje grupy zostały zaktualizowane', NULL),
(16153, 3, 'ASSIGNER_SAVE_ERROR', 'Błąd zmiany grup', NULL),
(16154, 3, 'ASSIGNER_SAVE_NO_CHANGE', 'Nie wprowadzono żadnych zmian', NULL),
(16155, 4, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Du hast keine der erforderlichen Gruppen. Du kannst den Gruppenzuweiser nicht verwenden.', NULL),
(16156, 4, 'DATE_FORMAT', 'd.m.Y', NULL),
(16157, 4, 'TIME_FORMAT', 'H:i', NULL),
(16158, 4, 'BANS_HEADER_TARGET', 'Bann', NULL),
(16159, 4, 'AUTHORS', 'Bluscream <bluscream@no-reply.github.com>\nderrobin154 <derrobin154@gmail.com>\nFreakyFP <info@hardcoregamers.de>', NULL),
(16160, 4, 'COOKIEALERT_MESSAGE', '<b>Magst du Kekse?</b> &#x1F36A; Wir nutzen Cookies um ihnen das bestmögliche Erlebnis auf unserer Webseite zu ermöglichen. <a href=\"https://support.mozilla.org/de/kb/cookies-informationen-websites-auf-ihrem-computer\" target=\"_blank\">Mehr erfahren</a>', NULL),
(16161, 4, 'COOKIEALERT_AGREE', 'Ich stimme zu', NULL),
(16162, 4, 'OUTDATED_DATA', '<b>Warnung!</b> Einige Informationen konnten nicht abgerufen werden. Zeige veraltete Informationen von {0}.', NULL),
(16163, 4, 'SHOW_PROBLEMS', 'Probleme anzeigen', NULL),
(16164, 4, 'PROBLEMS_DESCRIPTION', 'Probleme während dem Verbinden zum TeamSpeak Server aufgetreten', NULL),
(16165, 4, 'NO_JAVASCRIPT_ENABLED', 'Diese Webseite funktioniert nicht wenn JavaScript <a href=\"https://enable-javascript.com/de/\" target=\"_blank\">nicht aktiviert</a> ist.', NULL),
(16166, 4, 'CANNOT_GET_DATA', '\"{0}\" kann nicht abgerufen werden! Bitte kontaktieren sie den Webmaster.', NULL),
(16167, 4, 'NO_REASON_SET', '<b>(keine Begründung)</b>', NULL),
(16168, 4, 'BANS_HEADER_REASON', 'Grund', NULL),
(16169, 4, 'BANS_HEADER_INVOKER', 'Gebannt von', NULL),
(16170, 4, 'BANS_HEADER_BANDATE', 'Bann Zeitpunkt', NULL),
(16171, 4, 'BANS_HEADER_EXPIRES', 'Läuft ab am', NULL),
(16172, 4, 'DATATABLES_LANGUAGE_NAME', 'German', NULL),
(16173, 4, 'BANS_NEVEREXPIRES', 'Niemals', NULL),
(16174, 4, 'STATUS_ADDRESS', 'Adresse:', NULL),
(16175, 4, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(16176, 4, 'STATUS_RESERVED_SLOTS', '{0} reservierte Slots', NULL),
(16177, 4, 'STATUS_TOP_ONLINE', 'User Rekord:', NULL),
(16178, 4, 'STATUS_TOP_ONLINE_DESC', 'Erreicht am {0}', NULL),
(16179, 4, 'STATUS_UPTIME', 'Online seit:', NULL),
(16180, 4, 'STATUS_VERSION', 'Version:', NULL),
(16181, 4, 'STATUS_VERSION_DESC', '{0} auf {1}', NULL),
(16182, 4, 'STATUS_PING', 'Durchschn. Ping:', NULL),
(16183, 4, 'STATUS_PACKETLOSS', 'Durchschn. Paketverlust:', NULL),
(16184, 4, 'STATUS_ERROR', 'Serverstatus kann nicht abgerufen werden', NULL),
(16185, 4, 'STATUS_PANEL_TITLE', 'Serverstatus', NULL),
(16186, 4, 'DAYJS_LANG', 'de', NULL),
(16187, 4, 'LOGIN_CONFIRMATION_CODE', 'Hallo, hier ist dein verifizierungs Code zum Einloggen: [b]{0}[/b]', NULL),
(16188, 4, 'UNSUPPORTED_BROWSER', 'Dein Browser wird nicht unterstützt. Bitte wechsle zur neusten version von Chrome, Firefox, Safari oder Edge um diese Website zu verwenden.', NULL),
(16189, 4, 'DATATABLES_PLACEHOLDER_SEARCH', 'Suchen...', NULL),
(16190, 4, 'WEBSITE_TITLE', '| TS-Website Deutsche Sprache', NULL),
(16191, 4, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(16192, 4, 'ADMIN_STATUS_AWAY', 'Abwesend', NULL),
(16193, 4, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(16194, 4, 'ADMIN_STATUS_EMPTY_GROUP', 'Nichts zum zeigen', NULL),
(16195, 4, 'ADMIN_STATUS_EMPTY_STATUS', 'Adminstatus ist leer', NULL),
(16196, 4, 'ASSIGNER_PANEL_TITLE', 'Gruppenzuweiser', NULL),
(16197, 4, 'ASSIGNER_TITLE', 'Gruppenzuweiser', NULL),
(16198, 4, 'BANS_EMPTY', 'Bannliste ist leer', NULL),
(16199, 4, 'BANS_TITLE', 'Bannliste', NULL),
(16200, 4, 'BANS_PANEL_TITLE', 'Bannliste', NULL),
(16201, 4, 'BANS_BANNED_ALERT_TITLE', 'Deine IP wurde von {0} gebannt.', NULL),
(16202, 4, 'BANS_BANNED_ALERT_REASON', 'Grund: {0}', NULL),
(16203, 4, 'BANS_VIEW_MORE_TIP', 'Klick auf eine Zeile um mehr Infos zum Bann zu bekommen.', NULL),
(16204, 4, 'RULES_TITLE', 'Regeln', NULL),
(16205, 4, 'RULES_PANEL_TITLE', 'Regeln', NULL),
(16206, 4, 'FAQ_COPY_LINK', 'Link zu dieser Antwort kopieren.', NULL),
(16207, 4, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16208, 4, 'FAQ_TITLE', 'FAQ', NULL),
(16209, 4, 'FAQ_COPY_LINK_SUCCESS', 'Kopiert!', NULL),
(16210, 4, 'FAQ_COPY_LINK_ERROR', 'Fehler!', NULL),
(16211, 4, 'HOME_TITLE', 'Neuigkeiten', NULL),
(16212, 4, 'HOME_PANEL_TITLE', 'Neuigkeiten', NULL),
(16213, 4, 'HOME_EMPTY', 'Aktuell sind keine Neuigkeiten verfügbar.', NULL),
(16214, 4, 'HOME_INVALID_PAGE', 'Falsche Seiten Nummer', NULL),
(16215, 4, 'HOME_PREVIOUS_NEWS', 'Zurück', NULL),
(16216, 4, 'HOME_NEXT_NEWS', 'Weiter', NULL),
(16217, 4, 'ADMIN_STATUS_PANEL_TITLE', 'Adminstatus', NULL),
(16218, 4, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Offline Admins ausblenden', NULL),
(16219, 4, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Zeige Offline Admins', NULL),
(16220, 4, 'ADMIN_STATUS_ERROR', 'Admin Status Fehler', NULL),
(16221, 4, 'NAV_TOGGLE', 'Zeige Navigation', NULL),
(16222, 4, 'NAV_VIEWER', 'Viewer', NULL),
(16223, 4, 'NAV_ASSIGNER', 'Zuweiser', NULL),
(16224, 4, 'NAV_BANS', 'Banns', NULL),
(16225, 4, 'NAV_RULES', 'Regeln', NULL),
(16226, 4, 'NAV_FAQ', 'FAQ', NULL),
(16227, 4, 'NAV_ACCOUNT_LOGIN', 'Einloggen', NULL),
(16228, 4, 'NAV_ACCOUNT_LOGOUT', 'Ausloggen', NULL),
(16229, 4, 'VIEWER_TITLE', 'Serverviewer', NULL),
(16230, 4, 'VIEWER_PANEL_TITLE', 'Serverviewer', NULL),
(16231, 4, 'VIEWER_SHOW_EMPTY', 'Zeige leere Channel', NULL),
(16232, 4, 'VIEWER_HIDE_EMPTY', 'Verberge leere Channel', NULL),
(16233, 4, 'VIEWER_TIP_ALERT', 'Klicke auf einen Channel um ihn zu joinen. Fahre über einen Benutzer um seine Info zu sehen.', NULL),
(16234, 4, 'ARIA_CLOSE', 'Schließen', NULL),
(16235, 4, 'VIEWER_ERROR', 'Viewer Fehler', NULL),
(16236, 4, 'VIEWER_CONNECTION_CONFIRMATION', 'Willst du diesen Channel betreten?', NULL),
(16237, 4, 'VIEWER_CLIENT_LASTACTIVE', 'Zuletzt aktiv:', NULL),
(16238, 4, 'VIEWER_CLIENT_ONLINE', 'Onlinezeit:', NULL),
(16239, 4, 'VIEWER_CLIENT_JOINED', 'Erste Verbindung:', NULL),
(16240, 4, 'VIEWER_CLIENT_TITLE', 'Benutzerinfo', NULL),
(16241, 4, 'VIEWER_SERVER_ICON', 'Servericon', NULL),
(16242, 4, 'VIEWER_DEFAULT_CHANNEL', 'Standard Channel', NULL),
(16243, 4, 'VIEWER_CHANNEL_UNSUB1', ', nicht abboniert', NULL),
(16244, 4, 'VIEWER_CHANNEL_OCCUPIED', 'Voll belegt', NULL),
(16245, 4, 'VIEWER_CHANNEL_PASSWORD', 'Passwort geschützt.', NULL),
(16246, 4, 'VIEWER_CHANNEL_UNSUB2', 'Nicht abboniert', NULL),
(16247, 4, 'VIEWER_CHANNEL_ICON', 'Channelicon', NULL),
(16248, 4, 'VIEWER_CHANNEL_MODERATED', 'Moderiert', NULL),
(16249, 4, 'VIEWER_CHANNEL_MUSIC_CODED', 'Musikcodec', NULL),
(16250, 4, 'VIEWER_CLIENT_AWAY', 'Abwesend', NULL),
(16251, 4, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Sound deaktiviert', NULL),
(16252, 4, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Stummgeschaltet', NULL),
(16253, 4, 'VIEWER_CLIENT_MIC_DISABLED', 'Mikrofon deaktiviert', NULL),
(16254, 4, 'VIEWER_CLIENT_MIC_MUTED', 'Stumm', NULL),
(16255, 4, 'VIEWER_CLIENT_COMMANDER', 'Channel Commander', NULL),
(16256, 4, 'VIEWER_CLIENT_ICON', 'Clienticon', NULL),
(16257, 4, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Gesprächsleiter', NULL),
(16258, 4, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Talkpower erteilt', NULL),
(16259, 4, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Fehlende Talkpower', NULL),
(16260, 4, 'ASSIGNER_NOT_LOGGED_IN', 'Logge dich ein um den Gruppenzuweiser nutzen zu können.', NULL),
(16261, 4, 'ASSIGNER_LOGIN_BUTTON', 'Einloggen', NULL),
(16262, 4, 'ASSIGNER_SAVE_BUTTON', 'Speichern', NULL),
(16263, 4, 'ASSIGNER_INVALID_GROUPS', 'Falsche Gruppeneinstellungen', NULL),
(16264, 4, 'ASSIGNER_NOT_CONFIGURED', 'Gruppenzuweiser wurde nicht vom Webseitenadministrator konfiguriert.', NULL),
(16265, 4, 'ASSIGNER_SAVE_SUCCESS', 'Deine Gruppen wurden aktualisiert', NULL),
(16266, 4, 'ASSIGNER_SAVE_ERROR', 'Fehler beim Gruppen ändern', NULL),
(16267, 4, 'ASSIGNER_SAVE_NO_CHANGE', 'Es wurden keine Änderungen vorgenommen', NULL),
(16268, 5, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Нямате нито една от необходимите групи. Не можете да използвате добавяне на ранг.', NULL),
(16269, 5, 'DATE_FORMAT', 'd.m.Y', NULL),
(16270, 5, 'TIME_FORMAT', 'H:i', NULL),
(16271, 5, 'BANS_HEADER_TARGET', 'забрана', NULL),
(16272, 5, 'AUTHORS', 'toster234 <toster234@ts-24.pro>', NULL),
(16273, 5, 'COOKIEALERT_MESSAGE', '<b>Харесвате ли бисквитки?</b> &#x1F36A; Използваме „бисквитки“, за да гарантираме най-доброто преживяване на нашия уебсайт. <a href=\"https://bg.wikipedia.org/wiki/HTTP-%D0%B1%D0%B8%D1%81%D0%BA%D0%B2%D0%B8%D1%82%D0%BA%D0%B0\" target=\"_blank\">Научете повече</a>', NULL),
(16274, 5, 'COOKIEALERT_AGREE', 'съгласен съм', NULL),
(16275, 5, 'OUTDATED_DATA', '<b>Внимание!</b> Някои данни не могат да бъдат получени сега. Показват се остарели данни от {0}.', NULL),
(16276, 5, 'SHOW_PROBLEMS', 'Показване на проблеми', NULL),
(16277, 5, 'PROBLEMS_DESCRIPTION', 'Проблеми, възникнали при свързването със сървъра на TeamSpeak', NULL),
(16278, 5, 'NO_JAVASCRIPT_ENABLED', 'Този уебсайт няма да работи без<a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript активиран</a>.', NULL),
(16279, 5, 'CANNOT_GET_DATA', 'Данните за \"{0}\"! Моля, свържете се със собственика на уебсайта.', NULL),
(16280, 5, 'NO_REASON_SET', '<b>(без определена причина)</b>', NULL),
(16281, 5, 'BANS_HEADER_REASON', 'причина', NULL),
(16282, 5, 'BANS_HEADER_INVOKER', 'Забранен от', NULL),
(16283, 5, 'BANS_HEADER_BANDATE', 'Дата на забрана', NULL),
(16284, 5, 'BANS_HEADER_EXPIRES', 'Изтича', NULL),
(16285, 5, 'DATATABLES_LANGUAGE_NAME', 'Bulgarian', NULL),
(16286, 5, 'BANS_NEVEREXPIRES', 'никога', NULL),
(16287, 5, 'STATUS_ADDRESS', 'адрес:', NULL),
(16288, 5, 'STATUS_CLIENTS_ONLINE', 'Онлайн:', NULL),
(16289, 5, 'STATUS_RESERVED_SLOTS', '{0} запазени слотове', NULL),
(16290, 5, 'STATUS_TOP_ONLINE', 'Топ онлайн:', NULL),
(16291, 5, 'STATUS_TOP_ONLINE_DESC', 'Постигнато на {0}', NULL),
(16292, 5, 'STATUS_UPTIME', 'Uptime:', NULL),
(16293, 5, 'STATUS_VERSION', 'версия:', NULL),
(16294, 5, 'STATUS_VERSION_DESC', '{0} за {1}', NULL),
(16295, 5, 'STATUS_PING', 'Avg. ping:', NULL),
(16296, 5, 'STATUS_PACKETLOSS', 'Avg. packet loss:', NULL),
(16297, 5, 'STATUS_ERROR', 'Състоянието на сървъра не може да бъде извлечено', NULL),
(16298, 5, 'STATUS_PANEL_TITLE', 'Състояние на сървъра', NULL),
(16299, 5, 'DAYJS_LANG', 'bg', NULL),
(16300, 5, 'LOGIN_CONFIRMATION_CODE', 'Здравейте, тук е кодът ви за потвърждение, с който да влезете: [b]{0}[/b]', NULL),
(16301, 5, 'UNSUPPORTED_BROWSER', 'Вашият браузър не се поддържа. Моля, преминете към последната версия на Chrome, Firefox, Safari или Edge, за да използвате този уебсайт.', NULL),
(16302, 5, 'DATATABLES_PLACEHOLDER_SEARCH', 'Търсене...', NULL),
(16303, 5, 'WEBSITE_TITLE', ' | TS-website Bulgarian Language', NULL),
(16304, 5, 'ADMIN_STATUS_ONLINE', 'Онлайн', NULL),
(16305, 5, 'ADMIN_STATUS_AWAY', 'далеч', NULL),
(16306, 5, 'ADMIN_STATUS_OFFLINE', 'Извън линия', NULL),
(16307, 5, 'ADMIN_STATUS_EMPTY_GROUP', 'Нищо за показване', NULL),
(16308, 5, 'ADMIN_STATUS_EMPTY_STATUS', 'Състоянието на администратора е празно', NULL),
(16309, 5, 'ASSIGNER_PANEL_TITLE', 'Възложител на група', NULL),
(16310, 5, 'ASSIGNER_TITLE', 'Възложител на група', NULL),
(16311, 5, 'BANS_EMPTY', 'списък с блокове е празен', NULL),
(16312, 5, 'BANS_TITLE', 'списък с блокове', NULL),
(16313, 5, 'BANS_PANEL_TITLE', 'списък с блокове', NULL),
(16314, 5, 'BANS_BANNED_ALERT_TITLE', 'Вашият IP е забранен от {0}', NULL),
(16315, 5, 'BANS_BANNED_ALERT_REASON', 'причина: {0}', NULL),
(16316, 5, 'BANS_VIEW_MORE_TIP', 'Кликнете върху реда, за да видите повече подробности за забраната', NULL),
(16317, 5, 'RULES_TITLE', 'правилник', NULL),
(16318, 5, 'RULES_PANEL_TITLE', 'правилник', NULL),
(16319, 5, 'FAQ_COPY_LINK', 'Копирайте връзката към този отговор', NULL),
(16320, 5, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16321, 5, 'FAQ_TITLE', 'FAQ', NULL),
(16322, 5, 'FAQ_COPY_LINK_SUCCESS', 'Копирани!', NULL),
(16323, 5, 'FAQ_COPY_LINK_ERROR', 'Грешка!', NULL),
(16324, 5, 'HOME_TITLE', 'Новини', NULL),
(16325, 5, 'HOME_PANEL_TITLE', 'Новини', NULL),
(16326, 5, 'HOME_EMPTY', 'Няма налични новини в този момент', NULL),
(16327, 5, 'HOME_INVALID_PAGE', 'Невалиден номер на страница', NULL),
(16328, 5, 'HOME_PREVIOUS_NEWS', 'предишен', NULL),
(16329, 5, 'HOME_NEXT_NEWS', 'Следващия', NULL),
(16330, 5, 'ADMIN_STATUS_PANEL_TITLE', 'Статус на администратор', NULL),
(16331, 5, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Скриване на администраторите в офлайн режим', NULL),
(16332, 5, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Показване на администратори в офлайн режим', NULL),
(16333, 5, 'ADMIN_STATUS_ERROR', 'Грешка в състоянието на администратора', NULL),
(16334, 5, 'NAV_TOGGLE', 'Превключване на навигацията', NULL),
(16335, 5, 'NAV_VIEWER', 'Преглед', NULL),
(16336, 5, 'NAV_ASSIGNER', 'Възложител', NULL),
(16337, 5, 'NAV_BANS', 'Забраните', NULL),
(16338, 5, 'NAV_RULES', 'правилник', NULL),
(16339, 5, 'NAV_FAQ', 'FAQ', NULL),
(16340, 5, 'NAV_ACCOUNT_LOGIN', 'Влизам', NULL),
(16341, 5, 'NAV_ACCOUNT_LOGOUT', 'Излез от профила си', NULL),
(16342, 5, 'VIEWER_TITLE', 'Преглед на сървъра', NULL),
(16343, 5, 'VIEWER_PANEL_TITLE', 'Преглед на сървъра', NULL),
(16344, 5, 'VIEWER_SHOW_EMPTY', 'Показване на празни канали', NULL),
(16345, 5, 'VIEWER_HIDE_EMPTY', 'Скриване на празните канали', NULL),
(16346, 5, 'VIEWER_TIP_ALERT', 'Кликнете върху канал, за да се присъедините към него. Задръжте курсора на мишката върху потребител, за да проверите информацията им', NULL),
(16347, 5, 'ARIA_CLOSE', 'Близо', NULL),
(16348, 5, 'VIEWER_ERROR', 'Грешка в браузъра', NULL),
(16349, 5, 'VIEWER_CONNECTION_CONFIRMATION', 'Искате ли да се свържете с този канал?', NULL),
(16350, 5, 'VIEWER_CLIENT_LASTACTIVE', 'Последна активна:', NULL),
(16351, 5, 'VIEWER_CLIENT_ONLINE', 'Онлайн време:', NULL),
(16352, 5, 'VIEWER_CLIENT_JOINED', 'Първо се присъединиха:', NULL),
(16353, 5, 'VIEWER_CLIENT_TITLE', 'Информация за клиента', NULL),
(16354, 5, 'VIEWER_SERVER_ICON', 'Икона на сървъра', NULL),
(16355, 5, 'VIEWER_DEFAULT_CHANNEL', 'Канал по подразбиране', NULL),
(16356, 5, 'VIEWER_CHANNEL_UNSUB1', ', отписахте', NULL),
(16357, 5, 'VIEWER_CHANNEL_OCCUPIED', 'Напълно зает', NULL),
(16358, 5, 'VIEWER_CHANNEL_PASSWORD', 'Защитен с парола', NULL),
(16359, 5, 'VIEWER_CHANNEL_UNSUB2', 'отписахте', NULL),
(16360, 5, 'VIEWER_CHANNEL_ICON', 'Икона на канал', NULL),
(16361, 5, 'VIEWER_CHANNEL_MODERATED', 'Модератор', NULL),
(16362, 5, 'VIEWER_CHANNEL_MUSIC_CODED', 'Музикален кодек', NULL),
(16363, 5, 'VIEWER_CLIENT_AWAY', 'далеч', NULL),
(16364, 5, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Звукът е деактивиран', NULL),
(16365, 5, 'VIEWER_CLIENT_OUTPUT_MUTED', 'оглуши', NULL),
(16366, 5, 'VIEWER_CLIENT_MIC_DISABLED', 'Микрофонът е деактивиран', NULL),
(16367, 5, 'VIEWER_CLIENT_MIC_MUTED', 'Спряно', NULL),
(16368, 5, 'VIEWER_CLIENT_COMMANDER', 'Командир на канала', NULL),
(16369, 5, 'VIEWER_CLIENT_ICON', 'Икона на клиента', NULL),
(16370, 5, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Говорител с приоритет', NULL),
(16371, 5, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Говори се за власт', NULL),
(16372, 5, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Недостатъчна мощност', NULL),
(16373, 5, 'ASSIGNER_NOT_LOGGED_IN', 'Влезте в системата, преди да използвате групата', NULL),
(16374, 5, 'ASSIGNER_LOGIN_BUTTON', 'Влизам', NULL),
(16375, 5, 'ASSIGNER_SAVE_BUTTON', 'Запази', NULL),
(16376, 5, 'ASSIGNER_INVALID_GROUPS', 'Невалидни настройки на групата', NULL),
(16377, 5, 'ASSIGNER_NOT_CONFIGURED', 'Груповият разпоредител не се конфигурира от администратора на сайта', NULL),
(16378, 5, 'ASSIGNER_SAVE_SUCCESS', 'Групите ви бяха актуализирани', NULL),
(16379, 5, 'ASSIGNER_SAVE_ERROR', 'Грешка при промяна на групата', NULL),
(16380, 5, 'ASSIGNER_SAVE_NO_CHANGE', 'Не са направени промени', NULL),
(16381, 6, 'DATE_FORMAT', 'd.m.Y', NULL),
(16382, 6, 'TIME_FORMAT', 'H:i', NULL),
(16383, 6, 'BANS_HEADER_TARGET', 'Baneo', NULL),
(16384, 6, 'AUTHORS', 'NOX <nox@talkers.pro>', NULL),
(16385, 6, 'COOKIEALERT_MESSAGE', '<b>¿Te gustan las cookies?</b> &#x1F36A; Utilizamos cookies para asegurarnos de que obtengas la mejor experiencia en nuestro sitio web.  <a href=\"https://support.mozilla.org/es/kb/cookies-informacion-que-los-sitios-web-guardan-en-\" target=\"_blank\">Más información</a>', NULL),
(16386, 6, 'COOKIEALERT_AGREE', 'Estoy de acuerdo', NULL),
(16387, 6, 'OUTDATED_DATA', '<b>¡Aviso!</b> No se puede obtener información en este momento. Mostrando datos obsoletos de {0}.', NULL),
(16388, 6, 'SHOW_PROBLEMS', 'Mostrar problemas', NULL),
(16389, 6, 'PROBLEMS_DESCRIPTION', 'Problemas encontrados al conectarse al servidor de TeamSpeak', NULL),
(16390, 6, 'NO_JAVASCRIPT_ENABLED', 'Este sitio web no funcionará sin <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript activado</a>.', NULL),
(16391, 6, 'CANNOT_GET_DATA', '¡No se pueden obtener datos de \"{0}\"! Por favor, póngase en contacto con el propietario del sitio web.', NULL),
(16392, 6, 'NO_REASON_SET', '<b>(sin razón)</b>', NULL),
(16393, 6, 'BANS_HEADER_REASON', 'Razón', NULL),
(16394, 6, 'BANS_HEADER_INVOKER', 'Baneado por', NULL),
(16395, 6, 'BANS_HEADER_BANDATE', 'Fecha de baneo', NULL),
(16396, 6, 'BANS_HEADER_EXPIRES', 'Expiración', NULL),
(16397, 6, 'DATATABLES_LANGUAGE_NAME', 'Spanish', NULL),
(16398, 6, 'BANS_NEVEREXPIRES', 'Nunca', NULL),
(16399, 6, 'STATUS_ADDRESS', 'Dirección:', NULL),
(16400, 6, 'STATUS_CLIENTS_ONLINE', 'En línea:', NULL),
(16401, 6, 'STATUS_RESERVED_SLOTS', '{0} slots reservados', NULL),
(16402, 6, 'STATUS_TOP_ONLINE', 'Top en línea:', NULL),
(16403, 6, 'STATUS_TOP_ONLINE_DESC', 'Archivado en {0}', NULL),
(16404, 6, 'STATUS_UPTIME', 'Tiempo activo:', NULL),
(16405, 6, 'STATUS_VERSION', 'Versión:', NULL),
(16406, 6, 'STATUS_VERSION_DESC', '{0} en {1}', NULL),
(16407, 6, 'STATUS_PING', 'Ping promedio:', NULL),
(16408, 6, 'STATUS_PACKETLOSS', 'Pérdida de paquetes:', NULL),
(16409, 6, 'STATUS_ERROR', 'No se puede recuperar el estado del servidor', NULL),
(16410, 6, 'STATUS_PANEL_TITLE', 'Estado del servidor', NULL),
(16411, 6, 'DAYJS_LANG', 'es', NULL),
(16412, 6, 'LOGIN_CONFIRMATION_CODE', 'Hola, aquí tienes tu código de confirmación para iniciar sesión: [b]{0}[/b]', NULL),
(16413, 6, 'UNSUPPORTED_BROWSER', 'Tu navegador no es compatible. Cambia a la última versión de Chrome, Firefox, Safari o Edge para usar este sitio web.', NULL),
(16414, 6, 'DATATABLES_PLACEHOLDER_SEARCH', 'Buscar...', NULL),
(16415, 6, 'WEBSITE_TITLE', ' | TS-website idioma en Inglés', NULL),
(16416, 6, 'ADMIN_STATUS_ONLINE', 'En línea', NULL),
(16417, 6, 'ADMIN_STATUS_AWAY', 'AFK', NULL),
(16418, 6, 'ADMIN_STATUS_OFFLINE', 'Desconectado', NULL),
(16419, 6, 'ADMIN_STATUS_EMPTY_GROUP', 'Nada que mostrar', NULL),
(16420, 6, 'ADMIN_STATUS_EMPTY_STATUS', 'El estado de administrador está vacío', NULL),
(16421, 6, 'ASSIGNER_PANEL_TITLE', 'Selector de grupo', NULL),
(16422, 6, 'ASSIGNER_TITLE', 'Selector de grupo', NULL),
(16423, 6, 'BANS_EMPTY', 'La lista de baneados está vacía', NULL),
(16424, 6, 'BANS_TITLE', 'Lista de baneados', NULL),
(16425, 6, 'BANS_PANEL_TITLE', 'Lista de baneados', NULL),
(16426, 6, 'BANS_BANNED_ALERT_TITLE', 'Tu IP ha sido baneada por {0}', NULL),
(16427, 6, 'BANS_BANNED_ALERT_REASON', 'Razón: {0}', NULL),
(16428, 6, 'BANS_VIEW_MORE_TIP', 'Haga clic en una fila para ver más detalles sobre un baneo', NULL),
(16429, 6, 'RULES_TITLE', 'Reglas', NULL),
(16430, 6, 'RULES_PANEL_TITLE', 'Reglas', NULL),
(16431, 6, 'FAQ_COPY_LINK', 'Copiar enlace a esa respuesta', NULL),
(16432, 6, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16433, 6, 'FAQ_TITLE', 'FAQ', NULL),
(16434, 6, 'FAQ_COPY_LINK_SUCCESS', '¡Copiado!', NULL),
(16435, 6, 'FAQ_COPY_LINK_ERROR', '¡Error!', NULL),
(16436, 6, 'HOME_TITLE', 'Noticias', NULL),
(16437, 6, 'HOME_PANEL_TITLE', 'Noticias', NULL),
(16438, 6, 'HOME_EMPTY', 'No hay noticias disponibles en este momento.', NULL),
(16439, 6, 'HOME_INVALID_PAGE', 'Número de página inválido', NULL),
(16440, 6, 'HOME_PREVIOUS_NEWS', 'Anterior', NULL),
(16441, 6, 'HOME_NEXT_NEWS', 'Siguiente', NULL),
(16442, 6, 'ADMIN_STATUS_PANEL_TITLE', 'Estado administración', NULL),
(16443, 6, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Ocultar administradores sin conexión', NULL),
(16444, 6, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Mostrar administradores sin conexión', NULL),
(16445, 6, 'ADMIN_STATUS_ERROR', 'Error de estado de la administración', NULL),
(16446, 6, 'NAV_TOGGLE', 'Alternar la navegación', NULL),
(16447, 6, 'NAV_VIEWER', 'Servidor', NULL),
(16448, 6, 'NAV_ASSIGNER', 'Grupos', NULL),
(16449, 6, 'NAV_BANS', 'Baneados', NULL),
(16450, 6, 'NAV_RULES', 'Reglas', NULL),
(16451, 6, 'NAV_FAQ', 'FAQ', NULL),
(16452, 6, 'NAV_ACCOUNT_LOGIN', 'Iniciar sesión', NULL),
(16453, 6, 'NAV_ACCOUNT_LOGOUT', 'Salir', NULL),
(16454, 6, 'VIEWER_TITLE', 'Ver servidor', NULL),
(16455, 6, 'VIEWER_PANEL_TITLE', 'Visor del servidor', NULL),
(16456, 6, 'VIEWER_SHOW_EMPTY', 'Mostrar canales vacíos', NULL),
(16457, 6, 'VIEWER_HIDE_EMPTY', 'Ocultar canales vacíos', NULL),
(16458, 6, 'VIEWER_TIP_ALERT', 'Haz clic en un canal para unirte a él. Coloca el cursor sobre un usuario para comprobar su información.', NULL),
(16459, 6, 'ARIA_CLOSE', 'Cerrar', NULL),
(16460, 6, 'VIEWER_ERROR', 'Error del visor', NULL),
(16461, 6, 'VIEWER_CONNECTION_CONFIRMATION', '¿Quieres conectarte a este canal?', NULL),
(16462, 6, 'VIEWER_CLIENT_LASTACTIVE', 'Última actividad:', NULL),
(16463, 6, 'VIEWER_CLIENT_ONLINE', 'Tiempo en línea:', NULL),
(16464, 6, 'VIEWER_CLIENT_JOINED', 'Primera unión:', NULL),
(16465, 6, 'VIEWER_CLIENT_TITLE', 'Info cliente', NULL),
(16466, 6, 'VIEWER_SERVER_ICON', 'Icono del servidor', NULL),
(16467, 6, 'VIEWER_DEFAULT_CHANNEL', 'Canal por defecto', NULL),
(16468, 6, 'VIEWER_CHANNEL_UNSUB1', ', sin suscripción', NULL),
(16469, 6, 'VIEWER_CHANNEL_OCCUPIED', 'Totalmente ocupado', NULL),
(16470, 6, 'VIEWER_CHANNEL_PASSWORD', 'Contraseña protegida', NULL),
(16471, 6, 'VIEWER_CHANNEL_UNSUB2', 'Sin suscripción', NULL),
(16472, 6, 'VIEWER_CHANNEL_ICON', 'Icono del canal', NULL),
(16473, 6, 'VIEWER_CHANNEL_MODERATED', 'Moderado', NULL),
(16474, 6, 'VIEWER_CHANNEL_MUSIC_CODED', 'Codec de música', NULL),
(16475, 6, 'VIEWER_CLIENT_AWAY', 'AFK', NULL),
(16476, 6, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Sonido desactivado', NULL),
(16477, 6, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Sin auriculares', NULL),
(16478, 6, 'VIEWER_CLIENT_MIC_DISABLED', 'Micrófono desactivado', NULL),
(16479, 6, 'VIEWER_CLIENT_MIC_MUTED', 'Muteado', NULL),
(16480, 6, 'VIEWER_CLIENT_COMMANDER', 'Dueño del canal', NULL),
(16481, 6, 'VIEWER_CLIENT_ICON', 'Icono del cliente', NULL),
(16482, 6, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Voz prioritaria', NULL),
(16483, 6, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Permiso para hablar concedido', NULL),
(16484, 6, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Permiso insuficiente para hablar', NULL),
(16485, 6, 'ASSIGNER_NOT_LOGGED_IN', 'Inicia sesión antes de usar el selector de grupo', NULL),
(16486, 6, 'ASSIGNER_LOGIN_BUTTON', 'Iniciar sesión', NULL),
(16487, 6, 'ASSIGNER_SAVE_BUTTON', 'Guardar', NULL),
(16488, 6, 'ASSIGNER_INVALID_GROUPS', 'Configuración de grupo no válida', NULL),
(16489, 6, 'ASSIGNER_NOT_CONFIGURED', 'El administrador del sitio web no configura el asignador de grupo', NULL),
(16490, 6, 'ASSIGNER_SAVE_SUCCESS', 'Tus grupos han sido actualizados.', NULL),
(16491, 6, 'ASSIGNER_SAVE_ERROR', 'Error de cambio de grupo', NULL),
(16492, 6, 'ASSIGNER_SAVE_NO_CHANGE', 'No se han realizado cambios', NULL),
(16493, 7, 'DATE_FORMAT', 'd.m.Y', NULL),
(16494, 7, 'TIME_FORMAT', 'H:i', NULL),
(16495, 7, 'BANS_HEADER_TARGET', 'Бан', NULL),
(16496, 7, 'AUTHORS', 'kidi <admin@goodgame.by>', NULL),
(16497, 7, 'COOKIEALERT_MESSAGE', '<b>Вам нравятся куки?</b>&#x1F36A; Мы используем куки что бы обеспечить наилучший опыт на нашем вебсайте. <a href=\"https://support.mozilla.org/ru/kb/kuki-informaciya-kotoruyu-veb-sajty-hranyat-na-vas\" target=\"_blank\">Узнать больше</a>', NULL),
(16498, 7, 'COOKIEALERT_AGREE', 'Я согласен', NULL),
(16499, 7, 'OUTDATED_DATA', '<b>Внимание!</b> Не удалось получить актуальную информацию с сервера. Отображается информация {0}', NULL),
(16500, 7, 'SHOW_PROBLEMS', 'Показать проблемы', NULL),
(16501, 7, 'PROBLEMS_DESCRIPTION', 'При подключении к серверу TeamSpeak произошли ошибки', NULL),
(16502, 7, 'NO_JAVASCRIPT_ENABLED', 'Данный сайт не будет работать при отключенном <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript</a>', NULL),
(16503, 7, 'CANNOT_GET_DATA', 'Не удалось получить данные для модуля \"{0}\"! Пожалуйста свяжитесь с владельцем сайта.', NULL),
(16504, 7, 'NO_REASON_SET', '<b>(причина не указана)</b>', NULL),
(16505, 7, 'BANS_HEADER_REASON', 'Причина', NULL),
(16506, 7, 'BANS_HEADER_INVOKER', 'Забанил', NULL),
(16507, 7, 'BANS_HEADER_BANDATE', 'Бан создан', NULL),
(16508, 7, 'BANS_HEADER_EXPIRES', 'Истекает', NULL),
(16509, 7, 'DATATABLES_LANGUAGE_NAME', 'Russian', NULL),
(16510, 7, 'BANS_NEVEREXPIRES', 'Никогда', NULL),
(16511, 7, 'STATUS_ADDRESS', 'Адрес:', NULL),
(16512, 7, 'STATUS_CLIENTS_ONLINE', 'Онлайн:', NULL),
(16513, 7, 'STATUS_RESERVED_SLOTS', '{0} зарезервировано', NULL),
(16514, 7, 'STATUS_TOP_ONLINE', 'Макс. онлайн:', NULL),
(16515, 7, 'STATUS_TOP_ONLINE_DESC', 'Достигнут {0}', NULL),
(16516, 7, 'STATUS_UPTIME', 'Аптайм:', NULL),
(16517, 7, 'STATUS_VERSION', 'Версия:', NULL),
(16518, 7, 'STATUS_VERSION_DESC', '{0} на {1}', NULL),
(16519, 7, 'STATUS_PING', 'Средн. пинг:', NULL),
(16520, 7, 'STATUS_PACKETLOSS', 'Потери пакетов:', NULL),
(16521, 7, 'STATUS_ERROR', 'Невозможно получить статус сервера', NULL),
(16522, 7, 'STATUS_PANEL_TITLE', 'Статус сервера', NULL),
(16523, 7, 'DAYJS_LANG', 'ru', NULL),
(16524, 7, 'LOGIN_CONFIRMATION_CODE', 'Приветствуем! Ваш код подтверждения для авторизации: [b]{0}[/b]', NULL),
(16525, 7, 'UNSUPPORTED_BROWSER', 'Ваш браузер не поддерживается. Пожалуйста, установите Chrome, Firefox, Safari или Edge.', NULL),
(16526, 7, 'DATATABLES_PLACEHOLDER_SEARCH', 'Поиск...', NULL),
(16527, 7, 'WEBSITE_TITLE', ' | Русский язык TS-website', NULL),
(16528, 7, 'ADMIN_STATUS_ONLINE', 'Онлайн', NULL),
(16529, 7, 'ADMIN_STATUS_AWAY', 'Отошёл', NULL),
(16530, 7, 'ADMIN_STATUS_OFFLINE', 'Оффлайн', NULL),
(16531, 7, 'ADMIN_STATUS_EMPTY_GROUP', 'Нечего показывать', NULL),
(16532, 7, 'ADMIN_STATUS_EMPTY_STATUS', 'Статус администратора пуст', NULL),
(16533, 7, 'ASSIGNER_PANEL_TITLE', 'Группы', NULL),
(16534, 7, 'ASSIGNER_TITLE', 'Менеджер групп', NULL),
(16535, 7, 'BANS_EMPTY', 'Список банов пуст', NULL),
(16536, 7, 'BANS_TITLE', 'Баны', NULL),
(16537, 7, 'BANS_PANEL_TITLE', 'Баны', NULL),
(16538, 7, 'BANS_BANNED_ALERT_TITLE', 'Ваш IP забанен администратором {0}', NULL),
(16539, 7, 'BANS_BANNED_ALERT_REASON', 'Причина: {0}', NULL),
(16540, 7, 'BANS_VIEW_MORE_TIP', 'Нажмите на строку для отображения деталей о бане', NULL),
(16541, 7, 'RULES_TITLE', 'Правила', NULL),
(16542, 7, 'RULES_PANEL_TITLE', 'Правила', NULL),
(16543, 7, 'FAQ_COPY_LINK', 'Скопировать ссылку на этот ответ', NULL),
(16544, 7, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16545, 7, 'FAQ_TITLE', 'FAQ', NULL),
(16546, 7, 'FAQ_COPY_LINK_SUCCESS', 'Скопировано!', NULL),
(16547, 7, 'FAQ_COPY_LINK_ERROR', 'Ошибка!', NULL),
(16548, 7, 'HOME_TITLE', 'Новости', NULL),
(16549, 7, 'HOME_PANEL_TITLE', 'Новости', NULL),
(16550, 7, 'HOME_EMPTY', 'На данный момент нет новостей', NULL),
(16551, 7, 'HOME_INVALID_PAGE', 'Неверный номер страницы', NULL),
(16552, 7, 'HOME_PREVIOUS_NEWS', 'Назад', NULL),
(16553, 7, 'HOME_NEXT_NEWS', 'Вперёд', NULL),
(16554, 7, 'ADMIN_STATUS_PANEL_TITLE', 'Статус администрации', NULL),
(16555, 7, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Скрыть отключенных администраторов', NULL),
(16556, 7, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Показать отключенных администраторов', NULL),
(16557, 7, 'ADMIN_STATUS_ERROR', 'Ошибка статуса администратора', NULL),
(16558, 7, 'NAV_TOGGLE', 'Переключить навигацию', NULL),
(16559, 7, 'NAV_VIEWER', 'Обзор', NULL),
(16560, 7, 'NAV_ASSIGNER', 'Группы', NULL),
(16561, 7, 'NAV_BANS', 'Список банов', NULL),
(16562, 7, 'NAV_RULES', 'Правила', NULL),
(16563, 7, 'NAV_FAQ', 'FAQ', NULL),
(16564, 7, 'NAV_ACCOUNT_LOGIN', 'Войти', NULL),
(16565, 7, 'NAV_ACCOUNT_LOGOUT', 'Выйти', NULL),
(16566, 7, 'VIEWER_TITLE', 'Обзор сервера', NULL),
(16567, 7, 'VIEWER_PANEL_TITLE', 'Обзор сервера', NULL),
(16568, 7, 'VIEWER_SHOW_EMPTY', 'Показать пустые каналы', NULL),
(16569, 7, 'VIEWER_HIDE_EMPTY', 'Скрыть пустые каналы', NULL),
(16570, 7, 'VIEWER_TIP_ALERT', 'Для входа в канал нажмите на него. Наведите курсор над пользователем для отображения информации', NULL),
(16571, 7, 'ARIA_CLOSE', 'Закрыть', NULL),
(16572, 7, 'VIEWER_ERROR', 'Ошибка при обзоре сервера', NULL),
(16573, 7, 'VIEWER_CONNECTION_CONFIRMATION', 'Вы хотите войти в этот канал?', NULL),
(16574, 7, 'VIEWER_CLIENT_LASTACTIVE', 'Был активен:', NULL),
(16575, 7, 'VIEWER_CLIENT_ONLINE', 'Время онлайн:', NULL),
(16576, 7, 'VIEWER_CLIENT_JOINED', 'Первое подключение:', NULL),
(16577, 7, 'VIEWER_CLIENT_TITLE', 'Информация о клиенте', NULL),
(16578, 7, 'VIEWER_SERVER_ICON', 'Иконка сервера', NULL),
(16579, 7, 'VIEWER_DEFAULT_CHANNEL', 'Стандартный канал', NULL),
(16580, 7, 'VIEWER_CHANNEL_UNSUB1', ', не подписан', NULL),
(16581, 7, 'VIEWER_CHANNEL_OCCUPIED', 'Заполнен', NULL),
(16582, 7, 'VIEWER_CHANNEL_PASSWORD', 'Защищен паролем', NULL),
(16583, 7, 'VIEWER_CHANNEL_UNSUB2', 'Не подписан', NULL),
(16584, 7, 'VIEWER_CHANNEL_ICON', 'Иконка канала', NULL),
(16585, 7, 'VIEWER_CHANNEL_MODERATED', 'Модерируемый', NULL),
(16586, 7, 'VIEWER_CHANNEL_MUSIC_CODED', 'Opus для музыки', NULL),
(16587, 7, 'VIEWER_CLIENT_AWAY', 'Отошёл', NULL),
(16588, 7, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Звук отключён', NULL),
(16589, 7, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Приглушен', NULL),
(16590, 7, 'VIEWER_CLIENT_MIC_DISABLED', 'Микрофон отключён', NULL),
(16591, 7, 'VIEWER_CLIENT_MIC_MUTED', 'Заглушен', NULL),
(16592, 7, 'VIEWER_CLIENT_COMMANDER', 'Командир канала', NULL),
(16593, 7, 'VIEWER_CLIENT_ICON', 'Иконка клиента', NULL),
(16594, 7, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Приоритет голоса', NULL),
(16595, 7, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Право голоса получено', NULL),
(16596, 7, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Недостаточно прав голоса', NULL),
(16597, 7, 'ASSIGNER_NOT_LOGGED_IN', 'Авторизуйтесь перед использованием менеджера групп', NULL),
(16598, 7, 'ASSIGNER_LOGIN_BUTTON', 'Войти', NULL),
(16599, 7, 'ASSIGNER_SAVE_BUTTON', 'Сохранить', NULL),
(16600, 7, 'ASSIGNER_INVALID_GROUPS', 'Неверные настройки групп', NULL),
(16601, 7, 'ASSIGNER_NOT_CONFIGURED', 'Менеджер групп не был настроен администратором сайта', NULL),
(16602, 7, 'ASSIGNER_SAVE_SUCCESS', 'Ваши группы были обновлены', NULL),
(16603, 7, 'ASSIGNER_SAVE_ERROR', 'Ошибка при изменении группы', NULL),
(16604, 7, 'ASSIGNER_SAVE_NO_CHANGE', 'Изменения не были сохранены', NULL),
(16605, 8, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Je hebt geen van de vereiste groepen. Je kan niet de groep toewijzer gebruiken,', NULL),
(16606, 8, 'DATE_FORMAT', 'd.m.Y', NULL),
(16607, 8, 'TIME_FORMAT', 'H:i', NULL),
(16608, 8, 'BANS_HEADER_TARGET', 'Ban', NULL),
(16609, 8, 'AUTHORS', 'toster234 <toster234@ts-24.pro>\nT.S.', NULL),
(16610, 8, 'COOKIEALERT_MESSAGE', '<b>Houd je van cookies?</b> &#x1F36A; We gebruiken cookies om de hoogste kwaliteit van de services te garanderen. <a href=\"https://support.mozilla.org/nl/products/firefox/protect-your-privacy/cookies\" target=\"_blank\">Meer informatie</a>', NULL),
(16611, 8, 'COOKIEALERT_AGREE', 'Ik ben het ermee eens', NULL),
(16612, 8, 'OUTDATED_DATA', '<b>Uitkijken!</b> Sommige gegevens kunnen nu niet worden verkregen. Het laat verouderde gegevens zien {0}', NULL),
(16613, 8, 'SHOW_PROBLEMS', 'Toon problemen', NULL),
(16614, 8, 'PROBLEMS_DESCRIPTION', 'Problemen ondervonden tijdens het verbinden met de TeamSpeak Server', NULL),
(16615, 8, 'NO_JAVASCRIPT_ENABLED', 'Deze pagina zal niet werken zonder <a href=\"https://www.enable-javascript.com/nl/\" target=\"_blank\">JavaScript ingeschakeld</a>.', NULL),
(16616, 8, 'CANNOT_GET_DATA', 'Ik kan geen informatie downloaden over \"{0}\"! Neem contact op met de eigenaar van de site.', NULL),
(16617, 8, 'NO_REASON_SET', '<b>(Geen reden aangegeven)</b>', NULL),
(16618, 8, 'BANS_HEADER_REASON', 'Reden', NULL),
(16619, 8, 'BANS_HEADER_INVOKER', 'Gebanned door', NULL),
(16620, 8, 'BANS_HEADER_BANDATE', 'Ban datum', NULL),
(16621, 8, 'BANS_HEADER_EXPIRES', 'Vervalt', NULL),
(16622, 8, 'DATATABLES_LANGUAGE_NAME', 'Dutch', NULL),
(16623, 8, 'BANS_NEVEREXPIRES', 'Nooit', NULL),
(16624, 8, 'STATUS_ADDRESS', 'Adres:', NULL),
(16625, 8, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(16626, 8, 'STATUS_RESERVED_SLOTS', '{0} gereserveerde slots', NULL),
(16627, 8, 'STATUS_TOP_ONLINE', 'Meest online:', NULL),
(16628, 8, 'STATUS_TOP_ONLINE_DESC', 'Verkregen op {0}', NULL),
(16629, 8, 'STATUS_UPTIME', 'Tijd online:', NULL),
(16630, 8, 'STATUS_VERSION', 'Versie', NULL),
(16631, 8, 'STATUS_VERSION_DESC', '{0} op {1}', NULL),
(16632, 8, 'STATUS_PING', 'Gem. ping:', NULL),
(16633, 8, 'STATUS_PACKETLOSS', 'Gem. pakketverlies:', NULL),
(16634, 8, 'STATUS_ERROR', 'Fout bij laden van serverstatus', NULL),
(16635, 8, 'STATUS_PANEL_TITLE', 'Server status', NULL),
(16636, 8, 'DAYJS_LANG', 'nl', NULL),
(16637, 8, 'LOGIN_CONFIRMATION_CODE', 'Hallo, hier is uw inlogbevestigingscode: [b]{0}[/b]', NULL),
(16638, 8, 'UNSUPPORTED_BROWSER', 'Uw browser wordt niet ondersteund. Installeer de nieuwste versie van Chrome, Firefox, Safari of Edge om deze site te gebruiken.', NULL),
(16639, 8, 'DATATABLES_PLACEHOLDER_SEARCH', 'Zoeken...', NULL),
(16640, 8, 'WEBSITE_TITLE', ' | TS-website Nederlandse Taal', NULL),
(16641, 8, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(16642, 8, 'ADMIN_STATUS_AWAY', 'Afwezig', NULL),
(16643, 8, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(16644, 8, 'ADMIN_STATUS_EMPTY_GROUP', 'Niets te tonen', NULL),
(16645, 8, 'ADMIN_STATUS_EMPTY_STATUS', 'Administratiestatus is leeg', NULL),
(16646, 8, 'ASSIGNER_PANEL_TITLE', 'Groepstoewijzer', NULL),
(16647, 8, 'ASSIGNER_TITLE', 'Groepstoewijzer', NULL),
(16648, 8, 'BANS_EMPTY', 'Banlijst is leeg', NULL),
(16649, 8, 'BANS_TITLE', 'Banlijst', NULL),
(16650, 8, 'BANS_PANEL_TITLE', 'Banlijst', NULL),
(16651, 8, 'BANS_BANNED_ALERT_TITLE', 'Uw IP is gebanned door {0}', NULL),
(16652, 8, 'BANS_BANNED_ALERT_REASON', 'Reden: {0}', NULL),
(16653, 8, 'BANS_VIEW_MORE_TIP', 'Klik op een rij om meer informatie over een ban te bekijken', NULL),
(16654, 8, 'RULES_TITLE', 'Reglement', NULL),
(16655, 8, 'RULES_PANEL_TITLE', 'Reglement', NULL),
(16656, 8, 'FAQ_COPY_LINK', 'Kopieer de link naar dit antwoord', NULL),
(16657, 8, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16658, 8, 'FAQ_TITLE', 'FAQ', NULL),
(16659, 8, 'FAQ_COPY_LINK_SUCCESS', 'Gekopieerd!', NULL),
(16660, 8, 'FAQ_COPY_LINK_ERROR', 'Fout!', NULL),
(16661, 8, 'HOME_TITLE', 'Nieuws', NULL),
(16662, 8, 'HOME_PANEL_TITLE', 'Nieuws', NULL),
(16663, 8, 'HOME_EMPTY', 'Geen nieuws beschikbaar op dit moment', NULL),
(16664, 8, 'HOME_INVALID_PAGE', 'Ongeldig paginanummer', NULL),
(16665, 8, 'HOME_PREVIOUS_NEWS', 'Vorige', NULL),
(16666, 8, 'HOME_NEXT_NEWS', 'Volgende', NULL),
(16667, 8, 'ADMIN_STATUS_PANEL_TITLE', 'Administratieve status', NULL),
(16668, 8, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Verberg offline beheerders', NULL),
(16669, 8, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Toon offline beheerders', NULL),
(16670, 8, 'ADMIN_STATUS_ERROR', 'Beheerder status fout', NULL),
(16671, 8, 'NAV_TOGGLE', 'Navigatie (in/uit)schakelen', NULL),
(16672, 8, 'NAV_VIEWER', 'Bekijker', NULL),
(16673, 8, 'NAV_ASSIGNER', 'Toewijzer', NULL);
INSERT INTO `DBPREFIXtranslations` (`id`, `langid`, `identifier`, `value`, `comment`) VALUES
(16674, 8, 'NAV_BANS', 'Bans', NULL),
(16675, 8, 'NAV_RULES', 'Regels', NULL),
(16676, 8, 'NAV_FAQ', 'FAQ', NULL),
(16677, 8, 'NAV_ACCOUNT_LOGIN', 'Inloggen', NULL),
(16678, 8, 'NAV_ACCOUNT_LOGOUT', 'Uitloggen', NULL),
(16679, 8, 'VIEWER_TITLE', 'Server bekijker', NULL),
(16680, 8, 'VIEWER_PANEL_TITLE', 'Server bekijker', NULL),
(16681, 8, 'VIEWER_SHOW_EMPTY', 'Toon lege kanalen', NULL),
(16682, 8, 'VIEWER_HIDE_EMPTY', 'Verberg lege kanalen', NULL),
(16683, 8, 'VIEWER_TIP_ALERT', 'Klik op een kanaal om het toe te treden. Zweef over een gebruiker om hun informatie te bekijken.', NULL),
(16684, 8, 'ARIA_CLOSE', 'Sluit', NULL),
(16685, 8, 'VIEWER_ERROR', 'Bekijker fout', NULL),
(16686, 8, 'VIEWER_CONNECTION_CONFIRMATION', 'Wil je verbinding maken met dit kanaal?', NULL),
(16687, 8, 'VIEWER_CLIENT_LASTACTIVE', 'Laatst actief:', NULL),
(16688, 8, 'VIEWER_CLIENT_ONLINE', 'Online tijd:', NULL),
(16689, 8, 'VIEWER_CLIENT_JOINED', 'Geregistreerd op:', NULL),
(16690, 8, 'VIEWER_CLIENT_TITLE', 'Cliënt informatie', NULL),
(16691, 8, 'VIEWER_SERVER_ICON', 'Server icoon', NULL),
(16692, 8, 'VIEWER_DEFAULT_CHANNEL', 'Standaard kanaal', NULL),
(16693, 8, 'VIEWER_CHANNEL_UNSUB1', ', afgemeld', NULL),
(16694, 8, 'VIEWER_CHANNEL_OCCUPIED', 'Volledig bezet', NULL),
(16695, 8, 'VIEWER_CHANNEL_PASSWORD', 'Beveiligd met een wachtwoord', NULL),
(16696, 8, 'VIEWER_CHANNEL_UNSUB2', 'Afgemeld', NULL),
(16697, 8, 'VIEWER_CHANNEL_ICON', 'Kanaal icoon', NULL),
(16698, 8, 'VIEWER_CHANNEL_MODERATED', 'Gemodereerd', NULL),
(16699, 8, 'VIEWER_CHANNEL_MUSIC_CODED', 'Muziek codec', NULL),
(16700, 8, 'VIEWER_CLIENT_AWAY', 'Afwezig', NULL),
(16701, 8, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Geluid uitgeschakeld', NULL),
(16702, 8, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Geluid gedempt', NULL),
(16703, 8, 'VIEWER_CLIENT_MIC_DISABLED', 'Microfoon uitgeschakeld', NULL),
(16704, 8, 'VIEWER_CLIENT_MIC_MUTED', 'Microfoon gedempt', NULL),
(16705, 8, 'VIEWER_CLIENT_COMMANDER', 'Kanaal commandant', NULL),
(16706, 8, 'VIEWER_CLIENT_ICON', 'Cliënt icoon', NULL),
(16707, 8, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Prioriteitspreker', NULL),
(16708, 8, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Spreekkracht toegekend', NULL),
(16709, 8, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Onvoldoende spreekkracht', NULL),
(16710, 8, 'ASSIGNER_NOT_LOGGED_IN', 'Log in voor het gebruiken van de groeptoewijzer', NULL),
(16711, 8, 'ASSIGNER_LOGIN_BUTTON', 'Inloggen', NULL),
(16712, 8, 'ASSIGNER_SAVE_BUTTON', 'Opslaan', NULL),
(16713, 8, 'ASSIGNER_INVALID_GROUPS', 'Ongeldige groepsinstellingen', NULL),
(16714, 8, 'ASSIGNER_NOT_CONFIGURED', 'Groepstoewijzer is niet geconfigureerd door de website administrator.', NULL),
(16715, 8, 'ASSIGNER_SAVE_SUCCESS', 'Je groepen zijn bijgewerkt', NULL),
(16716, 8, 'ASSIGNER_SAVE_ERROR', 'Groepsveranderingsfout', NULL),
(16717, 8, 'ASSIGNER_SAVE_NO_CHANGE', 'Er zijn geen wijzigingen aangebracht', NULL),
(16718, 9, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Nemáš žádnou z potřebných skupin. Nemůžeš použít přiřazování skupin.', NULL),
(16719, 9, 'DATE_FORMAT', 'd.m.Y', NULL),
(16720, 9, 'TIME_FORMAT', 'H:i', NULL),
(16721, 9, 'BANS_HEADER_TARGET', 'Ban', NULL),
(16722, 9, 'AUTHORS', 'MiKE <mike@fungame.eu>\nOndřej Niesner <>', NULL),
(16723, 9, 'COOKIEALERT_MESSAGE', '<b>Tato stránka používá soubory cookies</b> &#x1F36A; Používáme cookies pro zajištění plynulé funkčnosti našich stránek  <a href=\"https://support.mozilla.org/cs/kb/cookies-informace-ktere-si-weby-ukladaji-do-vaseho\" target=\"_blank\">Zjistit více</a>', NULL),
(16724, 9, 'COOKIEALERT_AGREE', 'Souhlasím', NULL),
(16725, 9, 'OUTDATED_DATA', '<b>Varování!</b> Některé informace momentálně nemohou být načteny. Zobrazuji neaktuální data z {0}.', NULL),
(16726, 9, 'SHOW_PROBLEMS', 'Zobrazit problémy', NULL),
(16727, 9, 'PROBLEMS_DESCRIPTION', 'Vyskytl se problém při spojení s TeamSpeak serverem', NULL),
(16728, 9, 'NO_JAVASCRIPT_ENABLED', 'Tato stránka nefunguje bez <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">zapnutého JavaScriptu</a>.', NULL),
(16729, 9, 'CANNOT_GET_DATA', 'Nelze získat informace o \"{0}\"! Prosím kontaktujte správce stránky.', NULL),
(16730, 9, 'NO_REASON_SET', '<b>(důvod neuveden)</b>', NULL),
(16731, 9, 'BANS_HEADER_REASON', 'Důvod', NULL),
(16732, 9, 'BANS_HEADER_INVOKER', 'Zabanoval', NULL),
(16733, 9, 'BANS_HEADER_BANDATE', 'Datum banu', NULL),
(16734, 9, 'BANS_HEADER_EXPIRES', 'Vyprší', NULL),
(16735, 9, 'DATATABLES_LANGUAGE_NAME', 'Czech', NULL),
(16736, 9, 'BANS_NEVEREXPIRES', 'Nikdy', NULL),
(16737, 9, 'STATUS_ADDRESS', 'Adresa:', NULL),
(16738, 9, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(16739, 9, 'STATUS_RESERVED_SLOTS', '{0} rezervovaných slotů', NULL),
(16740, 9, 'STATUS_TOP_ONLINE', 'Nejvíce online:', NULL),
(16741, 9, 'STATUS_TOP_ONLINE_DESC', 'Dosaženo {0}', NULL),
(16742, 9, 'STATUS_UPTIME', 'Běží:', NULL),
(16743, 9, 'STATUS_VERSION', 'Verze:', NULL),
(16744, 9, 'STATUS_VERSION_DESC', '{0} na {1}', NULL),
(16745, 9, 'STATUS_PING', 'Ping', NULL),
(16746, 9, 'STATUS_PACKETLOSS', 'Ztráta paketů', NULL),
(16747, 9, 'STATUS_ERROR', 'Nelze zjistit stav serveru', NULL),
(16748, 9, 'STATUS_PANEL_TITLE', 'Stav serveru', NULL),
(16749, 9, 'DAYJS_LANG', 'cs', NULL),
(16750, 9, 'LOGIN_CONFIRMATION_CODE', 'Zdravím, toto je váš potvrzovací kód pro přihlášení: [b]{0}[/b]', NULL),
(16751, 9, 'UNSUPPORTED_BROWSER', 'Tento prohlížeč není podporován. Prosím použijte nejnovější verzi Chrome, Firefoxu, Safari nebo Edge pro zobrazení této stránky.', NULL),
(16752, 9, 'DATATABLES_PLACEHOLDER_SEARCH', 'Hledat...', NULL),
(16753, 9, 'WEBSITE_TITLE', ' | TS-website Čeština', NULL),
(16754, 9, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(16755, 9, 'ADMIN_STATUS_AWAY', 'Pryč', NULL),
(16756, 9, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(16757, 9, 'ADMIN_STATUS_EMPTY_GROUP', 'Nic k zobrazení', NULL),
(16758, 9, 'ADMIN_STATUS_EMPTY_STATUS', 'Stav adminů je prázdný', NULL),
(16759, 9, 'ASSIGNER_PANEL_TITLE', 'Přiřazování skupin', NULL),
(16760, 9, 'ASSIGNER_TITLE', 'Přiřazování skupin', NULL),
(16761, 9, 'BANS_EMPTY', 'Seznam banů je prázdný', NULL),
(16762, 9, 'BANS_TITLE', 'Seznam Banů', NULL),
(16763, 9, 'BANS_PANEL_TITLE', 'Seznam Banů', NULL),
(16764, 9, 'BANS_BANNED_ALERT_TITLE', 'Vaše IP byla zabanována za {0}', NULL),
(16765, 9, 'BANS_BANNED_ALERT_REASON', 'Důvod: {0}', NULL),
(16766, 9, 'BANS_VIEW_MORE_TIP', 'Klikněte na řádek pro zobrazení více informací o banu', NULL),
(16767, 9, 'RULES_TITLE', 'Pravidla', NULL),
(16768, 9, 'RULES_PANEL_TITLE', 'Pravidla', NULL),
(16769, 9, 'FAQ_COPY_LINK', 'Zkopíruj odkaz do této odpovědi', NULL),
(16770, 9, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16771, 9, 'FAQ_TITLE', 'FAQ', NULL),
(16772, 9, 'FAQ_COPY_LINK_SUCCESS', 'Zkopírováno!', NULL),
(16773, 9, 'FAQ_COPY_LINK_ERROR', 'Chyba!', NULL),
(16774, 9, 'HOME_TITLE', 'Novinky', NULL),
(16775, 9, 'HOME_PANEL_TITLE', 'Novinky', NULL),
(16776, 9, 'HOME_EMPTY', 'Žádné dostupné novinky', NULL),
(16777, 9, 'HOME_INVALID_PAGE', 'špatné číslo stránky', NULL),
(16778, 9, 'HOME_PREVIOUS_NEWS', 'Předchozí', NULL),
(16779, 9, 'HOME_NEXT_NEWS', 'Další', NULL),
(16780, 9, 'ADMIN_STATUS_PANEL_TITLE', 'Stav adminů', NULL),
(16781, 9, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Skrýt offline adminy', NULL),
(16782, 9, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Zobrazit offline adminy', NULL),
(16783, 9, 'ADMIN_STATUS_ERROR', 'Chyba stavu admina', NULL),
(16784, 9, 'NAV_TOGGLE', 'Zobrazit navigaci', NULL),
(16785, 9, 'NAV_VIEWER', 'Náhled serveru', NULL),
(16786, 9, 'NAV_ASSIGNER', 'Skupiny', NULL),
(16787, 9, 'NAV_BANS', 'Bany', NULL),
(16788, 9, 'NAV_RULES', 'Pravidla', NULL),
(16789, 9, 'NAV_FAQ', 'FAQ', NULL),
(16790, 9, 'NAV_ACCOUNT_LOGIN', 'Přihlásit', NULL),
(16791, 9, 'NAV_ACCOUNT_LOGOUT', 'Odhlásit', NULL),
(16792, 9, 'VIEWER_TITLE', 'Náhled serveru', NULL),
(16793, 9, 'VIEWER_PANEL_TITLE', 'Náhled serveru', NULL),
(16794, 9, 'VIEWER_SHOW_EMPTY', 'Zobrazit prázdné místnosti', NULL),
(16795, 9, 'VIEWER_HIDE_EMPTY', 'Skrýt prázdné místnosti', NULL),
(16796, 9, 'VIEWER_TIP_ALERT', 'Klikněte na místnost pro připojení se do ní. Najeďte kurzorem myši na uživatele pro zobrazení informací o něm', NULL),
(16797, 9, 'ARIA_CLOSE', 'Zavřít', NULL),
(16798, 9, 'VIEWER_ERROR', 'Chyba náhledu', NULL),
(16799, 9, 'VIEWER_CONNECTION_CONFIRMATION', 'Chcete se připojit do této místnosti?', NULL),
(16800, 9, 'VIEWER_CLIENT_LASTACTIVE', 'Naposledy aktivní:', NULL),
(16801, 9, 'VIEWER_CLIENT_ONLINE', 'Online čas:', NULL),
(16802, 9, 'VIEWER_CLIENT_JOINED', 'Poprvé připojen:', NULL),
(16803, 9, 'VIEWER_CLIENT_TITLE', 'Informace o klientovi', NULL),
(16804, 9, 'VIEWER_SERVER_ICON', 'Ikona serveru', NULL),
(16805, 9, 'VIEWER_DEFAULT_CHANNEL', 'Hlavní místnost', NULL),
(16806, 9, 'VIEWER_CHANNEL_UNSUB1', ', neodebíraný', NULL),
(16807, 9, 'VIEWER_CHANNEL_OCCUPIED', 'Plně obsazen', NULL),
(16808, 9, 'VIEWER_CHANNEL_PASSWORD', 'Chráněn heslem', NULL),
(16809, 9, 'VIEWER_CHANNEL_UNSUB2', 'Neodebíraný', NULL),
(16810, 9, 'VIEWER_CHANNEL_ICON', 'Ikona místnosti', NULL),
(16811, 9, 'VIEWER_CHANNEL_MODERATED', 'Moderovaný', NULL),
(16812, 9, 'VIEWER_CHANNEL_MUSIC_CODED', 'Hudební kodek', NULL),
(16813, 9, 'VIEWER_CLIENT_AWAY', 'Pryč', NULL),
(16814, 9, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Vypnutý zvuk', NULL),
(16815, 9, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Ohrožený', NULL),
(16816, 9, 'VIEWER_CLIENT_MIC_DISABLED', 'Vypnutý mikrofon', NULL),
(16817, 9, 'VIEWER_CLIENT_MIC_MUTED', 'Ztlumený', NULL),
(16818, 9, 'VIEWER_CLIENT_COMMANDER', 'Channel commander', NULL),
(16819, 9, 'VIEWER_CLIENT_ICON', 'Ikona klienta', NULL),
(16820, 9, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Priority speaker', NULL),
(16821, 9, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Právo mluvit přiděleno', NULL),
(16822, 9, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Nedostatečné právo mluvit', NULL),
(16823, 9, 'ASSIGNER_NOT_LOGGED_IN', 'Pro použití přiřazování skupin se prosím přihlašte', NULL),
(16824, 9, 'ASSIGNER_LOGIN_BUTTON', 'Přihlásit', NULL),
(16825, 9, 'ASSIGNER_SAVE_BUTTON', 'Uložit', NULL),
(16826, 9, 'ASSIGNER_INVALID_GROUPS', 'Špatné nastavení skupiny', NULL),
(16827, 9, 'ASSIGNER_NOT_CONFIGURED', 'Přiřazování skupin není nakonfigurováno správcem stránky', NULL),
(16828, 9, 'ASSIGNER_SAVE_SUCCESS', 'Vaše skupiny byly aktualizovány', NULL),
(16829, 9, 'ASSIGNER_SAVE_ERROR', 'Chyba při změně skupiny', NULL),
(16830, 9, 'ASSIGNER_SAVE_NO_CHANGE', 'Nebyly provedeny žádné změny', NULL),
(16831, 10, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Neked nincsen a szükséges csoportok közül semelyik. Nem használhatod a csoport assignert.', NULL),
(16832, 10, 'DATE_FORMAT', 'Y.M.d', NULL),
(16833, 10, 'TIME_FORMAT', 'H:i', NULL),
(16834, 10, 'BANS_HEADER_TARGET', 'Ban', NULL),
(16835, 10, 'AUTHORS', 'Wruczek <wruczekk@gmail.com>', NULL),
(16836, 10, 'COOKIEALERT_MESSAGE', '<b>Ez az oldal sütiket használ.</b> &#x1F36A; A sütiket annak érdekében használjuk, hogy a legjobb élményt biztosítsuk a weboldalunkon.<a href=\"https://support.mozilla.org/hu/kb/sutik-informacio-amelyet-weboldalak-tarolnak-szami\" target=\"_blank\">Tudj meg többet</a>', NULL),
(16837, 10, 'COOKIEALERT_AGREE', 'Elfogadom', NULL),
(16838, 10, 'OUTDATED_DATA', '<b>Figyelem!</b> Néhány információ jelenleg nem érhető el. Elavult adatok megjelenítése {0}.', NULL),
(16839, 10, 'SHOW_PROBLEMS', 'A problémák megjelenítése', NULL),
(16840, 10, 'PROBLEMS_DESCRIPTION', 'Problémák merültek fel a TeamSpeak szerverhez való csatlakozás során', NULL),
(16841, 10, 'NO_JAVASCRIPT_ENABLED', 'Ez a weboldal nem fog működni  <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript engedélyezése</a>.', NULL),
(16842, 10, 'CANNOT_GET_DATA', 'Nem lehet adatokat kapni \"{0}\"! Kérjük, forduljon a webhely tulajdonosához.', NULL),
(16843, 10, 'NO_REASON_SET', '<b>(nincs indok megadva)</b>', NULL),
(16844, 10, 'BANS_HEADER_REASON', 'Indok', NULL),
(16845, 10, 'BANS_HEADER_INVOKER', 'Bannolva általa', NULL),
(16846, 10, 'BANS_HEADER_BANDATE', 'Ban dátum', NULL),
(16847, 10, 'BANS_HEADER_EXPIRES', 'Lejárat', NULL),
(16848, 10, 'DATATABLES_LANGUAGE_NAME', 'Hungarian', NULL),
(16849, 10, 'BANS_NEVEREXPIRES', 'Soha', NULL),
(16850, 10, 'STATUS_ADDRESS', 'IP Cím:', NULL),
(16851, 10, 'STATUS_CLIENTS_ONLINE', 'Online', NULL),
(16852, 10, 'STATUS_RESERVED_SLOTS', 'Fenntartott helyek: {0}', NULL),
(16853, 10, 'STATUS_TOP_ONLINE', 'Rekord:', NULL),
(16854, 10, 'STATUS_TOP_ONLINE_DESC', 'Kitűntetés elérve: {0}', NULL),
(16855, 10, 'STATUS_UPTIME', 'Üzemidő:', NULL),
(16856, 10, 'STATUS_VERSION', 'Verzió:', NULL),
(16857, 10, 'STATUS_VERSION_DESC', '{0} tovább {1}', NULL),
(16858, 10, 'STATUS_PING', 'Átlagos Ping:', NULL),
(16859, 10, 'STATUS_PACKETLOSS', 'Átlagos Csomagvesztés:', NULL),
(16860, 10, 'STATUS_ERROR', 'Nem lehet letölteni a kiszolgáló állapotát', NULL),
(16861, 10, 'STATUS_PANEL_TITLE', 'Szerver állapota', NULL),
(16862, 10, 'DAYJS_LANG', 'hu', NULL),
(16863, 10, 'LOGIN_CONFIRMATION_CODE', 'Üdvözöllek ez a bejelentkezési kódod az oldalra: [b]{0}[/b]', NULL),
(16864, 10, 'UNSUPPORTED_BROWSER', 'A böngésződ nem támogatott. A weboldal használatához váltson a Chrome, a Firefox, a Safari vagy az Edge legújabb verziójára között.', NULL),
(16865, 10, 'DATATABLES_PLACEHOLDER_SEARCH', 'Keresés...', NULL),
(16866, 10, 'WEBSITE_TITLE', ' | TS-weboldal Magyar nyelven', NULL),
(16867, 10, 'ADMIN_STATUS_ONLINE', 'Elérhető', NULL),
(16868, 10, 'ADMIN_STATUS_AWAY', 'Távol', NULL),
(16869, 10, 'ADMIN_STATUS_OFFLINE', 'Nem elérhető', NULL),
(16870, 10, 'ADMIN_STATUS_EMPTY_GROUP', 'Semmit sem mutat', NULL),
(16871, 10, 'ADMIN_STATUS_EMPTY_STATUS', 'Az Admin állapot jelenleg üres', NULL),
(16872, 10, 'ASSIGNER_PANEL_TITLE', 'Csoport hozzárendelő', NULL),
(16873, 10, 'ASSIGNER_TITLE', 'Csoport hozzárendelő', NULL),
(16874, 10, 'BANS_EMPTY', 'A banlista jelenleg üres', NULL),
(16875, 10, 'BANS_TITLE', 'Banlista', NULL),
(16876, 10, 'BANS_PANEL_TITLE', 'Banlista', NULL),
(16877, 10, 'BANS_BANNED_ALERT_TITLE', 'A te IP címed bannolva van általa: {0}', NULL),
(16878, 10, 'BANS_BANNED_ALERT_REASON', 'Indok: {0}', NULL),
(16879, 10, 'BANS_VIEW_MORE_TIP', 'Kattints egy sorra, ha többet szeretnél megtudni a ban-ról', NULL),
(16880, 10, 'RULES_TITLE', 'Szabályzat', NULL),
(16881, 10, 'RULES_PANEL_TITLE', 'Szabályzat', NULL),
(16882, 10, 'FAQ_COPY_LINK', 'Hivatkozás másolása erre a válaszra', NULL),
(16883, 10, 'FAQ_PANEL_TITLE', 'GYIK', NULL),
(16884, 10, 'FAQ_TITLE', 'GYIK', NULL),
(16885, 10, 'FAQ_COPY_LINK_SUCCESS', 'Másolva!', NULL),
(16886, 10, 'FAQ_COPY_LINK_ERROR', 'Hiba!', NULL),
(16887, 10, 'HOME_TITLE', 'Hírek', NULL),
(16888, 10, 'HOME_PANEL_TITLE', 'Hírek', NULL),
(16889, 10, 'HOME_EMPTY', 'Nincsenek elérhető hírek', NULL),
(16890, 10, 'HOME_INVALID_PAGE', 'Érvénytelen oldalszám', NULL),
(16891, 10, 'HOME_PREVIOUS_NEWS', 'Előző', NULL),
(16892, 10, 'HOME_NEXT_NEWS', 'Következő', NULL),
(16893, 10, 'ADMIN_STATUS_PANEL_TITLE', 'Csapattagok', NULL),
(16894, 10, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Az offline adminok elrejtése', NULL),
(16895, 10, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Offline adminok megjelenítése', NULL),
(16896, 10, 'ADMIN_STATUS_ERROR', 'Admin állapot hiba', NULL),
(16897, 10, 'NAV_TOGGLE', 'Toggle navigation', NULL),
(16898, 10, 'NAV_VIEWER', 'Néző', NULL),
(16899, 10, 'NAV_ASSIGNER', 'Kijelölő', NULL),
(16900, 10, 'NAV_BANS', 'Bannok', NULL),
(16901, 10, 'NAV_RULES', 'Szabályok', NULL),
(16902, 10, 'NAV_FAQ', 'GYIK', NULL),
(16903, 10, 'NAV_ACCOUNT_LOGIN', 'Bejelentkezés', NULL),
(16904, 10, 'NAV_ACCOUNT_LOGOUT', 'Kijelentkezés', NULL),
(16905, 10, 'VIEWER_TITLE', 'Szerver Néző', NULL),
(16906, 10, 'VIEWER_PANEL_TITLE', 'Szerver Néző', NULL),
(16907, 10, 'VIEWER_SHOW_EMPTY', 'Üres szobák megjelenítése', NULL),
(16908, 10, 'VIEWER_HIDE_EMPTY', 'Üres szobák elrejtése', NULL),
(16909, 10, 'VIEWER_TIP_ALERT', 'Kattints egy szobára a csatlakozáshoz. Vidd rá az egeret egy névre az egyéb információért.', NULL),
(16910, 10, 'ARIA_CLOSE', 'Bezárás', NULL),
(16911, 10, 'VIEWER_ERROR', 'Figyelői hiba', NULL),
(16912, 10, 'VIEWER_CONNECTION_CONFIRMATION', 'Biztos szeretnél csatlakozni az adott szobához?', NULL),
(16913, 10, 'VIEWER_CLIENT_LASTACTIVE', 'Utoljára aktív:', NULL),
(16914, 10, 'VIEWER_CLIENT_ONLINE', 'Online idő:', NULL),
(16915, 10, 'VIEWER_CLIENT_JOINED', 'Első csatlakozás:', NULL),
(16916, 10, 'VIEWER_CLIENT_TITLE', 'Adatok', NULL),
(16917, 10, 'VIEWER_SERVER_ICON', 'Szerver icon', NULL),
(16918, 10, 'VIEWER_DEFAULT_CHANNEL', 'Alapértelmezett szoba', NULL),
(16919, 10, 'VIEWER_CHANNEL_UNSUB1', 'leiratkozott', NULL),
(16920, 10, 'VIEWER_CHANNEL_OCCUPIED', 'Limitált szoba', NULL),
(16921, 10, 'VIEWER_CHANNEL_PASSWORD', 'Jelszóval-védett', NULL),
(16922, 10, 'VIEWER_CHANNEL_UNSUB2', 'Leiratkozott', NULL),
(16923, 10, 'VIEWER_CHANNEL_ICON', 'Szoba icon', NULL),
(16924, 10, 'VIEWER_CHANNEL_MODERATED', 'Moderált', NULL),
(16925, 10, 'VIEWER_CHANNEL_MUSIC_CODED', 'Zene codec', NULL),
(16926, 10, 'VIEWER_CLIENT_AWAY', 'Távol van', NULL),
(16927, 10, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Hang kikapcsolva', NULL),
(16928, 10, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Deafened', NULL),
(16929, 10, 'VIEWER_CLIENT_MIC_DISABLED', 'Mikrofon kikapcsolva', NULL),
(16930, 10, 'VIEWER_CLIENT_MIC_MUTED', 'Némítva', NULL),
(16931, 10, 'VIEWER_CLIENT_COMMANDER', 'Channel commander', NULL),
(16932, 10, 'VIEWER_CLIENT_ICON', 'Kliens ikon', NULL),
(16933, 10, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Elsődleges beszélő', NULL),
(16934, 10, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Beszéd jogot kapott', NULL),
(16935, 10, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Nincs elég beszéd joga', NULL),
(16936, 10, 'ASSIGNER_NOT_LOGGED_IN', 'Jelentkezzen be a csoportos hozzárendelő használata előtt', NULL),
(16937, 10, 'ASSIGNER_LOGIN_BUTTON', 'Bejelentkezés', NULL),
(16938, 10, 'ASSIGNER_SAVE_BUTTON', 'Mentve', NULL),
(16939, 10, 'ASSIGNER_INVALID_GROUPS', 'Érvénytelen csoportbeállítások', NULL),
(16940, 10, 'ASSIGNER_NOT_CONFIGURED', 'A csoport-hozzárendelő nem lett bekonfigolva a oldal tulajdonosa által', NULL),
(16941, 10, 'ASSIGNER_SAVE_SUCCESS', 'A te csoportod frissítve lett', NULL),
(16942, 10, 'ASSIGNER_SAVE_ERROR', 'Csoportváltozási hiba', NULL),
(16943, 10, 'ASSIGNER_SAVE_NO_CHANGE', 'Nem történt módosítás', NULL),
(16944, 11, 'DATE_FORMAT', 'd.m.Y', NULL),
(16945, 11, 'TIME_FORMAT', 'H:i', NULL),
(16946, 11, 'AUTHORS', 'kidi <admin@goodgame.by>', NULL),
(16947, 11, 'COOKIEALERT_MESSAGE', '<b>Вам падабаюцца куки?</b> &#x1F36A; Мы выкарыстоўваем куки для забеспячэння найлепшага вопыту на нашым сайце. <a href=\"https://support.mozilla.org/ru/kb/kuki-informaciya-kotoruyu-veb-sajty-hranyat-na-vas\" target=\"_blank\">Даведацца больш</a>', NULL),
(16948, 11, 'COOKIEALERT_AGREE', 'Я згодны', NULL),
(16949, 11, 'OUTDATED_DATA', '<b>Увага!</b> Не ўдалося атрымаць актуальную інфармацыю з сервера. Адлюстроўваецца інфармацыя ад {0}', NULL),
(16950, 11, 'SHOW_PROBLEMS', 'Паказаць праблемы', NULL),
(16951, 11, 'PROBLEMS_DESCRIPTION', 'Пры падключэнні да сервера TeamSpeak адбыліся памылкі', NULL),
(16952, 11, 'NO_JAVASCRIPT_ENABLED', 'Дадзены сайт не будзе працаваць пры адключаным <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript</a>', NULL),
(16953, 11, 'CANNOT_GET_DATA', 'Не ўдалося атрымаць дадзеныя для модуля \"{0}\"! Калі ласка звяжыцеся з уладальнікам сайта.', NULL),
(16954, 11, 'NO_REASON_SET', '<b>(прычына не зазначана)</b>', NULL),
(16955, 11, 'BANS_HEADER_REASON', 'Прычына', NULL),
(16956, 11, 'BANS_HEADER_INVOKER', 'Заблакаваў', NULL),
(16957, 11, 'BANS_HEADER_BANDATE', 'Бан створан', NULL),
(16958, 11, 'BANS_HEADER_EXPIRES', 'Заканчваецца', NULL),
(16959, 11, 'DATATABLES_LANGUAGE_NAME', 'Belarusian', NULL),
(16960, 11, 'BANS_NEVEREXPIRES', 'Ніколі', NULL),
(16961, 11, 'STATUS_ADDRESS', 'Адрас:', NULL),
(16962, 11, 'STATUS_CLIENTS_ONLINE', 'Анлайн:', NULL),
(16963, 11, 'STATUS_RESERVED_SLOTS', '{0} зарэзервавана', NULL),
(16964, 11, 'STATUS_TOP_ONLINE', 'Макс. онлайн', NULL),
(16965, 11, 'STATUS_TOP_ONLINE_DESC', 'Дасягнуты {0}', NULL),
(16966, 11, 'STATUS_UPTIME', 'Аптайм:', NULL),
(16967, 11, 'STATUS_VERSION', 'Версія:', NULL),
(16968, 11, 'STATUS_VERSION_DESC', '{0} на {1}', NULL),
(16969, 11, 'STATUS_PING', 'Сярэдні пінг:', NULL),
(16970, 11, 'STATUS_PACKETLOSS', 'Страта пакетаў:', NULL),
(16971, 11, 'STATUS_ERROR', 'Немагчыма атрымаць статус сервера', NULL),
(16972, 11, 'STATUS_PANEL_TITLE', 'Статус сервера', NULL),
(16973, 11, 'DAYJS_LANG', 'be', NULL),
(16974, 11, 'LOGIN_CONFIRMATION_CODE', 'Вітаем! Вось ваш код пацверджання: [b]{0}[/b]', NULL),
(16975, 11, 'UNSUPPORTED_BROWSER', 'Ваш браўзэр не падтрымліваецца. Калі ласка, ўстанавіце Chrome, Firefox, Safari або Edge.', NULL),
(16976, 11, 'DATATABLES_PLACEHOLDER_SEARCH', 'Пошук...', NULL),
(16977, 11, 'WEBSITE_TITLE', ' | Беларуская мова TS-website', NULL),
(16978, 11, 'ADMIN_STATUS_ONLINE', 'Анлайн', NULL),
(16979, 11, 'ADMIN_STATUS_AWAY', 'Адышоў', NULL),
(16980, 11, 'ADMIN_STATUS_OFFLINE', 'Афлайн', NULL),
(16981, 11, 'ADMIN_STATUS_EMPTY_GROUP', 'Няма чаго паказваць', NULL),
(16982, 11, 'ADMIN_STATUS_EMPTY_STATUS', 'Статус адміністратара пусты', NULL),
(16983, 11, 'ASSIGNER_PANEL_TITLE', 'Групы', NULL),
(16984, 11, 'ASSIGNER_TITLE', 'Групы', NULL),
(16985, 11, 'BANS_EMPTY', 'Спіс банаў пусты', NULL),
(16986, 11, 'BANS_TITLE', 'Баны', NULL),
(16987, 11, 'BANS_PANEL_TITLE', 'Баны', NULL),
(16988, 11, 'BANS_BANNED_ALERT_TITLE', 'Ваш IP забанен адміністратарам {0}', NULL),
(16989, 11, 'BANS_BANNED_ALERT_REASON', 'Прычына: {0}', NULL),
(16990, 11, 'BANS_VIEW_MORE_TIP', 'Націсніце на радок для адлюстравання дэталяў аб бане', NULL),
(16991, 11, 'RULES_TITLE', 'Правілы', NULL),
(16992, 11, 'RULES_PANEL_TITLE', 'Правілы', NULL),
(16993, 11, 'FAQ_COPY_LINK', 'Скапіяваць спасылку на гэты адказ', NULL),
(16994, 11, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(16995, 11, 'FAQ_TITLE', 'FAQ', NULL),
(16996, 11, 'FAQ_COPY_LINK_SUCCESS', 'Скапіявана!', NULL),
(16997, 11, 'FAQ_COPY_LINK_ERROR', 'Памылка!', NULL),
(16998, 11, 'HOME_TITLE', 'Навіны', NULL),
(16999, 11, 'HOME_PANEL_TITLE', 'Навіны', NULL),
(17000, 11, 'HOME_EMPTY', 'На дадзены момант няма навін', NULL),
(17001, 11, 'HOME_INVALID_PAGE', 'Няправільны нумар старонкі', NULL),
(17002, 11, 'HOME_PREVIOUS_NEWS', 'Назад', NULL),
(17003, 11, 'HOME_NEXT_NEWS', 'Наперад', NULL),
(17004, 11, 'ADMIN_STATUS_PANEL_TITLE', 'Статус адміністрацыі', NULL),
(17005, 11, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Схаваць адключаных адміністратараў', NULL),
(17006, 11, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Паказаць адключаных адміністратараў', NULL),
(17007, 11, 'ADMIN_STATUS_ERROR', 'Памылка статусу адміністратара', NULL),
(17008, 11, 'NAV_TOGGLE', 'Пераключыць навігацыю', NULL),
(17009, 11, 'NAV_VIEWER', 'Агляд', NULL),
(17010, 11, 'NAV_ASSIGNER', 'Группы', NULL),
(17011, 11, 'NAV_BANS', 'Блакаванні', NULL),
(17012, 11, 'NAV_RULES', 'Правілы', NULL),
(17013, 11, 'NAV_FAQ', 'FAQ', NULL),
(17014, 11, 'NAV_ACCOUNT_LOGIN', 'Увайсці', NULL),
(17015, 11, 'NAV_ACCOUNT_LOGOUT', 'Выйсці', NULL),
(17016, 11, 'VIEWER_TITLE', 'Агляд сервера', NULL),
(17017, 11, 'VIEWER_PANEL_TITLE', 'Агляд сервера', NULL),
(17018, 11, 'VIEWER_SHOW_EMPTY', 'Паказаць пустыя каналы', NULL),
(17019, 11, 'VIEWER_HIDE_EMPTY', 'Схаваць пустыя каналы', NULL),
(17020, 11, 'VIEWER_TIP_ALERT', 'Для ўваходу ў канал націсніце на яго. Навядзіце курсор над карыстальнікам для адлюстравання інфармацыі', NULL),
(17021, 11, 'ARIA_CLOSE', 'Закрыць', NULL),
(17022, 11, 'VIEWER_ERROR', 'Памылка пры аглядзе сервера', NULL),
(17023, 11, 'VIEWER_CONNECTION_CONFIRMATION', 'Вы хочаце увайсці ў гэты канал?', NULL),
(17024, 11, 'VIEWER_CLIENT_LASTACTIVE', 'Апошнія дзеянні:', NULL),
(17025, 11, 'VIEWER_CLIENT_ONLINE', 'Час анлайн:', NULL),
(17026, 11, 'VIEWER_CLIENT_JOINED', 'Першае падключэнне:', NULL),
(17027, 11, 'VIEWER_CLIENT_TITLE', 'Інфармацыя пра кліента', NULL),
(17028, 11, 'VIEWER_SERVER_ICON', 'Іконка сервера', NULL),
(17029, 11, 'VIEWER_DEFAULT_CHANNEL', 'Стандартны канал', NULL),
(17030, 11, 'VIEWER_CHANNEL_UNSUB1', ', не падпісаны', NULL),
(17031, 11, 'VIEWER_CHANNEL_OCCUPIED', 'Запоўнены', NULL),
(17032, 11, 'VIEWER_CHANNEL_PASSWORD', 'Абаронены паролем', NULL),
(17033, 11, 'VIEWER_CHANNEL_UNSUB2', 'Не падпісаны', NULL),
(17034, 11, 'VIEWER_CHANNEL_ICON', 'Іконка канала', NULL),
(17035, 11, 'VIEWER_CHANNEL_MODERATED', 'Кіраваны', NULL),
(17036, 11, 'VIEWER_CHANNEL_MUSIC_CODED', 'Opus для музыкі', NULL),
(17037, 11, 'VIEWER_CLIENT_AWAY', 'Адышоў', NULL),
(17038, 11, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Гук адключаны', NULL),
(17039, 11, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Прыглушаны', NULL),
(17040, 11, 'VIEWER_CLIENT_MIC_DISABLED', 'Мікрафон адключаны', NULL),
(17041, 11, 'VIEWER_CLIENT_MIC_MUTED', 'Заглушаны', NULL),
(17042, 11, 'VIEWER_CLIENT_COMMANDER', 'Камандзір канала', NULL),
(17043, 11, 'VIEWER_CLIENT_ICON', 'Іконка кліента', NULL),
(17044, 11, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Прыярытэт голаса', NULL),
(17045, 11, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Права голасу атрымана', NULL),
(17046, 11, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Недастаткова праў голаса', NULL),
(17047, 11, 'ASSIGNER_NOT_LOGGED_IN', 'Аўтарызуйцеся перад выкарыстаннем мэнэджара груп', NULL),
(17048, 11, 'ASSIGNER_LOGIN_BUTTON', 'Лагін', NULL),
(17049, 11, 'ASSIGNER_SAVE_BUTTON', 'Захаваць', NULL),
(17050, 11, 'ASSIGNER_INVALID_GROUPS', 'Няверныя настройкі груп', NULL),
(17051, 11, 'ASSIGNER_NOT_CONFIGURED', 'Менеджэр груп не быў настроены адміністратарам сайта', NULL),
(17052, 11, 'ASSIGNER_SAVE_SUCCESS', 'Вашы групы былі абноўленыя', NULL),
(17053, 11, 'ASSIGNER_SAVE_ERROR', 'Памылка пры змене групы', NULL),
(17054, 11, 'ASSIGNER_SAVE_NO_CHANGE', 'Змены не былі захаваны', NULL),
(17055, 12, 'DATE_FORMAT', 'd.m.Y', NULL),
(17056, 12, 'TIME_FORMAT', 'H:i', NULL),
(17057, 12, 'AUTHORS', 'R3TR0Piha <protony16@gmail.com>', NULL),
(17058, 12, 'COOKIEALERT_MESSAGE', '<b>Da li voliš kolačiće?</b> &#x1F36A; Ova stranica koristi kolačiće za najbolje doživljaje!. <a href=\"https://support.mozilla.org/en-US/kb/cookies-information-websites-store-on-your-computer\" target=\"_blank\">Pročitaj više</a>', NULL),
(17059, 12, 'COOKIEALERT_AGREE', 'Prihvaćam', NULL),
(17060, 12, 'OUTDATED_DATA', '<b>Upozorenje!</b> Neke informacije su nedostupne. Prikazuju se zastarjeli podaci od {0}.', NULL),
(17061, 12, 'SHOW_PROBLEMS', 'Prikaži greške', NULL),
(17062, 12, 'PROBLEMS_DESCRIPTION', 'Problemi na koje ste naišli tijekom povezivanja s TeamSpeak poslužiteljem', NULL),
(17063, 12, 'NO_JAVASCRIPT_ENABLED', 'Ova stranica neće raditi bez <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript enabled</a>.', NULL),
(17064, 12, 'CANNOT_GET_DATA', 'Nije moguće dobiti podatke za \"{0}\"! Kontaktirajte vlasnika web-lokacije.', NULL),
(17065, 12, 'NO_REASON_SET', '<b>(razlog nije postavljen)</b>', NULL),
(17066, 12, 'BANS_HEADER_REASON', 'Razlog', NULL),
(17067, 12, 'BANS_HEADER_INVOKER', 'Banan od', NULL),
(17068, 12, 'BANS_HEADER_BANDATE', 'Datum bana', NULL),
(17069, 12, 'BANS_HEADER_EXPIRES', 'Istječe', NULL),
(17070, 12, 'DATATABLES_LANGUAGE_NAME', 'Croatian', NULL),
(17071, 12, 'BANS_NEVEREXPIRES', 'Nikada', NULL),
(17072, 12, 'STATUS_ADDRESS', 'Adresa:', NULL),
(17073, 12, 'STATUS_CLIENTS_ONLINE', 'Na mreži:', NULL),
(17074, 12, 'STATUS_RESERVED_SLOTS', '{0} rezervirana mjesta', NULL),
(17075, 12, 'STATUS_TOP_ONLINE', 'Najviše na mreži:', NULL),
(17076, 12, 'STATUS_TOP_ONLINE_DESC', 'Postignuto na {0}', NULL),
(17077, 12, 'STATUS_UPTIME', 'Uptime:', NULL),
(17078, 12, 'STATUS_VERSION', 'Verzija:', NULL),
(17079, 12, 'STATUS_VERSION_DESC', '{0} na {1}', NULL),
(17080, 12, 'STATUS_PING', 'Avg. ping:', NULL),
(17081, 12, 'STATUS_PACKETLOSS', 'Avg. packet loss:', NULL),
(17082, 12, 'STATUS_ERROR', 'Status servera nije moguće dohvatiti', NULL),
(17083, 12, 'STATUS_PANEL_TITLE', 'Status servera', NULL),
(17084, 12, 'DAYJS_LANG', 'hr', NULL),
(17085, 12, 'LOGIN_CONFIRMATION_CODE', 'Pozdrav, ovdje je tvoj kod potvrde za prijavu: [b]{0}[/b]', NULL),
(17086, 12, 'UNSUPPORTED_BROWSER', 'Vaš preglednik nije podržan. Prebacite se na najnoviju verziju preglednika Chrome, Firefox, Safari ili Edge da biste koristili ovu web-lokaciju.', NULL),
(17087, 12, 'DATATABLES_PLACEHOLDER_SEARCH', 'Traži...', NULL),
(17088, 12, 'WEBSITE_TITLE', '| TS-web stranica Bosanski jezik', NULL),
(17089, 12, 'ADMIN_STATUS_ONLINE', 'Na mreži', NULL),
(17090, 12, 'ADMIN_STATUS_AWAY', 'Otišao', NULL),
(17091, 12, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(17092, 12, 'ADMIN_STATUS_EMPTY_GROUP', 'Nema ništa za prikazati', NULL),
(17093, 12, 'ADMIN_STATUS_EMPTY_STATUS', 'Status administratora je prazan', NULL),
(17094, 12, 'ASSIGNER_PANEL_TITLE', 'Dodjeljivač grupe', NULL),
(17095, 12, 'ASSIGNER_TITLE', 'Dodjeljivač grupe', NULL),
(17096, 12, 'BANS_EMPTY', 'Ban lista je prazna', NULL),
(17097, 12, 'BANS_TITLE', 'Ban lista', NULL),
(17098, 12, 'BANS_PANEL_TITLE', 'Ban lista', NULL),
(17099, 12, 'BANS_BANNED_ALERT_TITLE', 'Tvoj IP je banan od {0}', NULL),
(17100, 12, 'BANS_BANNED_ALERT_REASON', 'Razlog: {0}', NULL),
(17101, 12, 'BANS_VIEW_MORE_TIP', 'Kliknite na redak da biste vidjeli više pojedinosti o banu', NULL),
(17102, 12, 'RULES_TITLE', 'Pravila', NULL),
(17103, 12, 'RULES_PANEL_TITLE', 'Pravila', NULL),
(17104, 12, 'FAQ_COPY_LINK', 'Kopirajte vezu na taj odgovor', NULL),
(17105, 12, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(17106, 12, 'FAQ_TITLE', 'FAQ', NULL),
(17107, 12, 'FAQ_COPY_LINK_SUCCESS', 'Kopirano!', NULL),
(17108, 12, 'FAQ_COPY_LINK_ERROR', 'Greška!', NULL),
(17109, 12, 'HOME_TITLE', 'Novosti', NULL),
(17110, 12, 'HOME_PANEL_TITLE', 'Novosti', NULL),
(17111, 12, 'HOME_EMPTY', 'Vijesti trenutno nisu dostupne', NULL),
(17112, 12, 'HOME_INVALID_PAGE', 'Nevažeći broj stranice', NULL),
(17113, 12, 'HOME_PREVIOUS_NEWS', 'Prijašnja', NULL),
(17114, 12, 'HOME_NEXT_NEWS', 'Sljedeća', NULL),
(17115, 12, 'ADMIN_STATUS_PANEL_TITLE', 'Admin status\n', NULL),
(17116, 12, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Sakrij offline admine', NULL),
(17117, 12, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Prikaži  offline admine', NULL),
(17118, 12, 'ADMIN_STATUS_ERROR', 'Pogreška statusa administratora', NULL),
(17119, 12, 'NAV_TOGGLE', 'Uključi navigaciju', NULL),
(17120, 12, 'NAV_VIEWER', 'Preglednik', NULL),
(17121, 12, 'NAV_ASSIGNER', 'dodjeljivač', NULL),
(17122, 12, 'NAV_BANS', 'Banovi', NULL),
(17123, 12, 'NAV_RULES', 'Pravila', NULL),
(17124, 12, 'NAV_FAQ', 'FAQ', NULL),
(17125, 12, 'NAV_ACCOUNT_LOGIN', 'Prijava', NULL),
(17126, 12, 'NAV_ACCOUNT_LOGOUT', 'Odjavi se', NULL),
(17127, 12, 'VIEWER_TITLE', 'Pregled servera', NULL),
(17128, 12, 'VIEWER_PANEL_TITLE', 'Pregled servera', NULL),
(17129, 12, 'VIEWER_SHOW_EMPTY', 'Prikaži prazne kanale', NULL),
(17130, 12, 'VIEWER_HIDE_EMPTY', 'Sakrij prazne kanale', NULL),
(17131, 12, 'VIEWER_TIP_ALERT', 'Kliknite kanal da biste mu se pridružili. Zadržite pokazivač iznad korisnika da biste provjerili njihove informacije', NULL),
(17132, 12, 'ARIA_CLOSE', 'Zatvori', NULL),
(17133, 12, 'VIEWER_ERROR', 'Pogreška preglednika\n', NULL),
(17134, 12, 'VIEWER_CONNECTION_CONFIRMATION', 'Želite li se povezati s ovim kanalom?', NULL),
(17135, 12, 'VIEWER_CLIENT_LASTACTIVE', 'Posljednja aktivnost:', NULL),
(17136, 12, 'VIEWER_CLIENT_ONLINE', 'Vrijeme na mreži:', NULL),
(17137, 12, 'VIEWER_CLIENT_JOINED', 'Prvi se pridružio:', NULL),
(17138, 12, 'VIEWER_CLIENT_TITLE', 'Informacije o klijentu', NULL),
(17139, 12, 'VIEWER_SERVER_ICON', 'Ikona servera', NULL),
(17140, 12, 'VIEWER_DEFAULT_CHANNEL', 'Početni kanal', NULL),
(17141, 12, 'VIEWER_CHANNEL_UNSUB1', ', odjavili ste se', NULL),
(17142, 12, 'VIEWER_CHANNEL_OCCUPIED', 'Potpuno zauzeta', NULL),
(17143, 12, 'VIEWER_CHANNEL_PASSWORD', 'Lozinka zaštićena', NULL),
(17144, 12, 'VIEWER_CHANNEL_UNSUB2', 'poništili pretplatu\n', NULL),
(17145, 12, 'VIEWER_CHANNEL_ICON', 'Ikona kanala', NULL),
(17146, 12, 'VIEWER_CHANNEL_MODERATED', 'Moderirano', NULL),
(17147, 12, 'VIEWER_CHANNEL_MUSIC_CODED', 'Glazbeni codec', NULL),
(17148, 12, 'VIEWER_CLIENT_AWAY', 'Otišao', NULL),
(17149, 12, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Isključen zvuk', NULL),
(17150, 12, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Zaglušena', NULL),
(17151, 12, 'VIEWER_CLIENT_MIC_DISABLED', 'Isključen mikrofon', NULL),
(17152, 12, 'VIEWER_CLIENT_MIC_MUTED', 'Ušutkan', NULL),
(17153, 12, 'VIEWER_CLIENT_COMMANDER', 'Komander kanala', NULL),
(17154, 12, 'VIEWER_CLIENT_ICON', 'Ikona korisnika', NULL),
(17155, 12, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Prioritetni zvučnik', NULL),
(17156, 12, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Dobio si snagu razgovaranja', NULL),
(17157, 12, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Nedovoljna snaga razgovora', NULL),
(17158, 12, 'ASSIGNER_NOT_LOGGED_IN', 'Prijavi se prije korištenja dodjeljivača grupe', NULL),
(17159, 12, 'ASSIGNER_LOGIN_BUTTON', 'Prijava', NULL),
(17160, 12, 'ASSIGNER_SAVE_BUTTON', 'Spremi', NULL),
(17161, 12, 'ASSIGNER_INVALID_GROUPS', 'Nevažeće postavke grupe\n', NULL),
(17162, 12, 'ASSIGNER_NOT_CONFIGURED', 'Administrator web-lokacije ne konfigurira dodjeljivača grupe', NULL),
(17163, 12, 'ASSIGNER_SAVE_SUCCESS', 'Vaše su grupe ažurirane', NULL),
(17164, 12, 'ASSIGNER_SAVE_ERROR', 'Pogreška promjene grupe', NULL),
(17165, 12, 'ASSIGNER_SAVE_NO_CHANGE', 'Nema promjena', NULL),
(17166, 13, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Você não tem nenhum dos grupos necessários. Você não pode usar o atribuidor de grupo.', NULL),
(17167, 13, 'DATE_FORMAT', 'd.m.Y', NULL),
(17168, 13, 'TIME_FORMAT', 'H:i', NULL),
(17169, 13, 'BANS_HEADER_TARGET', 'Ban', NULL),
(17170, 13, 'AUTHORS', 'Wruczek <wruczekk@gmail.com>', NULL),
(17171, 13, 'COOKIEALERT_MESSAGE', '<b>Gosta de cookies?</b> &#x1F36A; Usamos cookies para garantir que você obtenha a melhor experiência em nosso site. <a href=\"https://support.mozilla.org/en-US/kb/cookies-information-websites-store-on-your-computer\" target=\"_blank\"> Saiba mais</a>', NULL),
(17172, 13, 'COOKIEALERT_AGREE', 'Aceito', NULL),
(17173, 13, 'OUTDATED_DATA', '<b>Atenção!</b> Algumas informações não podem ser obtidas agora. Mostrando dados desatualizados de {0}.', NULL),
(17174, 13, 'SHOW_PROBLEMS', 'Mostrar problemas', NULL),
(17175, 13, 'PROBLEMS_DESCRIPTION', 'Problemas encontrados durante a conexão com o servidor TeamSpeak', NULL),
(17176, 13, 'NO_JAVASCRIPT_ENABLED', 'Este website não funcionará sem o <a href=\"https://www.enable-javascript.com/\" target=\"_blank\"> JavaScript ativado</a>.', NULL),
(17177, 13, 'CANNOT_GET_DATA', 'Não é possível obter dados para \"{0}\"!  Entre em contato com o dono do site.', NULL),
(17178, 13, 'NO_REASON_SET', '<b>(sem razão definida)</b>', NULL),
(17179, 13, 'BANS_HEADER_REASON', 'Razão', NULL),
(17180, 13, 'BANS_HEADER_INVOKER', 'Banido por', NULL),
(17181, 13, 'BANS_HEADER_BANDATE', 'Data do ban', NULL),
(17182, 13, 'BANS_HEADER_EXPIRES', 'Expira', NULL),
(17183, 13, 'DATATABLES_LANGUAGE_NAME', 'Portuguese', NULL),
(17184, 13, 'BANS_NEVEREXPIRES', 'Nunca', NULL),
(17185, 13, 'STATUS_ADDRESS', 'Endereço:', NULL),
(17186, 13, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(17187, 13, 'STATUS_RESERVED_SLOTS', '{0} slots reservados', NULL),
(17188, 13, 'STATUS_TOP_ONLINE', 'Top online:', NULL),
(17189, 13, 'STATUS_TOP_ONLINE_DESC', 'Alcançado em {0}', NULL),
(17190, 13, 'STATUS_UPTIME', 'Uptime:', NULL),
(17191, 13, 'STATUS_VERSION', 'Versão:', NULL),
(17192, 13, 'STATUS_VERSION_DESC', '{0} em {1}', NULL),
(17193, 13, 'STATUS_PING', 'Ping médio:', NULL),
(17194, 13, 'STATUS_PACKETLOSS', 'Perda de pacotes média:', NULL),
(17195, 13, 'STATUS_ERROR', 'Falha a obter o status do servidor', NULL),
(17196, 13, 'STATUS_PANEL_TITLE', 'Status do servidor', NULL),
(17197, 13, 'DAYJS_LANG', 'pt-br', NULL),
(17198, 13, 'LOGIN_CONFIRMATION_CODE', 'Olá, aqui está o seu código de confirmação para fazer login: [b]{0}[/b]', NULL),
(17199, 13, 'UNSUPPORTED_BROWSER', 'Seu navegador não é suportado.  Mude para a versão mais recente do Chrome, Firefox, Safari ou Edge para usar este site.', NULL),
(17200, 13, 'DATATABLES_PLACEHOLDER_SEARCH', 'Procurar...', NULL),
(17201, 13, 'WEBSITE_TITLE', ' | TS-website Língua Inglesa', NULL),
(17202, 13, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(17203, 13, 'ADMIN_STATUS_AWAY', 'Ausente', NULL),
(17204, 13, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(17205, 13, 'ADMIN_STATUS_EMPTY_GROUP', 'Nada para mostrar', NULL),
(17206, 13, 'ADMIN_STATUS_EMPTY_STATUS', 'O status do administrador está vazio', NULL),
(17207, 13, 'ASSIGNER_PANEL_TITLE', 'Atribuidor de grupos', NULL),
(17208, 13, 'ASSIGNER_TITLE', 'Atribuidor de grupos', NULL),
(17209, 13, 'BANS_EMPTY', 'A lista de bans está vazia', NULL),
(17210, 13, 'BANS_TITLE', 'Lista de bans', NULL),
(17211, 13, 'BANS_PANEL_TITLE', 'Lista de bans', NULL),
(17212, 13, 'BANS_BANNED_ALERT_TITLE', 'Seu IP foi banido por {0}', NULL),
(17213, 13, 'BANS_BANNED_ALERT_REASON', 'Razão: {0}', NULL),
(17214, 13, 'BANS_VIEW_MORE_TIP', 'Clique em uma linha para ver mais detalhes sobre o ban', NULL),
(17215, 13, 'RULES_TITLE', 'Regras', NULL),
(17216, 13, 'RULES_PANEL_TITLE', 'Regras', NULL),
(17217, 13, 'FAQ_COPY_LINK', 'Copia o link para essa resposta', NULL),
(17218, 13, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(17219, 13, 'FAQ_TITLE', 'FAQ', NULL),
(17220, 13, 'FAQ_COPY_LINK_SUCCESS', 'Copiado!', NULL),
(17221, 13, 'FAQ_COPY_LINK_ERROR', 'Erro!', NULL),
(17222, 13, 'HOME_TITLE', 'Notícias', NULL),
(17223, 13, 'HOME_PANEL_TITLE', 'Notícias', NULL),
(17224, 13, 'HOME_EMPTY', 'Sem notícias disponíveis de momento', NULL),
(17225, 13, 'HOME_INVALID_PAGE', 'Número de página inválido', NULL),
(17226, 13, 'HOME_PREVIOUS_NEWS', 'Anterior', NULL),
(17227, 13, 'HOME_NEXT_NEWS', 'Próximo', NULL),
(17228, 13, 'ADMIN_STATUS_PANEL_TITLE', 'Status dos admins', NULL),
(17229, 13, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Ocultar admins offline', NULL),
(17230, 13, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Mostrar admins offline', NULL),
(17231, 13, 'ADMIN_STATUS_ERROR', 'Erro no status dos admins', NULL),
(17232, 13, 'NAV_TOGGLE', 'Alternar navegação', NULL),
(17233, 13, 'NAV_VIEWER', 'Visualizador', NULL),
(17234, 13, 'NAV_ASSIGNER', 'Atribuidor', NULL),
(17235, 13, 'NAV_BANS', 'Bans', NULL),
(17236, 13, 'NAV_RULES', 'Regras', NULL),
(17237, 13, 'NAV_FAQ', 'FAQ', NULL),
(17238, 13, 'NAV_ACCOUNT_LOGIN', 'Entrar', NULL),
(17239, 13, 'NAV_ACCOUNT_LOGOUT', 'Sair', NULL),
(17240, 13, 'VIEWER_TITLE', 'Visualizador do servidor', NULL),
(17241, 13, 'VIEWER_PANEL_TITLE', 'Visualizador do servidor', NULL),
(17242, 13, 'VIEWER_SHOW_EMPTY', 'Mostrar canais vazios', NULL),
(17243, 13, 'VIEWER_HIDE_EMPTY', 'Esconder canais vazios', NULL),
(17244, 13, 'VIEWER_TIP_ALERT', 'Clique em um canal para entrar. Passe o mouse sobre um usuário para verificar suas informações', NULL),
(17245, 13, 'ARIA_CLOSE', 'Fechar', NULL),
(17246, 13, 'VIEWER_ERROR', 'Erro do visualizador', NULL),
(17247, 13, 'VIEWER_CONNECTION_CONFIRMATION', 'Você quer se conectar a este canal?', NULL),
(17248, 13, 'VIEWER_CLIENT_LASTACTIVE', 'Última vez ativo:', NULL),
(17249, 13, 'VIEWER_CLIENT_ONLINE', 'Tempo online:', NULL),
(17250, 13, 'VIEWER_CLIENT_JOINED', 'Primeira entrada:', NULL),
(17251, 13, 'VIEWER_CLIENT_TITLE', 'Informação do cliente', NULL),
(17252, 13, 'VIEWER_SERVER_ICON', 'Ícone do servidor', NULL),
(17253, 13, 'VIEWER_DEFAULT_CHANNEL', 'Canal padrão', NULL),
(17254, 13, 'VIEWER_CHANNEL_UNSUB1', ', não inscrito', NULL),
(17255, 13, 'VIEWER_CHANNEL_OCCUPIED', 'Totalmente ocupado', NULL),
(17256, 13, 'VIEWER_CHANNEL_PASSWORD', 'Protegido por senha', NULL),
(17257, 13, 'VIEWER_CHANNEL_UNSUB2', 'Não inscrito', NULL),
(17258, 13, 'VIEWER_CHANNEL_ICON', 'Ícone do canal', NULL),
(17259, 13, 'VIEWER_CHANNEL_MODERATED', 'Moderado', NULL),
(17260, 13, 'VIEWER_CHANNEL_MUSIC_CODED', 'Codec de música', NULL),
(17261, 13, 'VIEWER_CLIENT_AWAY', 'Ausente', NULL),
(17262, 13, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Som desativado', NULL),
(17263, 13, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Som desativado', NULL),
(17264, 13, 'VIEWER_CLIENT_MIC_DISABLED', 'Microfone desativdo', NULL),
(17265, 13, 'VIEWER_CLIENT_MIC_MUTED', 'Microfone desativado', NULL),
(17266, 13, 'VIEWER_CLIENT_COMMANDER', 'Responsável pelo canal', NULL),
(17267, 13, 'VIEWER_CLIENT_ICON', 'Ícone do cliente', NULL),
(17268, 13, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Prioridade para falar', NULL),
(17269, 13, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Poder para falar concedido', NULL),
(17270, 13, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Poder para falar insuficiente', NULL),
(17271, 13, 'ASSIGNER_NOT_LOGGED_IN', 'Faça login antes de usar o atribuidor de grupos', NULL),
(17272, 13, 'ASSIGNER_LOGIN_BUTTON', 'Entrar', NULL),
(17273, 13, 'ASSIGNER_SAVE_BUTTON', 'Salvar', NULL),
(17274, 13, 'ASSIGNER_INVALID_GROUPS', 'Definições do grupo inválidas', NULL),
(17275, 13, 'ASSIGNER_NOT_CONFIGURED', 'O atribuidor do grupo não foi configurado pelo administrador do site', NULL),
(17276, 13, 'ASSIGNER_SAVE_SUCCESS', 'Seus grupos foram atualizados', NULL),
(17277, 13, 'ASSIGNER_SAVE_ERROR', 'Erro na alteração de grupos', NULL),
(17278, 13, 'ASSIGNER_SAVE_NO_CHANGE', 'Nenhuma alteração efetuada', NULL),
(17279, 14, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Δεν έχετε κανένα από τα απαιτούμενα γκρουπ. Δεν μπορείτε να χρησιμοποιήσετε την ανάθεση εικονιδίων.', NULL),
(17280, 14, 'DATE_FORMAT', 'd.m.Y', NULL),
(17281, 14, 'TIME_FORMAT', 'H:i', NULL),
(17282, 14, 'BANS_HEADER_TARGET', 'Αποκλεισμός', NULL),
(17283, 14, 'AUTHORS', 'Alligatoras <contact@alligatoras.eu>', NULL),
(17284, 14, 'COOKIEALERT_MESSAGE', '<b>Σας αρέσουν τα cookies;</b> &#x1F36A; Χρησιμοποιούμε cookies για να εξασφαλίσουμε ότι έχετε την καλύτερη εμπειρία στον ιστότοπό μας. <a href=\"https://support.mozilla.org/el-gr/kb/cookies-information-websites-store-on-your-computer\" target=\"_blank\">Μάθετε περισσότερα</a>', NULL),
(17285, 14, 'COOKIEALERT_AGREE', 'Συμφωνώ', NULL),
(17286, 14, 'OUTDATED_DATA', '<b>Προσοχή!</b> Ορισμένες πληροφορίες δεν μπορούν να ληφθούν τώρα. Εμφάνιση παρωχημένων δεδομένων από {0}.', NULL),
(17287, 14, 'SHOW_PROBLEMS', 'Εμφάνιση προβλημάτων', NULL),
(17288, 14, 'PROBLEMS_DESCRIPTION', 'Παρουσιάστηκαν προβλήματα κατά τη σύνδεση με το διακομιστή TeamSpeak', NULL),
(17289, 14, 'NO_JAVASCRIPT_ENABLED', 'Αυτός ο ιστότοπος δεν θα λειτουργήσει χωρίς <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">ενεργοποιημένο JavaScript</a>.', NULL),
(17290, 14, 'CANNOT_GET_DATA', 'Δεν είναι δυνατή η λήψη δεδομένων για το \"{0}\"! Επικοινωνήστε με τον κάτοχο της ιστοσελίδας.', NULL),
(17291, 14, 'NO_REASON_SET', '<b>(δεν υπάρχει αιτία)</b>', NULL),
(17292, 14, 'BANS_HEADER_REASON', 'Αιτία', NULL),
(17293, 14, 'BANS_HEADER_INVOKER', 'Αποκλείστηκε από', NULL),
(17294, 14, 'BANS_HEADER_BANDATE', 'Ημερομηνία αποκλεισμού', NULL),
(17295, 14, 'BANS_HEADER_EXPIRES', 'Λήγει', NULL),
(17296, 14, 'DATATABLES_LANGUAGE_NAME', 'Greek', NULL),
(17297, 14, 'BANS_NEVEREXPIRES', 'Ποτέ', NULL),
(17298, 14, 'STATUS_ADDRESS', 'Διεύθυνση:', NULL),
(17299, 14, 'STATUS_CLIENTS_ONLINE', 'Συνδεδεμένοι:', NULL),
(17300, 14, 'STATUS_RESERVED_SLOTS', '{0} δεσμευμένες θέσεις', NULL),
(17301, 14, 'STATUS_TOP_ONLINE', 'Περισσότερες συνδέσεις:', NULL),
(17302, 14, 'STATUS_TOP_ONLINE_DESC', 'Επιτεύχθηκε στις {0}', NULL),
(17303, 14, 'STATUS_UPTIME', 'Λειτουργία:', NULL),
(17304, 14, 'STATUS_VERSION', 'Έκδοση:', NULL),
(17305, 14, 'STATUS_VERSION_DESC', '{0} στα {1}', NULL),
(17306, 14, 'STATUS_PING', 'Μ. όρος ping:', NULL),
(17307, 14, 'STATUS_PACKETLOSS', 'Μ. όρος απώλειας:', NULL),
(17308, 14, 'STATUS_ERROR', 'Δεν είναι δυνατή η ανάκτηση της κατάστασης του διακομιστή', NULL),
(17309, 14, 'STATUS_PANEL_TITLE', 'Κατάσταση διακομιστή', NULL),
(17310, 14, 'DAYJS_LANG', 'el', NULL),
(17311, 14, 'LOGIN_CONFIRMATION_CODE', 'Γεια σας, αυτός είναι ο κωδικός επιβεβαίωσης για να συνδεθείτε: [b]{0}[/b]', NULL),
(17312, 14, 'UNSUPPORTED_BROWSER', 'Ο περιηγητής σας δεν υποστηρίζεται. Μεταβείτε στην πιο πρόσφατη έκδοση του Chrome, Firefox, Safari ή Edge για να χρησιμοποιήσετε αυτόν τον ιστότοπο.', NULL),
(17313, 14, 'DATATABLES_PLACEHOLDER_SEARCH', 'Αναζήτηση...', NULL),
(17314, 14, 'WEBSITE_TITLE', ' | TS-website Ελληνική Γλώσσα', NULL),
(17315, 14, 'ADMIN_STATUS_ONLINE', 'Συνδεδεμένος', NULL),
(17316, 14, 'ADMIN_STATUS_AWAY', 'Μακριά', NULL),
(17317, 14, 'ADMIN_STATUS_OFFLINE', 'Αποσυνδεδεμένος', NULL),
(17318, 14, 'ADMIN_STATUS_EMPTY_GROUP', 'Τίποτα προς εμφάνιση', NULL),
(17319, 14, 'ADMIN_STATUS_EMPTY_STATUS', 'Η κατάσταση διαχειριστών είναι κενή', NULL),
(17320, 14, 'ASSIGNER_PANEL_TITLE', 'Ανάθεση εικονιδίων', NULL),
(17321, 14, 'ASSIGNER_TITLE', 'Ανάθεση εικονιδίων', NULL),
(17322, 14, 'BANS_EMPTY', 'Η λίστα αποκλεισμών είναι κενή', NULL),
(17323, 14, 'BANS_TITLE', 'Λίστα αποκλεισμών', NULL),
(17324, 14, 'BANS_PANEL_TITLE', 'Λίστα αποκλεισμών', NULL),
(17325, 14, 'BANS_BANNED_ALERT_TITLE', 'Η IP σας έχει αποκλειστεί από τον {0}', NULL),
(17326, 14, 'BANS_BANNED_ALERT_REASON', 'Αιτία: {0}', NULL),
(17327, 14, 'BANS_VIEW_MORE_TIP', 'Κάντε κλικ σε μια σειρά για να δείτε περισσότερες λεπτομέρειες σχετικά με τον αποκλεισμό', NULL),
(17328, 14, 'RULES_TITLE', 'Κανόνες', NULL),
(17329, 14, 'RULES_PANEL_TITLE', 'Κανόνες', NULL),
(17330, 14, 'FAQ_COPY_LINK', 'Αντιγραφή συνδέσμου αυτής της απάντησης', NULL),
(17331, 14, 'FAQ_PANEL_TITLE', 'Συχνές ερωτήσεις', NULL),
(17332, 14, 'FAQ_TITLE', 'Συχνές ερωτήσεις', NULL),
(17333, 14, 'FAQ_COPY_LINK_SUCCESS', 'Αντιγράφτηκε!', NULL),
(17334, 14, 'FAQ_COPY_LINK_ERROR', 'Σφάλμα!', NULL),
(17335, 14, 'HOME_TITLE', 'Νέα', NULL),
(17336, 14, 'HOME_PANEL_TITLE', 'Νέα', NULL),
(17337, 14, 'HOME_EMPTY', 'Δεν υπάρχουν διαθέσιμα νέα αυτή τη στιγμή', NULL),
(17338, 14, 'HOME_INVALID_PAGE', 'Μη έγκυρος αριθμός σελίδας', NULL),
(17339, 14, 'HOME_PREVIOUS_NEWS', 'Προηγούμενο', NULL),
(17340, 14, 'HOME_NEXT_NEWS', 'Επόμενο', NULL),
(17341, 14, 'ADMIN_STATUS_PANEL_TITLE', 'Κατάσταση διαχειριστών', NULL),
(17342, 14, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Απόκρυψη αποσυνδεδεμένων διαχειριστών', NULL),
(17343, 14, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Εμφάνιση αποσυνδεδεμένων διαχειριστών', NULL),
(17344, 14, 'ADMIN_STATUS_ERROR', 'Σφάλμα κατάστασης διαχειριστών', NULL),
(17345, 14, 'NAV_TOGGLE', 'Εναλλαγή πλοήγησης', NULL),
(17346, 14, 'NAV_VIEWER', 'Προβολή', NULL),
(17347, 14, 'NAV_ASSIGNER', 'Ανάθεση', NULL),
(17348, 14, 'NAV_BANS', 'Αποκλεισμοί', NULL),
(17349, 14, 'NAV_RULES', 'Κανόνες', NULL),
(17350, 14, 'NAV_FAQ', 'FAQ', NULL),
(17351, 14, 'NAV_ACCOUNT_LOGIN', 'Σύνδεση', NULL),
(17352, 14, 'NAV_ACCOUNT_LOGOUT', 'Αποσύνδεση', NULL),
(17353, 14, 'VIEWER_TITLE', 'Προβολή διακομιστή', NULL),
(17354, 14, 'VIEWER_PANEL_TITLE', 'Προβολή διακομιστή', NULL),
(17355, 14, 'VIEWER_SHOW_EMPTY', 'Εμφάνιση άδειων καναλιών', NULL),
(17356, 14, 'VIEWER_HIDE_EMPTY', 'Απόκρυψη άδειων καναλιών', NULL),
(17357, 14, 'VIEWER_TIP_ALERT', 'Κάντε κλικ σε ένα κανάλι για να συνδεθείτε σε αυτό. Τοποθετήστε το δείκτη του ποντικιού πάνω από έναν χρήστη για να ελέγξετε τις πληροφορίες του', NULL),
(17358, 14, 'ARIA_CLOSE', 'Κλείσιμο', NULL),
(17359, 14, 'VIEWER_ERROR', 'Σφάλμα προβολής', NULL),
(17360, 14, 'VIEWER_CONNECTION_CONFIRMATION', 'Θέλετε να συνδεθείτε σε αυτό το κανάλι;', NULL),
(17361, 14, 'VIEWER_CLIENT_LASTACTIVE', 'Τελευταία σύνδεση:', NULL),
(17362, 14, 'VIEWER_CLIENT_ONLINE', 'Χρόνος σύνδεσης:', NULL),
(17363, 14, 'VIEWER_CLIENT_JOINED', 'Πρώτη σύνδεση:', NULL),
(17364, 14, 'VIEWER_CLIENT_TITLE', 'Πληροφορίες χρήστη', NULL),
(17365, 14, 'VIEWER_SERVER_ICON', 'Εικονίδιο διακομιστή', NULL),
(17366, 14, 'VIEWER_DEFAULT_CHANNEL', 'Προεπιλεγμένο κανάλι', NULL),
(17367, 14, 'VIEWER_CHANNEL_UNSUB1', ', επιτυχής αναίρεση εγγραφής', NULL),
(17368, 14, 'VIEWER_CHANNEL_OCCUPIED', 'Πλήρως κατειλημμένο', NULL),
(17369, 14, 'VIEWER_CHANNEL_PASSWORD', 'Προστατεύεται με κωδικό', NULL),
(17370, 14, 'VIEWER_CHANNEL_UNSUB2', 'Επιτυχής αναίρεση εγγραφής', NULL),
(17371, 14, 'VIEWER_CHANNEL_ICON', 'Εικονίδιο καναλιού', NULL),
(17372, 14, 'VIEWER_CHANNEL_MODERATED', 'Τροποποιημένο', NULL),
(17373, 14, 'VIEWER_CHANNEL_MUSIC_CODED', 'Κωδικοποίηση μουσικής', NULL),
(17374, 14, 'VIEWER_CLIENT_AWAY', 'Μακριά', NULL),
(17375, 14, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Απενεργοποιημένος ήχος', NULL),
(17376, 14, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Κλειστός ήχος', NULL),
(17377, 14, 'VIEWER_CLIENT_MIC_DISABLED', 'Απενεργοποιημένο μικρόφωνο', NULL),
(17378, 14, 'VIEWER_CLIENT_MIC_MUTED', 'Κλειστό μικρόφωνο', NULL),
(17379, 14, 'VIEWER_CLIENT_COMMANDER', 'Διαχειριστής καναλιού', NULL),
(17380, 14, 'VIEWER_CLIENT_ICON', 'Εικονίδιο χρήστη', NULL),
(17381, 14, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Προτεραιότητα ομιλίας', NULL),
(17382, 14, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Εξουσιοδοτημένη ομιλία', NULL),
(17383, 14, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Ανεπαρκής δυνατότητα ομιλίας', NULL),
(17384, 14, 'ASSIGNER_NOT_LOGGED_IN', 'Συνδεθείτε πριν χρησιμοποιήσετε την ανάθεση εικονιδίων', NULL),
(17385, 14, 'ASSIGNER_LOGIN_BUTTON', 'Σύνδεση', NULL),
(17386, 14, 'ASSIGNER_SAVE_BUTTON', 'Αποθήκευση', NULL),
(17387, 14, 'ASSIGNER_INVALID_GROUPS', 'Μη έγκυρες ρυθμίσεις εικονιδίων', NULL),
(17388, 14, 'ASSIGNER_NOT_CONFIGURED', 'Η ανάθεση εικονιδίων δεν έχει ρυθμιστεί από τον διαχειριστή του ιστότοπου', NULL),
(17389, 14, 'ASSIGNER_SAVE_SUCCESS', 'Τα εικονίδια σας έχουν ενημερωθεί', NULL),
(17390, 14, 'ASSIGNER_SAVE_ERROR', 'Σφάλμα αλλαγής εικονιδίων', NULL),
(17391, 14, 'ASSIGNER_SAVE_NO_CHANGE', 'Δεν έχουν γίνει αλλαγές', NULL),
(17392, 15, 'DATE_FORMAT', 'd.m.Y', NULL),
(17393, 15, 'TIME_FORMAT', 'H:i', NULL),
(17394, 15, 'AUTHORS', 'Mikkel Lind <mikkel.linddk@gmail.com>', NULL),
(17395, 15, 'COOKIEALERT_MESSAGE', '<b>Kan du lide cookies?</b> &#x1F36A; Vi bruger cookies for at sikre, at du får den bedste oplevelse på vores hjemmeside. <a href=\"https://support.mozilla.org/da/kb/cookies-information-som-websteder-gemmer-paa-din-computer\" target=\"_blank\">Lær mere</a>', NULL),
(17396, 15, 'COOKIEALERT_AGREE', 'Jeg er enig', NULL),
(17397, 15, 'OUTDATED_DATA', '<b>Advarsel!</b> Nogle oplysninger kan ikke opnås nu. Viser forældede data fra {0}.', NULL),
(17398, 15, 'SHOW_PROBLEMS', 'Vis problemer', NULL),
(17399, 15, 'PROBLEMS_DESCRIPTION', 'Problemer opstår under forbindelse til TeamSpeak server', NULL),
(17400, 15, 'NO_JAVASCRIPT_ENABLED', 'Denne hjemmeside vil ikke fungere uden <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript aktiveret</a>.', NULL),
(17401, 15, 'CANNOT_GET_DATA', 'Kan ikke få data til \"{0}\"! Kontakt venligst hjemmesiden\'s ejer.', NULL),
(17402, 15, 'NO_REASON_SET', '<b>(Ingen begrundelse sat)</b>', NULL),
(17403, 15, 'BANS_HEADER_REASON', 'Begrundelse', NULL),
(17404, 15, 'BANS_HEADER_INVOKER', 'Banned af', NULL),
(17405, 15, 'BANS_HEADER_BANDATE', 'Forbudsdato', NULL),
(17406, 15, 'BANS_HEADER_EXPIRES', 'Udløber', NULL),
(17407, 15, 'DATATABLES_LANGUAGE_NAME', 'Danish', NULL),
(17408, 15, 'BANS_NEVEREXPIRES', 'Aldrig', NULL),
(17409, 15, 'STATUS_ADDRESS', 'Adresse:', NULL),
(17410, 15, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(17411, 15, 'STATUS_RESERVED_SLOTS', '{0} reserverede plads', NULL),
(17412, 15, 'STATUS_TOP_ONLINE', 'Top online:', NULL),
(17413, 15, 'STATUS_TOP_ONLINE_DESC', 'Opnået på {0}', NULL),
(17414, 15, 'STATUS_UPTIME', 'Oppetid:', NULL),
(17415, 15, 'STATUS_VERSION', 'Version:', NULL),
(17416, 15, 'STATUS_VERSION_DESC', '{0} på {1}', NULL),
(17417, 15, 'STATUS_PING', 'Gennemsnitlig. ping:', NULL),
(17418, 15, 'STATUS_PACKETLOSS', 'Gennemsnitlig. pakke tab:', NULL),
(17419, 15, 'STATUS_ERROR', 'Kan ikke hente serverstatus', NULL),
(17420, 15, 'STATUS_PANEL_TITLE', 'Server status', NULL),
(17421, 15, 'DAYJS_LANG', 'da', NULL);
INSERT INTO `DBPREFIXtranslations` (`id`, `langid`, `identifier`, `value`, `comment`) VALUES
(17422, 15, 'LOGIN_CONFIRMATION_CODE', 'Hej, her er din bekræftelseskode for at logge ind: [b]{0}[/b]', NULL),
(17423, 15, 'UNSUPPORTED_BROWSER', 'Din browser understøttes ikke. Venligst skift til den nyeste version af Chrome, Firefox, Safari eller Edge for at bruge denne hjemmeside.', NULL),
(17424, 15, 'DATATABLES_PLACEHOLDER_SEARCH', 'Søg...', NULL),
(17425, 15, 'WEBSITE_TITLE', ' | TS-website Dansk Sprog', NULL),
(17426, 15, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(17427, 15, 'ADMIN_STATUS_AWAY', 'Væk', NULL),
(17428, 15, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(17429, 15, 'ADMIN_STATUS_EMPTY_GROUP', 'Intet at vise', NULL),
(17430, 15, 'ADMIN_STATUS_EMPTY_STATUS', 'Administrationsstatus er tom', NULL),
(17431, 15, 'ASSIGNER_PANEL_TITLE', 'Gruppe tildele', NULL),
(17432, 15, 'ASSIGNER_TITLE', 'Gruppe tildele', NULL),
(17433, 15, 'BANS_EMPTY', 'Banlist er tom', NULL),
(17434, 15, 'BANS_TITLE', 'Banlist', NULL),
(17435, 15, 'BANS_PANEL_TITLE', 'Banlist', NULL),
(17436, 15, 'BANS_BANNED_ALERT_TITLE', 'Din IP er blevet forbudt af {0}', NULL),
(17437, 15, 'BANS_BANNED_ALERT_REASON', 'Begrundelse: {0}', NULL),
(17438, 15, 'BANS_VIEW_MORE_TIP', 'Klik på en række for at se flere detaljer om et forbud', NULL),
(17439, 15, 'RULES_TITLE', 'Regler', NULL),
(17440, 15, 'RULES_PANEL_TITLE', 'Regler', NULL),
(17441, 15, 'FAQ_COPY_LINK', 'Kopier link til dette svar', NULL),
(17442, 15, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(17443, 15, 'FAQ_TITLE', 'FAQ', NULL),
(17444, 15, 'FAQ_COPY_LINK_SUCCESS', 'Kopieret!', NULL),
(17445, 15, 'FAQ_COPY_LINK_ERROR', 'Fejl!', NULL),
(17446, 15, 'HOME_TITLE', 'Nyheder', NULL),
(17447, 15, 'HOME_PANEL_TITLE', 'Nyheder', NULL),
(17448, 15, 'HOME_EMPTY', 'Der er ingen nyheder på nuværende tidspunkt', NULL),
(17449, 15, 'HOME_INVALID_PAGE', 'Ugyldigt sidetal', NULL),
(17450, 15, 'HOME_PREVIOUS_NEWS', 'Tidligere', NULL),
(17451, 15, 'HOME_NEXT_NEWS', 'Næste', NULL),
(17452, 15, 'ADMIN_STATUS_PANEL_TITLE', 'Admin status', NULL),
(17453, 15, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Skjul offline admins', NULL),
(17454, 15, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Vis offline admins', NULL),
(17455, 15, 'ADMIN_STATUS_ERROR', 'Administrator status fejl', NULL),
(17456, 15, 'NAV_TOGGLE', 'Skift navigation', NULL),
(17457, 15, 'NAV_VIEWER', 'Fremviser', NULL),
(17458, 15, 'NAV_ASSIGNER', 'Tildele', NULL),
(17459, 15, 'NAV_BANS', 'Bans', NULL),
(17460, 15, 'NAV_RULES', 'Regler', NULL),
(17461, 15, 'NAV_FAQ', 'FAQ', NULL),
(17462, 15, 'NAV_ACCOUNT_LOGIN', 'Logind', NULL),
(17463, 15, 'NAV_ACCOUNT_LOGOUT', 'Log ud', NULL),
(17464, 15, 'VIEWER_TITLE', 'Server visning', NULL),
(17465, 15, 'VIEWER_PANEL_TITLE', 'Server visning', NULL),
(17466, 16, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Vous n\'avez aucun des groupes requis. Vous ne pouvez pas utiliser l\'assignation de groupe.', NULL),
(17467, 16, 'DATE_FORMAT', 'd.m.Y', NULL),
(17468, 16, 'TIME_FORMAT', 'H:i', NULL),
(17469, 16, 'BANS_HEADER_TARGET', 'Ban', NULL),
(17470, 16, 'AUTHORS', 'Wruczek <wruczekk@gmail.com>', NULL),
(17471, 16, 'COOKIEALERT_MESSAGE', '<b>Tu aime les cookies ?</b> &#x1F36A; Ce site web utilise des cookies pour améliorer votre expérience de navigation. <a href=\"https://support.mozilla.org/fr/kb/cookies-informations-sites-enregistrent\" target=\"_blank\">En savoir plus</a>', NULL),
(17472, 16, 'COOKIEALERT_AGREE', 'J\'accepte', NULL),
(17473, 16, 'OUTDATED_DATA', '<b>Attention !</b> Certaines informations ne peuvent pas être obtenues maintenant. Affichage de données obsolètes de {0}.', NULL),
(17474, 16, 'SHOW_PROBLEMS', 'Montrer les problèmes', NULL),
(17475, 16, 'PROBLEMS_DESCRIPTION', 'Problèmes rencontrés lors de la connexion au serveur TeamSpeak', NULL),
(17476, 16, 'NO_JAVASCRIPT_ENABLED', 'Ce site ne fonctionnera pas sans <a href=\"https://www.enable-javascript.com/fr/\" target=\"_blank\">JavaScript enabled</a>.', NULL),
(17477, 16, 'CANNOT_GET_DATA', 'Impossible d\'obtenir les données pour \"{0}\"! S\'il vous plaît contacter le propriétaire du site.', NULL),
(17478, 16, 'NO_REASON_SET', '<b>(aucune raison définie)</b>', NULL),
(17479, 16, 'BANS_HEADER_REASON', 'Raison', NULL),
(17480, 16, 'BANS_HEADER_INVOKER', 'Banni par', NULL),
(17481, 16, 'BANS_HEADER_BANDATE', 'Date de Ban', NULL),
(17482, 16, 'BANS_HEADER_EXPIRES', 'Expire', NULL),
(17483, 16, 'DATATABLES_LANGUAGE_NAME', 'French', NULL),
(17484, 16, 'BANS_NEVEREXPIRES', 'Jamais', NULL),
(17485, 16, 'STATUS_ADDRESS', 'Adresse:', NULL),
(17486, 16, 'STATUS_CLIENTS_ONLINE', 'En Ligne:', NULL),
(17487, 16, 'STATUS_RESERVED_SLOTS', '{0} emplacements réservés', NULL),
(17488, 16, 'STATUS_TOP_ONLINE', 'Top en ligne:', NULL),
(17489, 16, 'STATUS_TOP_ONLINE_DESC', 'Atteint le {0}', NULL),
(17490, 16, 'STATUS_UPTIME', 'En ligne depuis :', NULL),
(17491, 16, 'STATUS_VERSION', 'Version:', NULL),
(17492, 16, 'STATUS_VERSION_DESC', '{0} sur {1}', NULL),
(17493, 16, 'STATUS_PING', 'Ping moyen:', NULL),
(17494, 16, 'STATUS_PACKETLOSS', 'Paquets perdu moyen:', NULL),
(17495, 16, 'STATUS_ERROR', 'Impossible de récupérer l\'état du serveur', NULL),
(17496, 16, 'STATUS_PANEL_TITLE', 'Statut du serveur', NULL),
(17497, 16, 'DAYJS_LANG', 'fr', NULL),
(17498, 16, 'LOGIN_CONFIRMATION_CODE', 'Bonjour, voici votre code de confirmation pour vous connecter: [b]{0}[/b]', NULL),
(17499, 16, 'UNSUPPORTED_BROWSER', 'Votre navigateur n\'est pas supporté. Veuillez utiliser la dernière version de Chrome, Firefox, Safari ou Edge pour utiliser ce site Web.', NULL),
(17500, 16, 'DATATABLES_PLACEHOLDER_SEARCH', 'Recherche...', NULL),
(17501, 16, 'WEBSITE_TITLE', ' | TS-website Langue Française', NULL),
(17502, 16, 'ADMIN_STATUS_ONLINE', 'En ligne', NULL),
(17503, 16, 'ADMIN_STATUS_AWAY', 'Absent', NULL),
(17504, 16, 'ADMIN_STATUS_OFFLINE', 'Hors ligne', NULL),
(17505, 16, 'ADMIN_STATUS_EMPTY_GROUP', 'Rien à montrer', NULL),
(17506, 16, 'ADMIN_STATUS_EMPTY_STATUS', 'Le statut d\'administrateur est vide', NULL),
(17507, 16, 'ASSIGNER_PANEL_TITLE', 'Assignateur de groupe', NULL),
(17508, 16, 'ASSIGNER_TITLE', 'Assignation de groupe', NULL),
(17509, 16, 'BANS_EMPTY', 'La liste des Ban est vide', NULL),
(17510, 16, 'BANS_TITLE', 'Liste des bannissements', NULL),
(17511, 16, 'BANS_PANEL_TITLE', 'Liste des bannissements', NULL),
(17512, 16, 'BANS_BANNED_ALERT_TITLE', 'Votre adresse IP a été bannie par {0}.', NULL),
(17513, 16, 'BANS_BANNED_ALERT_REASON', 'Raison: {0}', NULL),
(17514, 16, 'BANS_VIEW_MORE_TIP', 'Cliquez sur une ligne pour afficher plus de détails sur un Ban', NULL),
(17515, 16, 'RULES_TITLE', 'Règles', NULL),
(17516, 16, 'RULES_PANEL_TITLE', 'Règles', NULL),
(17517, 16, 'FAQ_COPY_LINK', 'Copier le lien vers cette réponse', NULL),
(17518, 16, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(17519, 16, 'FAQ_TITLE', 'FAQ', NULL),
(17520, 16, 'FAQ_COPY_LINK_SUCCESS', 'Copié!', NULL),
(17521, 16, 'FAQ_COPY_LINK_ERROR', 'Erreur!', NULL),
(17522, 16, 'HOME_TITLE', 'Actualités', NULL),
(17523, 16, 'HOME_PANEL_TITLE', 'Actualités', NULL),
(17524, 16, 'HOME_EMPTY', 'Aucune actualités disponible pour le moment', NULL),
(17525, 16, 'HOME_INVALID_PAGE', 'Numéro de page invalide', NULL),
(17526, 16, 'HOME_PREVIOUS_NEWS', 'Précédent', NULL),
(17527, 16, 'HOME_NEXT_NEWS', 'Suivant', NULL),
(17528, 16, 'ADMIN_STATUS_PANEL_TITLE', 'Statut administrateur', NULL),
(17529, 16, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Masquer les administrateurs hors ligne', NULL),
(17530, 16, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Afficher les administrateurs hors ligne', NULL),
(17531, 16, 'ADMIN_STATUS_ERROR', 'Erreur d\'état de l\'administrateur', NULL),
(17532, 16, 'NAV_TOGGLE', 'Basculer de navigation', NULL),
(17533, 16, 'NAV_VIEWER', 'Aperçu', NULL),
(17534, 16, 'NAV_ASSIGNER', 'Assigner', NULL),
(17535, 16, 'NAV_BANS', 'Bannissements', NULL),
(17536, 16, 'NAV_RULES', 'Règlement', NULL),
(17537, 16, 'NAV_FAQ', 'FAQ', NULL),
(17538, 16, 'NAV_ACCOUNT_LOGIN', 'Connexion', NULL),
(17539, 16, 'NAV_ACCOUNT_LOGOUT', 'Déconnexion', NULL),
(17540, 16, 'VIEWER_TITLE', 'Vue du serveur', NULL),
(17541, 16, 'VIEWER_PANEL_TITLE', 'Vue du serveur', NULL),
(17542, 16, 'VIEWER_SHOW_EMPTY', 'Afficher les canaux vides', NULL),
(17543, 16, 'VIEWER_HIDE_EMPTY', 'Cacher les canaux vides', NULL),
(17544, 16, 'VIEWER_TIP_ALERT', 'Cliquez sur un canal pour le rejoindre. Cliquez sur un utilisateur pour vérifier ses informations.', NULL),
(17545, 16, 'ARIA_CLOSE', 'Fermer', NULL),
(17546, 16, 'VIEWER_ERROR', 'Problème pour voir', NULL),
(17547, 16, 'VIEWER_CONNECTION_CONFIRMATION', 'Voulez-vous vous connecter à ce canal ?', NULL),
(17548, 16, 'VIEWER_CLIENT_LASTACTIVE', 'Dernier actif :', NULL),
(17549, 16, 'VIEWER_CLIENT_ONLINE', 'En ligne depuis :', NULL),
(17550, 16, 'VIEWER_CLIENT_JOINED', 'Premier membre ; ', NULL),
(17551, 16, 'VIEWER_CLIENT_TITLE', 'Informations de l\'utilisateur : ', NULL),
(17552, 16, 'VIEWER_SERVER_ICON', 'Icône du serveur', NULL),
(17553, 16, 'VIEWER_DEFAULT_CHANNEL', 'Canal par défaut', NULL),
(17554, 16, 'VIEWER_CHANNEL_UNSUB1', 'Désabonnement', NULL),
(17555, 16, 'VIEWER_CHANNEL_OCCUPIED', 'Tout est occupé', NULL),
(17556, 16, 'VIEWER_CHANNEL_PASSWORD', 'Protégé par un mot de passe', NULL),
(17557, 16, 'VIEWER_CHANNEL_UNSUB2', 'Désabonnement', NULL),
(17558, 16, 'VIEWER_CHANNEL_ICON', 'Icône du Channel', NULL),
(17559, 16, 'VIEWER_CHANNEL_MODERATED', 'Modéré', NULL),
(17560, 16, 'VIEWER_CHANNEL_MUSIC_CODED', 'Configuration music ', NULL),
(17561, 16, 'VIEWER_CLIENT_AWAY', 'Absent', NULL),
(17562, 16, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Sons désactivés', NULL),
(17563, 16, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Assourdi', NULL),
(17564, 16, 'VIEWER_CLIENT_MIC_DISABLED', 'Microphone désactiver', NULL),
(17565, 16, 'VIEWER_CLIENT_MIC_MUTED', 'Muté', NULL),
(17566, 16, 'VIEWER_CLIENT_COMMANDER', 'Commandant du Channel', NULL),
(17567, 16, 'VIEWER_CLIENT_ICON', 'Icône de l\'utilisateur', NULL),
(17568, 16, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Personne prioritaire', NULL),
(17569, 16, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Le pouvoir de parler a été accordé', NULL),
(17570, 16, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Niveau de conversation insuffisant', NULL),
(17571, 16, 'ASSIGNER_NOT_LOGGED_IN', 'Connectez-vous avant d\'utiliser l\'assignateur de groupes', NULL),
(17572, 16, 'ASSIGNER_LOGIN_BUTTON', 'Connexion', NULL),
(17573, 16, 'ASSIGNER_SAVE_BUTTON', 'Sauvegarde', NULL),
(17574, 16, 'ASSIGNER_INVALID_GROUPS', 'Les paramètres du groupe sont invalide', NULL),
(17575, 16, 'ASSIGNER_NOT_CONFIGURED', 'L\'assignation de groupe n\'a pas été configuré par l\'administrateur du site web', NULL),
(17576, 16, 'ASSIGNER_SAVE_SUCCESS', 'Vos groupes ont bien été mis a jour', NULL),
(17577, 16, 'ASSIGNER_SAVE_ERROR', 'Erreur dans le changement de groupe', NULL),
(17578, 16, 'ASSIGNER_SAVE_NO_CHANGE', 'Aucun changement n\'a été fait', NULL),
(17579, 17, 'DATE_FORMAT', 'd.m.Y', NULL),
(17580, 17, 'TIME_FORMAT', 'H:i', NULL),
(17581, 17, 'BANS_HEADER_TARGET', 'Yasak', NULL),
(17582, 17, 'AUTHORS', 'Uldin <muratbeylbyprof@gmail.com>', NULL),
(17583, 17, 'COOKIEALERT_MESSAGE', '<b>Çerezleri sever misin?</b> &#x1F36A; Web sitemizde en iyi deneyimi yaşamanızı sağlamak için çerezleri kullanıyoruz. <a href=\"https://support.mozilla.org/tr/kb/cerezler-web-sitelerinin-bilgisayarinizda-depoladi\" target=\"_blank\">Daha fazla bilgi edinin</a>', NULL),
(17584, 17, 'COOKIEALERT_AGREE', 'Kabul ediyorum', NULL),
(17585, 17, 'OUTDATED_DATA', '<b>Uyarı!</b> Bazı bilgiler şimdi alınamıyor. {0} \'daki güncel olmayan veriler gösteriliyor.', NULL),
(17586, 17, 'SHOW_PROBLEMS', 'Sorunları göster', NULL),
(17587, 17, 'PROBLEMS_DESCRIPTION', 'TeamSpeak sunucusuna bağlanırken karşılaşılan sorunlar', NULL),
(17588, 17, 'NO_JAVASCRIPT_ENABLED', 'Bu web sitesi<a href=\"https://www.enable-javascript.com/tr/\" target=\"_blank\">JavaScript etkinleştirilmiş</a> olmadan çalışmaz', NULL),
(17589, 17, 'CANNOT_GET_DATA', '\"{0}\" için veri alınamıyor! Yönetici ile iletişime geçmeyi deneyiniz.', NULL),
(17590, 17, 'NO_REASON_SET', '<b>(Sebep belirtilmemiş)</b>', NULL),
(17591, 17, 'BANS_HEADER_REASON', 'Sebep', NULL),
(17592, 17, 'BANS_HEADER_INVOKER', 'Yetkili', NULL),
(17593, 17, 'BANS_HEADER_BANDATE', 'Yasaklanma tarihi', NULL),
(17594, 17, 'BANS_HEADER_EXPIRES', 'Bitiş Tarihi', NULL),
(17595, 17, 'DATATABLES_LANGUAGE_NAME', 'Turkish', NULL),
(17596, 17, 'BANS_NEVEREXPIRES', 'Belirsiz', NULL),
(17597, 17, 'STATUS_ADDRESS', 'Adres:', NULL),
(17598, 17, 'STATUS_CLIENTS_ONLINE', 'Aktif:', NULL),
(17599, 17, 'STATUS_RESERVED_SLOTS', '{0} ayrılmış kullanıcı', NULL),
(17600, 17, 'STATUS_TOP_ONLINE', 'Rekor Aktiflik', NULL),
(17601, 17, 'STATUS_TOP_ONLINE_DESC', '{0} tarihinde ulaşıldı', NULL),
(17602, 17, 'STATUS_UPTIME', 'Güncelleme:', NULL),
(17603, 17, 'STATUS_VERSION', 'Versiyon:', NULL),
(17604, 17, 'STATUS_VERSION_DESC', '{0} ve {1}', NULL),
(17605, 17, 'STATUS_PING', 'Ort. ping:', NULL),
(17606, 17, 'STATUS_PACKETLOSS', 'Ort. paket kaybı:', NULL),
(17607, 17, 'STATUS_ERROR', 'Sunucu durumu alınamıyor', NULL),
(17608, 17, 'STATUS_PANEL_TITLE', 'Sunucu durumu', NULL),
(17609, 17, 'DAYJS_LANG', 'tr', NULL),
(17610, 17, 'LOGIN_CONFIRMATION_CODE', 'Merhaba, giriş yapmak için onay kodunuz: [b][color=red]{0}', NULL),
(17611, 17, 'UNSUPPORTED_BROWSER', 'Tarayıcınız desteklenmiyor. Bu web sitesini kullanmak için lütfen Chrome, Firefox, Safari veya Edge’in en son sürümüne geçin.', NULL),
(17612, 17, 'DATATABLES_PLACEHOLDER_SEARCH', 'Arama..', NULL),
(17613, 17, 'WEBSITE_TITLE', ' | TS-website Türkce dili', NULL),
(17614, 17, 'ADMIN_STATUS_ONLINE', 'Aktif', NULL),
(17615, 17, 'ADMIN_STATUS_AWAY', 'Uzakta', NULL),
(17616, 17, 'ADMIN_STATUS_OFFLINE', 'Çevrimdışı', NULL),
(17617, 17, 'ADMIN_STATUS_EMPTY_GROUP', 'Gösterecek bir şey yok', NULL),
(17618, 17, 'ADMIN_STATUS_EMPTY_STATUS', 'Yönetici durumu boş', NULL),
(17619, 17, 'ASSIGNER_PANEL_TITLE', 'Yetki görevlisi', NULL),
(17620, 17, 'ASSIGNER_TITLE', 'Yetki görevlisi', NULL),
(17621, 17, 'BANS_EMPTY', 'Yasaklanmış kullanıcı yok!', NULL),
(17622, 17, 'BANS_TITLE', 'Ban Listesi', NULL),
(17623, 17, 'BANS_PANEL_TITLE', 'Ban Listesi', NULL),
(17624, 17, 'BANS_BANNED_ALERT_TITLE', 'IP\'niz {0} tarafından yasaklandı', NULL),
(17625, 17, 'BANS_BANNED_ALERT_REASON', 'Sebep: {0}', NULL),
(17626, 17, 'BANS_VIEW_MORE_TIP', 'Yasak hakkında daha fazla ayrıntı görüntülemek için bir satıra tıklayın', NULL),
(17627, 17, 'RULES_TITLE', 'Kurallar', NULL),
(17628, 17, 'RULES_PANEL_TITLE', 'Kurallar', NULL),
(17629, 17, 'FAQ_COPY_LINK', 'Bu cevabın bağlantısını kopyala', NULL),
(17630, 17, 'FAQ_PANEL_TITLE', 'S.S.S', NULL),
(17631, 17, 'FAQ_TITLE', 'S.S.S', NULL),
(17632, 17, 'FAQ_COPY_LINK_SUCCESS', 'Kopyalandı!', NULL),
(17633, 17, 'FAQ_COPY_LINK_ERROR', 'Hata!', NULL),
(17634, 17, 'HOME_TITLE', 'Haberler', NULL),
(17635, 17, 'HOME_PANEL_TITLE', 'Haberler', NULL),
(17636, 17, 'HOME_EMPTY', 'Şu an hiç haber yok', NULL),
(17637, 17, 'HOME_INVALID_PAGE', 'Geçersiz sayfa numarası', NULL),
(17638, 17, 'HOME_PREVIOUS_NEWS', 'Önceki', NULL),
(17639, 17, 'HOME_NEXT_NEWS', 'Sonraki', NULL),
(17640, 17, 'ADMIN_STATUS_PANEL_TITLE', 'Yönetici durumu', NULL),
(17641, 17, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Çevrimdışı yöneticileri gizle', NULL),
(17642, 17, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Çevrimdışı yöneticileri göster', NULL),
(17643, 17, 'ADMIN_STATUS_ERROR', 'Yönetici durumu hatası', NULL),
(17644, 17, 'NAV_TOGGLE', 'Gezinmeyi değiştir', NULL),
(17645, 17, 'NAV_VIEWER', 'Görüntüle', NULL),
(17646, 17, 'NAV_ASSIGNER', 'Yetki', NULL),
(17647, 17, 'NAV_BANS', 'Ban listesi', NULL),
(17648, 17, 'NAV_RULES', 'Kurallar', NULL),
(17649, 17, 'NAV_FAQ', 'S.S.S', NULL),
(17650, 17, 'NAV_ACCOUNT_LOGIN', 'Giriş yap', NULL),
(17651, 17, 'NAV_ACCOUNT_LOGOUT', 'Çıkış yap', NULL),
(17652, 17, 'VIEWER_TITLE', 'Sunucuyu görüntüle', NULL),
(17653, 17, 'VIEWER_PANEL_TITLE', 'Sunucuyu görüntüle', NULL),
(17654, 17, 'VIEWER_SHOW_EMPTY', 'Boş kanalları göster', NULL),
(17655, 17, 'VIEWER_HIDE_EMPTY', 'Boş kanalları gizle', NULL),
(17656, 17, 'VIEWER_TIP_ALERT', 'Katılmak için bir kanala tıklayın. Bilgilerini kontrol etmek için bir kullanıcının üzerine gelin', NULL),
(17657, 17, 'ARIA_CLOSE', 'Kapat', NULL),
(17658, 17, 'VIEWER_ERROR', 'Sunucu Görüntülenemiyor!', NULL),
(17659, 17, 'VIEWER_CONNECTION_CONFIRMATION', 'Bu kanala bağlanmak ister misiniz?', NULL),
(17660, 17, 'VIEWER_CLIENT_LASTACTIVE', 'Son İşlem:', NULL),
(17661, 17, 'VIEWER_CLIENT_ONLINE', 'Aktiflik Süresi:', NULL),
(17662, 17, 'VIEWER_CLIENT_JOINED', 'İlk giriş:', NULL),
(17663, 17, 'VIEWER_CLIENT_TITLE', 'Kullanıcı bilgileri', NULL),
(17664, 17, 'VIEWER_SERVER_ICON', 'Sunucu ikonu', NULL),
(17665, 17, 'VIEWER_DEFAULT_CHANNEL', 'Standart kanal', NULL),
(17666, 17, 'VIEWER_CHANNEL_UNSUB1', ', aboneliği iptal et', NULL),
(17667, 17, 'VIEWER_CHANNEL_OCCUPIED', 'Tamamen meşgul', NULL),
(17668, 17, 'VIEWER_CHANNEL_PASSWORD', 'Şifreli Kanal', NULL),
(17669, 17, 'VIEWER_CHANNEL_UNSUB2', 'Abonelikten Çık', NULL),
(17670, 17, 'VIEWER_CHANNEL_ICON', 'Kanal ikonu', NULL),
(17671, 17, 'VIEWER_CHANNEL_MODERATED', 'Modereatör düzenlemesi', NULL),
(17672, 17, 'VIEWER_CHANNEL_MUSIC_CODED', 'Yüksek Kalite Ses', NULL),
(17673, 17, 'VIEWER_CLIENT_AWAY', 'Uzakta', NULL),
(17674, 17, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Ses devre dışı', NULL),
(17675, 17, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Ses Kapalı', NULL),
(17676, 17, 'VIEWER_CLIENT_MIC_DISABLED', 'Mikrofon devre dışı', NULL),
(17677, 17, 'VIEWER_CLIENT_MIC_MUTED', 'Mikrofon kapalı', NULL),
(17678, 17, 'VIEWER_CLIENT_COMMANDER', 'Kanal Komutanı', NULL),
(17679, 17, 'VIEWER_CLIENT_ICON', 'Kullanıcı ikonu', NULL),
(17680, 17, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Öncelikli konuşmacı', NULL),
(17681, 17, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Konuşma gücü verildi', NULL),
(17682, 17, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Yetersiz konuşma gücü', NULL),
(17683, 17, 'ASSIGNER_NOT_LOGGED_IN', 'Yetki almak için önce giriş yapınız!', NULL),
(17684, 17, 'ASSIGNER_LOGIN_BUTTON', 'Giriş yap', NULL),
(17685, 17, 'ASSIGNER_SAVE_BUTTON', 'Kaydet', NULL),
(17686, 17, 'ASSIGNER_INVALID_GROUPS', 'Geçersiz grup ayarları', NULL),
(17687, 17, 'ASSIGNER_NOT_CONFIGURED', 'Yetki sistemi yönetici tarafından tanımlanmamıştır.', NULL),
(17688, 17, 'ASSIGNER_SAVE_SUCCESS', 'Yetkileriniz güncellendi', NULL),
(17689, 17, 'ASSIGNER_SAVE_ERROR', 'Yetki değişikliği hatası', NULL),
(17690, 17, 'ASSIGNER_SAVE_NO_CHANGE', 'Hiçbir değişiklik yapılmadı', NULL),
(17691, 18, 'ASSIGNER_NO_REQUIRED_GROUPS', 'Non hai nessuno dei gruppi richiesti. Non è possibile utilizzare l\'assegnatore di gruppo.', NULL),
(17692, 18, 'DATE_FORMAT', 'd.m.Y', NULL),
(17693, 18, 'TIME_FORMAT', 'H:m', NULL),
(17694, 18, 'BANS_HEADER_TARGET', 'Ban', NULL),
(17695, 18, 'AUTHORS', 'alsoGAMER <nextgamer3152@gmail.com>', NULL),
(17696, 18, 'COOKIEALERT_MESSAGE', '<b>Ti piacciono i biscotti?</b> &#x1F36A; Noi usiamo i cookies per darti la migliore esperienza sul nostro sito. <a href=\"https://support.mozilla.org/it/kb/Gestione%20dei%20cookie#w_che-cosa-ae-un-cookie\" target=\"_blank\">Scopri di più</a>', NULL),
(17697, 18, 'COOKIEALERT_AGREE', 'Accetto', NULL),
(17698, 18, 'OUTDATED_DATA', '<b>Attenzione!</b> Alcune informazioni non possono essere ottenute ora. Ti sto mostrando dati non aggiornati da {0}.', NULL),
(17699, 18, 'SHOW_PROBLEMS', 'Mostra problemi', NULL),
(17700, 18, 'PROBLEMS_DESCRIPTION', 'Si sono riscontrati dei problemi durante la connessione al server TeamSpeak', NULL),
(17701, 18, 'NO_JAVASCRIPT_ENABLED', 'Questo sito non funzionerà senza <a href=\"https://www.enable-javascript.com/it/\" target=\"_blank\">JavaScript abilitato</a>', NULL),
(17702, 18, 'CANNOT_GET_DATA', 'Non riesco ad ottenere i dati per \"{0}\"! Perfavore contatta il proprietario del sito.', NULL),
(17703, 18, 'NO_REASON_SET', '<b>(nessun motivo impostato)</b>', NULL),
(17704, 18, 'BANS_HEADER_REASON', 'Motivo', NULL),
(17705, 18, 'BANS_HEADER_INVOKER', 'Bannato da', NULL),
(17706, 18, 'BANS_HEADER_BANDATE', 'Data del Ban', NULL),
(17707, 18, 'BANS_HEADER_EXPIRES', 'Scadenza Ban', NULL),
(17708, 18, 'DATATABLES_LANGUAGE_NAME', 'Italian', NULL),
(17709, 18, 'BANS_NEVEREXPIRES', 'Mai', NULL),
(17710, 18, 'STATUS_ADDRESS', 'Indirizzo:', NULL),
(17711, 18, 'STATUS_CLIENTS_ONLINE', 'Online:', NULL),
(17712, 18, 'STATUS_RESERVED_SLOTS', '{0} slot(s) riservati', NULL),
(17713, 18, 'STATUS_TOP_ONLINE', 'Top online:', NULL),
(17714, 18, 'STATUS_TOP_ONLINE_DESC', 'Ottenuto il {0}', NULL),
(17715, 18, 'STATUS_UPTIME', 'Uptime:', NULL),
(17716, 18, 'STATUS_VERSION', 'Versione:', NULL),
(17717, 18, 'STATUS_VERSION_DESC', '{0} su {1}', NULL),
(17718, 18, 'STATUS_PING', 'Ping medio:', NULL),
(17719, 18, 'STATUS_PACKETLOSS', 'Pacchetti persi medi:', NULL),
(17720, 18, 'STATUS_ERROR', 'Impossibile ottenere lo stato del server', NULL),
(17721, 18, 'STATUS_PANEL_TITLE', 'Stato del server', NULL),
(17722, 18, 'DAYJS_LANG', 'it', NULL),
(17723, 18, 'LOGIN_CONFIRMATION_CODE', 'Ciao, ecco il tuo codice di conferma per accedere: [b]{0}[/b]', NULL),
(17724, 18, 'UNSUPPORTED_BROWSER', 'Il tuo browser non è supportato. Passa alla versione più recente di Chrome, Firefox, Safari o Edge per utilizzare questo sito Web.', NULL),
(17725, 18, 'DATATABLES_PLACEHOLDER_SEARCH', 'Cerca...', NULL),
(17726, 18, 'WEBSITE_TITLE', ' | Lingua Italiana di TS-website', NULL),
(17727, 18, 'ADMIN_STATUS_ONLINE', 'Online', NULL),
(17728, 18, 'ADMIN_STATUS_AWAY', 'AFK', NULL),
(17729, 18, 'ADMIN_STATUS_OFFLINE', 'Offline', NULL),
(17730, 18, 'ADMIN_STATUS_EMPTY_GROUP', 'Nulla da mostrare', NULL),
(17731, 18, 'ADMIN_STATUS_EMPTY_STATUS', 'Lo stato di amministratore è vuoto', NULL),
(17732, 18, 'ASSIGNER_PANEL_TITLE', 'Assegna un Gruppo', NULL),
(17733, 18, 'ASSIGNER_TITLE', 'Assegna un Gruppo', NULL),
(17734, 18, 'BANS_EMPTY', 'La lista ban è vuota', NULL),
(17735, 18, 'BANS_TITLE', 'Lista ban', NULL),
(17736, 18, 'BANS_PANEL_TITLE', 'Lista ban', NULL),
(17737, 18, 'BANS_BANNED_ALERT_TITLE', 'Il tuo IP è stato bannato da {0}', NULL),
(17738, 18, 'BANS_BANNED_ALERT_REASON', 'Motivo: {0}', NULL),
(17739, 18, 'BANS_VIEW_MORE_TIP', 'Fai clic su una riga per visualizzare ulteriori dettagli sul Ban', NULL),
(17740, 18, 'RULES_TITLE', 'Regole', NULL),
(17741, 18, 'RULES_PANEL_TITLE', 'Regole', NULL),
(17742, 18, 'FAQ_COPY_LINK', 'Copia link a quella risposta', NULL),
(17743, 18, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(17744, 18, 'FAQ_TITLE', 'FAQ', NULL),
(17745, 18, 'FAQ_COPY_LINK_SUCCESS', 'Copiato!', NULL),
(17746, 18, 'FAQ_COPY_LINK_ERROR', 'Errore!', NULL),
(17747, 18, 'HOME_TITLE', 'Notizie', NULL),
(17748, 18, 'HOME_PANEL_TITLE', 'Notizie', NULL),
(17749, 18, 'HOME_EMPTY', 'Nessuna notizia disponibile in questo momento', NULL),
(17750, 18, 'HOME_INVALID_PAGE', 'Numero di pagina non valido', NULL),
(17751, 18, 'HOME_PREVIOUS_NEWS', 'Precedente', NULL),
(17752, 18, 'HOME_NEXT_NEWS', 'Successivo', NULL),
(17753, 18, 'ADMIN_STATUS_PANEL_TITLE', 'Stato amministratore', NULL),
(17754, 18, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Nascondi amministratori offline', NULL),
(17755, 18, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Mostra amministratori offline', NULL),
(17756, 18, 'ADMIN_STATUS_ERROR', 'Errore di stato dell\'amministratore', NULL),
(17757, 18, 'NAV_TOGGLE', 'Attiva / disattiva la navigazione', NULL),
(17758, 18, 'NAV_VIEWER', 'Spettatore', NULL),
(17759, 18, 'NAV_ASSIGNER', 'Assegnatore', NULL),
(17760, 18, 'NAV_BANS', 'Ban', NULL),
(17761, 18, 'NAV_RULES', 'Regole', NULL),
(17762, 18, 'NAV_FAQ', 'FAQ', NULL),
(17763, 18, 'NAV_ACCOUNT_LOGIN', 'Accesso', NULL),
(17764, 18, 'NAV_ACCOUNT_LOGOUT', 'Esci', NULL),
(17765, 18, 'VIEWER_TITLE', 'Visualizzatore server', NULL),
(17766, 18, 'VIEWER_PANEL_TITLE', 'Visualizzatore server', NULL),
(17767, 18, 'VIEWER_SHOW_EMPTY', 'Mostra canali vuoti', NULL),
(17768, 18, 'VIEWER_HIDE_EMPTY', 'Nascondi canali vuoti', NULL),
(17769, 18, 'VIEWER_TIP_ALERT', 'Clicca su un canale per entrarci. Passa con il mouse sopra un utente per guardare le sue info', NULL),
(17770, 18, 'ARIA_CLOSE', 'Vicino', NULL),
(17771, 18, 'VIEWER_ERROR', 'Errore del visualizzatore', NULL),
(17772, 18, 'VIEWER_CONNECTION_CONFIRMATION', 'Vuoi connetterti a questo canale?', NULL),
(17773, 18, 'VIEWER_CLIENT_LASTACTIVE', 'Ultima attività:', NULL),
(17774, 18, 'VIEWER_CLIENT_ONLINE', 'Tempo online:', NULL),
(17775, 18, 'VIEWER_CLIENT_JOINED', 'Primo iscritto:', NULL),
(17776, 18, 'VIEWER_CLIENT_TITLE', 'Informazioni utente', NULL),
(17777, 18, 'VIEWER_SERVER_ICON', 'Icona del server', NULL),
(17778, 18, 'VIEWER_DEFAULT_CHANNEL', 'Canale di default', NULL),
(17779, 18, 'VIEWER_CHANNEL_UNSUB1', ', non iscritto', NULL),
(17780, 18, 'VIEWER_CHANNEL_OCCUPIED', 'Pieno', NULL),
(17781, 18, 'VIEWER_CHANNEL_PASSWORD', 'Protetto da password', NULL),
(17782, 18, 'VIEWER_CHANNEL_UNSUB2', 'Non iscritto', NULL),
(17783, 18, 'VIEWER_CHANNEL_ICON', 'Icona del canale', NULL),
(17784, 18, 'VIEWER_CHANNEL_MODERATED', 'Moderato', NULL),
(17785, 18, 'VIEWER_CHANNEL_MUSIC_CODED', 'Codec musica', NULL),
(17786, 18, 'VIEWER_CLIENT_AWAY', 'AFK', NULL),
(17787, 18, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Audio disattivato', NULL),
(17788, 18, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Mutato', NULL),
(17789, 18, 'VIEWER_CLIENT_MIC_DISABLED', 'Microfono disattivato', NULL),
(17790, 18, 'VIEWER_CLIENT_MIC_MUTED', 'Mutato', NULL),
(17791, 18, 'VIEWER_CLIENT_COMMANDER', 'Comandante canale', NULL),
(17792, 18, 'VIEWER_CLIENT_ICON', 'Icona utente', NULL),
(17793, 18, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Speaker prioritario', NULL),
(17794, 18, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Permesso di parola concesso', NULL),
(17795, 18, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Permesso di parola insufficiente', NULL),
(17796, 18, 'ASSIGNER_NOT_LOGGED_IN', 'Effettua l\'accesso prima di usare l\'assegnatore gruppi', NULL),
(17797, 18, 'ASSIGNER_LOGIN_BUTTON', 'Accesso', NULL),
(17798, 18, 'ASSIGNER_SAVE_BUTTON', 'Salva', NULL),
(17799, 18, 'ASSIGNER_INVALID_GROUPS', 'Impostazioni gruppo invalide', NULL),
(17800, 18, 'ASSIGNER_NOT_CONFIGURED', 'L\'assegnatore gruppi non è stato configurato dall\'amministratore del sito', NULL),
(17801, 18, 'ASSIGNER_SAVE_SUCCESS', 'I tuoi gruppi sono stati modificati', NULL),
(17802, 18, 'ASSIGNER_SAVE_ERROR', 'Errore durante il cambio del gruppo', NULL),
(17803, 18, 'ASSIGNER_SAVE_NO_CHANGE', 'Nessuna modifica effettuata', NULL),
(17804, 19, 'DATE_FORMAT', 'd.m.Y', NULL),
(17805, 19, 'TIME_FORMAT', 'H:i', NULL),
(17806, 19, 'BANS_HEADER_TARGET', 'Бан', NULL),
(17807, 19, 'AUTHORS', 'fyfywka <fyfywka@gmail.com>', NULL),
(17808, 19, 'COOKIEALERT_MESSAGE', '<b>Вам подобаються куки?</b>&#x1F36A; Ми використовуємо куки, щоб забезпечити найкращий досвід на нашому вебсайті. <a href=\"https://support.mozilla.org/ru/kb/kuki-informaciya-kotoruyu-veb-sajty-hranyat-na-vas\" target=\"_blank\">Дізнатися більше</a>', NULL),
(17809, 19, 'COOKIEALERT_AGREE', 'Я згоден', NULL),
(17810, 19, 'OUTDATED_DATA', '<b>Увага!</b> Не вдалося отримати актуальну інформацію з сервера. Відображається інформація {0}', NULL),
(17811, 19, 'SHOW_PROBLEMS', 'Показати проблеми', NULL),
(17812, 19, 'PROBLEMS_DESCRIPTION', 'Під час підключення до сервера TeamSpeak сталася помилка', NULL),
(17813, 19, 'NO_JAVASCRIPT_ENABLED', 'Даний сайт не буде працювати при відключеному <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript</a>', NULL),
(17814, 19, 'CANNOT_GET_DATA', 'Не вдалося отримати дані для модуля \"{0}\"! Будь ласка, зв\'яжіться з власником сайту.', NULL),
(17815, 19, 'NO_REASON_SET', '<b>(причина не вказана)</b>', NULL),
(17816, 19, 'BANS_HEADER_REASON', 'Причина', NULL),
(17817, 19, 'BANS_HEADER_INVOKER', 'Забанив', NULL),
(17818, 19, 'BANS_HEADER_BANDATE', 'Бан створений', NULL),
(17819, 19, 'BANS_HEADER_EXPIRES', 'Закінчується', NULL),
(17820, 19, 'DATATABLES_LANGUAGE_NAME', 'Ukrainian', NULL),
(17821, 19, 'BANS_NEVEREXPIRES', 'Ніколи', NULL),
(17822, 19, 'STATUS_ADDRESS', 'Адрес:', NULL),
(17823, 19, 'STATUS_CLIENTS_ONLINE', 'Онлайн:', NULL),
(17824, 19, 'STATUS_RESERVED_SLOTS', '{0} зарезервовано', NULL),
(17825, 19, 'STATUS_TOP_ONLINE', 'Макс. онлайн:', NULL),
(17826, 19, 'STATUS_TOP_ONLINE_DESC', 'Досягнуто {0}', NULL),
(17827, 19, 'STATUS_UPTIME', 'Аптайм:', NULL),
(17828, 19, 'STATUS_VERSION', 'Версія:', NULL),
(17829, 19, 'STATUS_VERSION_DESC', '{0} на {1}', NULL),
(17830, 19, 'STATUS_PING', 'Середн. пінг:', NULL),
(17831, 19, 'STATUS_PACKETLOSS', 'Втрати пакетів:', NULL),
(17832, 19, 'STATUS_ERROR', 'Неможливо отримати статус сервера', NULL),
(17833, 19, 'STATUS_PANEL_TITLE', 'Статус сервера', NULL),
(17834, 19, 'DAYJS_LANG', 'uk', NULL),
(17835, 19, 'LOGIN_CONFIRMATION_CODE', 'Привіт! Ваш код підтвердження для авторизації: [b]{0}[/b]', NULL),
(17836, 19, 'UNSUPPORTED_BROWSER', 'Ваш браузер не підтримується. Будь ласка, встановіть Chrome, Firefox, Safari або Edge.', NULL),
(17837, 19, 'DATATABLES_PLACEHOLDER_SEARCH', 'Пошук...', NULL),
(17838, 19, 'WEBSITE_TITLE', ' | Українська мова TS-website', NULL),
(17839, 19, 'ADMIN_STATUS_ONLINE', 'Онлайн', NULL),
(17840, 19, 'ADMIN_STATUS_AWAY', 'Відійшов', NULL),
(17841, 19, 'ADMIN_STATUS_OFFLINE', 'Оффлайн', NULL),
(17842, 19, 'ADMIN_STATUS_EMPTY_GROUP', 'Нічого показувати', NULL),
(17843, 19, 'ADMIN_STATUS_EMPTY_STATUS', 'Статус адміністратора відсутній', NULL),
(17844, 19, 'ASSIGNER_PANEL_TITLE', 'Групи', NULL),
(17845, 19, 'ASSIGNER_TITLE', 'Менеджер груп', NULL),
(17846, 19, 'BANS_EMPTY', 'Список банів порожній', NULL),
(17847, 19, 'BANS_TITLE', 'Бани', NULL),
(17848, 19, 'BANS_PANEL_TITLE', 'Бани', NULL),
(17849, 19, 'BANS_BANNED_ALERT_TITLE', 'Ваш IP забанений адміністратором {0}', NULL),
(17850, 19, 'BANS_BANNED_ALERT_REASON', 'Причина: {0}', NULL),
(17851, 19, 'BANS_VIEW_MORE_TIP', 'Натисніть на рядок для відображення деталей про баню', NULL),
(17852, 19, 'RULES_TITLE', 'Правила', NULL),
(17853, 19, 'RULES_PANEL_TITLE', 'Правила', NULL),
(17854, 19, 'FAQ_COPY_LINK', 'Скопіювати посилання на цю відповідь', NULL),
(17855, 19, 'FAQ_PANEL_TITLE', 'FAQ', NULL),
(17856, 19, 'FAQ_TITLE', 'FAQ', NULL),
(17857, 19, 'FAQ_COPY_LINK_SUCCESS', 'Скопійовано!', NULL),
(17858, 19, 'FAQ_COPY_LINK_ERROR', 'Помилка!', NULL),
(17859, 19, 'HOME_TITLE', 'Новини', NULL),
(17860, 19, 'HOME_PANEL_TITLE', 'Новини', NULL),
(17861, 19, 'HOME_EMPTY', 'На даний момент немає новин', NULL),
(17862, 19, 'HOME_INVALID_PAGE', 'Неправильний номер сторінки', NULL),
(17863, 19, 'HOME_PREVIOUS_NEWS', 'Назад', NULL),
(17864, 19, 'HOME_NEXT_NEWS', 'Уперед', NULL),
(17865, 19, 'ADMIN_STATUS_PANEL_TITLE', 'Статус адміністрації', NULL),
(17866, 19, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', 'Приховати відключених адміністраторів', NULL),
(17867, 19, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', 'Показати відключених адміністраторів', NULL),
(17868, 19, 'ADMIN_STATUS_ERROR', 'Помилка статусу адміністратора', NULL),
(17869, 19, 'NAV_TOGGLE', 'Переключити навігацію', NULL),
(17870, 19, 'NAV_VIEWER', 'Огляд', NULL),
(17871, 19, 'NAV_ASSIGNER', 'Групи', NULL),
(17872, 19, 'NAV_BANS', 'Список банів', NULL),
(17873, 19, 'NAV_RULES', 'Правила', NULL),
(17874, 19, 'NAV_FAQ', 'FAQ', NULL),
(17875, 19, 'NAV_ACCOUNT_LOGIN', 'Увійти', NULL),
(17876, 19, 'NAV_ACCOUNT_LOGOUT', 'Вийти', NULL),
(17877, 19, 'VIEWER_TITLE', 'Огляд сервера', NULL),
(17878, 19, 'VIEWER_PANEL_TITLE', 'Огляд сервера', NULL),
(17879, 19, 'VIEWER_SHOW_EMPTY', 'Показати порожні канали', NULL),
(17880, 19, 'VIEWER_HIDE_EMPTY', 'Приховати порожні канали', NULL),
(17881, 19, 'VIEWER_TIP_ALERT', 'Для входу в канал натисніть на нього. Наведіть курсор над користувачем для відображення інформації', NULL),
(17882, 19, 'ARIA_CLOSE', 'Закрити', NULL),
(17883, 19, 'VIEWER_ERROR', 'Помилка при огляді сервера', NULL),
(17884, 19, 'VIEWER_CONNECTION_CONFIRMATION', 'Ви хочете увійти в цей канал?', NULL),
(17885, 19, 'VIEWER_CLIENT_LASTACTIVE', 'Був активний:', NULL),
(17886, 19, 'VIEWER_CLIENT_ONLINE', 'Час онлайн:', NULL),
(17887, 19, 'VIEWER_CLIENT_JOINED', 'Перше підключення:', NULL),
(17888, 19, 'VIEWER_CLIENT_TITLE', 'Інформація про клієнта', NULL),
(17889, 19, 'VIEWER_SERVER_ICON', 'Іконка сервера', NULL),
(17890, 19, 'VIEWER_DEFAULT_CHANNEL', 'Стандартний канал', NULL),
(17891, 19, 'VIEWER_CHANNEL_UNSUB1', ', не підписаний', NULL),
(17892, 19, 'VIEWER_CHANNEL_OCCUPIED', 'Заповнений', NULL),
(17893, 19, 'VIEWER_CHANNEL_PASSWORD', 'Захищений паролем', NULL),
(17894, 19, 'VIEWER_CHANNEL_UNSUB2', 'Не підписаний', NULL),
(17895, 19, 'VIEWER_CHANNEL_ICON', 'Іконка каналу', NULL),
(17896, 19, 'VIEWER_CHANNEL_MODERATED', 'Модерований', NULL),
(17897, 19, 'VIEWER_CHANNEL_MUSIC_CODED', 'Opus для музики', NULL),
(17898, 19, 'VIEWER_CLIENT_AWAY', 'Відійшов', NULL),
(17899, 19, 'VIEWER_CLIENT_OUTPUT_DISABLED', 'Звук відключений', NULL),
(17900, 19, 'VIEWER_CLIENT_OUTPUT_MUTED', 'Приглушений', NULL),
(17901, 19, 'VIEWER_CLIENT_MIC_DISABLED', 'Мікрофон відключений', NULL),
(17902, 19, 'VIEWER_CLIENT_MIC_MUTED', 'Заглушений', NULL),
(17903, 19, 'VIEWER_CLIENT_COMMANDER', 'Командир каналу', NULL),
(17904, 19, 'VIEWER_CLIENT_ICON', 'Іконка клієнта', NULL),
(17905, 19, 'VIEWER_CLIENT_PRIORITY_SPEAKER', 'Пріоритет голосу', NULL),
(17906, 19, 'VIEWER_CLIENT_TALK_POWER_GRANTED', 'Право голосу отримано', NULL),
(17907, 19, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', 'Недостатньо прав голосу', NULL),
(17908, 19, 'ASSIGNER_NOT_LOGGED_IN', 'Авторизуйтесь перед використанням менеджера груп', NULL),
(17909, 19, 'ASSIGNER_LOGIN_BUTTON', 'Увійти', NULL),
(17910, 19, 'ASSIGNER_SAVE_BUTTON', 'Зберегти', NULL),
(17911, 19, 'ASSIGNER_INVALID_GROUPS', 'Невірні налаштування груп', NULL),
(17912, 19, 'ASSIGNER_NOT_CONFIGURED', 'Менеджер груп не був налаштований адміністратором сайту', NULL),
(17913, 19, 'ASSIGNER_SAVE_SUCCESS', 'Ваші групи були оновлені', NULL),
(17914, 19, 'ASSIGNER_SAVE_ERROR', 'Помилка при зміні групи', NULL),
(17915, 19, 'ASSIGNER_SAVE_NO_CHANGE', 'Зміни не були збережені', NULL),
(17916, 20, 'ASSIGNER_NO_REQUIRED_GROUPS', '目前没有已分配组，您无法使用组分配器！', NULL),
(17917, 20, 'DATE_FORMAT', 'd.m.Y', NULL),
(17918, 20, 'TIME_FORMAT', 'H:i', NULL),
(17919, 20, 'BANS_HEADER_TARGET', '封禁', NULL),
(17920, 20, 'AUTHORS', 'ZeusGamingPlay<zeusgamingplay@126.com>', NULL),
(17921, 20, 'COOKIEALERT_MESSAGE', '<b>不想反复重新登录吗？</b> &#x1F36A; 我们使用Cookies 来改善本站的用户体验！ <a href=\"https://support.mozilla.org/en-US/kb/cookies-information-websites-store-on-your-computer\" target=\"_blank\">了解更多</a>', NULL),
(17922, 20, 'COOKIEALERT_AGREE', '我同意', NULL),
(17923, 20, 'OUTDATED_DATA', '<b>警告！</b> 本页面部分功能当前可能无法正常运作，部分信息可能并非实时更新，该部分数据来自 {0}.', NULL),
(17924, 20, 'SHOW_PROBLEMS', '显示问题', NULL),
(17925, 20, 'PROBLEMS_DESCRIPTION', '在连接到 Teamspeak 服务器时遭遇问题', NULL),
(17926, 20, 'NO_JAVASCRIPT_ENABLED', '此网站无法在脱离 <a href=\"https://www.enable-javascript.com/\" target=\"_blank\">JavaScript </a>的情况下使用.', NULL),
(17927, 20, 'CANNOT_GET_DATA', '无法获取 \"{0}\"的数据! 请向网站管理员反馈这个问题.', NULL),
(17928, 20, 'NO_REASON_SET', '<b>返回内容为空</b>', NULL),
(17929, 20, 'BANS_HEADER_REASON', '原因', NULL),
(17930, 20, 'BANS_HEADER_INVOKER', '由该管理员封禁', NULL),
(17931, 20, 'BANS_HEADER_BANDATE', '封禁日期', NULL),
(17932, 20, 'BANS_HEADER_EXPIRES', '起迄日期', NULL),
(17933, 20, 'DATATABLES_LANGUAGE_NAME', 'Chinese', NULL),
(17934, 20, 'BANS_NEVEREXPIRES', '从不', NULL),
(17935, 20, 'STATUS_ADDRESS', '地址:', NULL),
(17936, 20, 'STATUS_CLIENTS_ONLINE', '在线:', NULL),
(17937, 20, 'STATUS_RESERVED_SLOTS', '{0} 保留位', NULL),
(17938, 20, 'STATUS_TOP_ONLINE', '最常在线:', NULL),
(17939, 20, 'STATUS_TOP_ONLINE_DESC', '收录于 {0}', NULL),
(17940, 20, 'STATUS_UPTIME', '在线时长:', NULL),
(17941, 20, 'STATUS_VERSION', '版本:', NULL),
(17942, 20, 'STATUS_VERSION_DESC', '{0} on {1}', NULL),
(17943, 20, 'STATUS_PING', '平均延迟:', NULL),
(17944, 20, 'STATUS_PACKETLOSS', '平均丢包率:', NULL),
(17945, 20, 'STATUS_ERROR', '无法取得服务器状态', NULL),
(17946, 20, 'STATUS_PANEL_TITLE', '服务器状态', NULL),
(17947, 20, 'DAYJS_LANG', 'zh-cn', NULL),
(17948, 20, 'LOGIN_CONFIRMATION_CODE', '您好，请查收您的登录验证码: [b]{0}[/b]', NULL),
(17949, 20, 'UNSUPPORTED_BROWSER', '您当前使用的浏览器不受支持!请使用最新版本的谷歌,火狐,Safari或Edge浏览器进行访问!', NULL),
(17950, 20, 'DATATABLES_PLACEHOLDER_SEARCH', '搜索...', NULL),
(17951, 20, 'WEBSITE_TITLE', ' | TS-website 简体中文', NULL),
(17952, 20, 'ADMIN_STATUS_ONLINE', '在线', NULL),
(17953, 20, 'ADMIN_STATUS_AWAY', '不在电脑边', NULL),
(17954, 20, 'ADMIN_STATUS_OFFLINE', '离线', NULL),
(17955, 20, 'ADMIN_STATUS_EMPTY_GROUP', '无更多信息', NULL),
(17956, 20, 'ADMIN_STATUS_EMPTY_STATUS', '管理员状态为空', NULL),
(17957, 20, 'ASSIGNER_PANEL_TITLE', '组分配器', NULL),
(17958, 20, 'ASSIGNER_TITLE', '组分配器', NULL),
(17959, 20, 'BANS_EMPTY', '黑名单为空', NULL),
(17960, 20, 'BANS_TITLE', '黑名单', NULL),
(17961, 20, 'BANS_PANEL_TITLE', '黑名单', NULL),
(17962, 20, 'BANS_BANNED_ALERT_TITLE', '您的IP已被 {0} 封禁', NULL),
(17963, 20, 'BANS_BANNED_ALERT_REASON', '原因: {0}', NULL),
(17964, 20, 'BANS_VIEW_MORE_TIP', '点击某一行来显示某次封禁的详细信息', NULL),
(17965, 20, 'RULES_TITLE', '规则', NULL),
(17966, 20, 'RULES_PANEL_TITLE', '规则', NULL),
(17967, 20, 'FAQ_COPY_LINK', '将链接复制到该回复', NULL),
(17968, 20, 'FAQ_PANEL_TITLE', '常见问题', NULL),
(17969, 20, 'FAQ_TITLE', '常见问题', NULL),
(17970, 20, 'FAQ_COPY_LINK_SUCCESS', '已复制到剪贴板!', NULL),
(17971, 20, 'FAQ_COPY_LINK_ERROR', '错误!', NULL),
(17972, 20, 'HOME_TITLE', '最新资讯', NULL),
(17973, 20, 'HOME_PANEL_TITLE', '最新资讯', NULL),
(17974, 20, 'HOME_EMPTY', '当前没有最新资讯', NULL),
(17975, 20, 'HOME_INVALID_PAGE', '无效的页数', NULL),
(17976, 20, 'HOME_PREVIOUS_NEWS', '上一页', NULL),
(17977, 20, 'HOME_NEXT_NEWS', '下一页', NULL),
(17978, 20, 'ADMIN_STATUS_PANEL_TITLE', '管理员状态', NULL),
(17979, 20, 'ADMIN_STATUS_HIDE_OFFLINE_TIP', '隐藏离线管理员', NULL),
(17980, 20, 'ADMIN_STATUS_SHOW_OFFLINE_TIP', '显示离线管理员', NULL),
(17981, 20, 'ADMIN_STATUS_ERROR', '管理员状态错误', NULL),
(17982, 20, 'NAV_TOGGLE', '展开导航', NULL),
(17983, 20, 'NAV_VIEWER', '检索器', NULL),
(17984, 20, 'NAV_ASSIGNER', '分配器', NULL),
(17985, 20, 'NAV_BANS', '封禁', NULL),
(17986, 20, 'NAV_RULES', '规则', NULL),
(17987, 20, 'NAV_FAQ', '常见问题', NULL),
(17988, 20, 'NAV_ACCOUNT_LOGIN', '登录', NULL),
(17989, 20, 'NAV_ACCOUNT_LOGOUT', '登出', NULL),
(17990, 20, 'VIEWER_TITLE', '服务器检索器', NULL),
(17991, 20, 'VIEWER_PANEL_TITLE', '服务器检索器', NULL),
(17992, 20, 'VIEWER_SHOW_EMPTY', '显示无人频道', NULL),
(17993, 20, 'VIEWER_HIDE_EMPTY', '隐藏无人频道', NULL),
(17994, 20, 'VIEWER_TIP_ALERT', '点击某个频道加入,将光标停留在某用户上来显示该用户概要', NULL),
(17995, 20, 'ARIA_CLOSE', '关闭', NULL),
(17996, 20, 'VIEWER_ERROR', '检索器错误', NULL),
(17997, 20, 'VIEWER_CONNECTION_CONFIRMATION', '你想要连接到这个频道吗?', NULL),
(17998, 20, 'VIEWER_CLIENT_LASTACTIVE', '最后活跃时间:', NULL),
(17999, 20, 'VIEWER_CLIENT_ONLINE', '在线时长:', NULL),
(18000, 20, 'VIEWER_CLIENT_JOINED', '首次加入时间:', NULL),
(18001, 20, 'VIEWER_CLIENT_TITLE', '用户信息:', NULL),
(18002, 20, 'VIEWER_SERVER_ICON', '服务器图标', NULL),
(18003, 20, 'VIEWER_DEFAULT_CHANNEL', '默认频道', NULL),
(18004, 20, 'VIEWER_CHANNEL_UNSUB1', ', 已取消订阅', NULL),
(18005, 20, 'VIEWER_CHANNEL_OCCUPIED', '满员', NULL),
(18006, 20, 'VIEWER_CHANNEL_PASSWORD', '密码验证', NULL),
(18007, 20, 'VIEWER_CHANNEL_UNSUB2', '取消订阅', NULL),
(18008, 20, 'VIEWER_CHANNEL_ICON', '频道图标', NULL),
(18009, 20, 'VIEWER_CHANNEL_MODERATED', '主席模式', NULL),
(18010, 20, 'VIEWER_CHANNEL_MUSIC_CODED', '音乐编码', NULL),
(18011, 20, 'VIEWER_CLIENT_AWAY', '不在电脑边', NULL),
(18012, 20, 'VIEWER_CLIENT_OUTPUT_DISABLED', '关闭声音', NULL),
(18013, 20, 'VIEWER_CLIENT_OUTPUT_MUTED', '静音模式', NULL),
(18014, 20, 'VIEWER_CLIENT_MIC_DISABLED', '麦克风已禁用', NULL),
(18015, 20, 'VIEWER_CLIENT_MIC_MUTED', '已静音', NULL),
(18016, 20, 'VIEWER_CLIENT_COMMANDER', '频道管理员', NULL),
(18017, 20, 'VIEWER_CLIENT_ICON', '客户图标', NULL),
(18018, 20, 'VIEWER_CLIENT_PRIORITY_SPEAKER', '高优先级发言者', NULL),
(18019, 20, 'VIEWER_CLIENT_TALK_POWER_GRANTED', '已赋予发言权', NULL),
(18020, 20, 'VIEWER_CLIENT_TALK_POWER_INSUFFICIENT', '权限不足,无法发言', NULL),
(18021, 20, 'ASSIGNER_NOT_LOGGED_IN', '登录以使用组检索器', NULL),
(18022, 20, 'ASSIGNER_LOGIN_BUTTON', '登录', NULL),
(18023, 20, 'ASSIGNER_SAVE_BUTTON', '保存', NULL),
(18024, 20, 'ASSIGNER_INVALID_GROUPS', '无效的组设置', NULL),
(18025, 20, 'ASSIGNER_NOT_CONFIGURED', '组检索器尚未被网站管理员配置,故当前不可用', NULL),
(18026, 20, 'ASSIGNER_SAVE_SUCCESS', '您的组已被更新', NULL),
(18027, 20, 'ASSIGNER_SAVE_ERROR', '组变更过程中产生错误', NULL),
(18028, 20, 'ASSIGNER_SAVE_NO_CHANGE', '没有进行改动，维持原设定。', NULL);


ALTER TABLE `DBPREFIXlanguages`
  ADD PRIMARY KEY (`langid`);

ALTER TABLE `DBPREFIXtranslations`
  ADD PRIMARY KEY (`id`);


ALTER TABLE `DBPREFIXlanguages`
  MODIFY `langid` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=21;

ALTER TABLE `DBPREFIXtranslations`
  MODIFY `id` int(10) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=18029;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
